<?php
/* SVN FILE: $Id: app_model.php 4409 2007-02-02 13:20:59Z phpnut $ */
/**
 * Application model for Cake.
 *
 * This file is application-wide model file. You can put all
 * application-wide model-related methods here.
 *
 * PHP versions 4 and 5
 *
 * CakePHP(tm) :  Rapid Development Framework <http://www.cakephp.org/>
 * Copyright 2005-2007, Cake Software Foundation, Inc.
 *								1785 E. Sahara Avenue, Suite 490-204
 *								Las Vegas, Nevada 89104
 *
 * Licensed under The MIT License
 * Redistributions of files must retain the above copyright notice.
 *
 * @filesource
 * @copyright		Copyright 2005-2007, Cake Software Foundation, Inc.
 * @link				http://www.cakefoundation.org/projects/info/cakephp CakePHP(tm) Project
 * @package			cake
 * @subpackage		cake.cake
 * @since			CakePHP(tm) v 0.2.9
 * @version			$Revision: 4409 $
 * @modifiedby		$LastChangedBy: phpnut $
 * @lastmodified	$Date: 2007-02-02 07:20:59 -0600 (Fri, 02 Feb 2007) $
 * @license			http://www.opensource.org/licenses/mit-license.php The MIT License
 */
/**
 * Application model for Cake.
 *
 * This is a placeholder class.
 * Create the same file in app/app_model.php
 * Add your application-wide methods to the class, your models will inherit them.
 *
 * @package		cake
 * @subpackage	cake.cake
 */
// * @lastmodified	$Date:xinw 2008-10-17 modify for LV20R1-178
class AppModel extends Model{
	function queryLV($sql)
	{
		$sql = $this->replaceMySQL($sql);
		$data = $this->query($sql);
		return $data;
	}
	function replaceMySQL($sql)
	{//echo mb_detect_encoding($sql);
	//$sql = mb_ereg_replace("\\\\","\\\\",$sql);
		$sql = mb_ereg_replace("TIMEPART\(","TIME(",$sql, 'i');
		$sql = mb_ereg_replace("DATEPART\(","DATE(",$sql, 'i');
		$sql = mb_ereg_replace("\sAS\sGroup\s"," AS `Group` ",$sql);
		$sql = mb_ereg_replace("DAYS_BETWEEN\(([^,]+),([\S]+)\)","DATEDIFF(\\1,\\2)",$sql);
		$sql = mb_ereg_replace("secs_between\(([^,]+),([\S]+)\)","TIME_TO_SEC(TIMEDIFF(\\1,\\2))",$sql);
	
		$pattern = "/(?:(?:lower\(|)(Astsfw.software_name|Astsfw.maker|Astsfw.version)(?:\)|))\s*(=|like)\s*'(([^'\\\\]|\\\\\\\\|\\'\\')+)'\s*/u";
		if(preg_match_all($pattern, $sql, $match)){
			//debug($match);
			$count = count($match[0]);
			for($i = 0; $i < $count; $i++)
			{
				$str = str_replace(array("''","\\\\"), array("'","\\"), $match[3][$i]);
				$replace = $match[1][$i]." ".$match[2][$i]." 0x".bin2hex($str)." ";
				$sql = str_replace($match[0][$i], $replace, $sql);
			}
		}
		
		return $sql;
	}
	/**
	 * Associations
	 *
	 */
	function findByAsso($conditions1 = null, $fields = null, $order = null, $limit = null, $page = 1, $asso = null)
	{
		
		$sql = $this->generateSqlWithAsso($conditions1, $fields, $order, $limit, $page, $asso);
//		debug($sql, true);
		$data = $this->query($sql);
		return $data;
	}
	
	function generateSqlWithAsso($conditions1 = null, $fields = null, $order = null, $limit = null, $page = 1, $asso = null)
	{
		if($page < 1){
			$page = 1;
		}
		
		$sql = "SELECT ";
		$conditions = $conditions1;
		$fields_ = array();
		foreach($fields as $v){
			if(false === strpos($v, ' as ') && false === strpos($v, ' AS ') ){
				$fields_[] .= "`" . str_replace(array(' ','.'), array('','`.`'), $v)  . "` AS `" . str_replace(array(' ','.','`'), array('','__',''), $v) . "`";
			}
			else {
				$fields_[] .= $v;
			}
		}
		$sql .= implode(', ', $fields_);
		
		$sql .= " FROM `$this->useTable` AS `$this->name` ";
		
		//associations
		$sql .= $this->_generateAsso($asso);
		
		//group by 
		$conditions = array_change_key_case($conditions, CASE_UPPER);
		if(isset($conditions['GROUP BY'])){
			$groupby  = "GROUP BY " . $conditions['GROUP BY'] . " ";
			unset($conditions['GROUP BY']);
		}
		$sql .= "WHERE " . implode(' AND ', $conditions) . " ";
		
		isset($groupby) ?  $sql .= $groupby : NULL ;
		
		//order by
		if( !is_null($order) ){
			if(false === strpos(strtoupper($order), 'ASC') && false === strpos(strtoupper($order), 'DESC')){
				$sql .= " ORDER BY $order ASC ";
			}
			else {
				$sql .= " ORDER BY $order ";
			}
		}
		
		//limit
		if(!is_null($limit)){
			if(false === strpos(strtoupper($limit), 'LIMIT')){
				$sql .= "LIMIT " . (($page-1)*$limit) . ", $limit ";
			}
			else {
				$sql .= "$limit  ";
			}
		}
		return $this->replaceMySQL($sql);
	}
	
	function getLastInsertID()
	{
		$data = $this->find(null, "MAX({$this->name}.id) AS id", null, 0);
		$lastInsertId = $data[0]['id'];
		return $lastInsertId;
	}
	
//	function deleteAll($conditions, $asso = NULL)
	function deleteAll($conditions)
	{
//		$sql = "DELETE FROM $this->useTable AS $this->name " . $this->_generateAsso($asso) . " WHERE " . implode(' AND ', $conditions) . " ";
//		$sql = "DELETE FROM $this->useTable AS $this->name WHERE " . implode(' AND ', $conditions) . " ";
		$sql = "DELETE FROM $this->useTable WHERE " . implode(' AND ', $conditions) . " ";
		$result = $this->queryLV($sql);
		return $result;
	}
	
	function deleteAllByParentId($groupId)
	{
		//$sql = "DELETE FROM $this->useTable AS $this->name WHERE $this->name.group_id IN ( SELECT G.group_id FROM grpauths AS G WHERE G.org_grp_id = " . $groupId . ")";//で全部上位グループ
		$sql = "DELETE FROM $this->useTable WHERE $this->useTable.group_id IN ( SELECT G.group_id FROM grpauths AS G WHERE G.org_grp_id = " . $groupId . ")";//で全部上位グループ

		$result = $this->query($sql);
		return $result;
	}
	
	function deleteAllByGroupId($groupId)
	{
		$sql = "DELETE FROM $this->useTable WHERE $this->useTable.group_id  = " . $groupId . "";/////でグループだけ

		$result = $this->query($sql);
		return $result;
	}
	
	function deleteHstaltByParentId($groupId)
	{
		$sql = "DELETE FROM {$this->useTable} WHERE {$this->useTable}.host_id IN (
							SELECT Rlthstgrp.host_id FROM rlthstgrps AS Rlthstgrp 
								INNER JOIN grpauths AS Grpauth ON Grpauth.group_id = Rlthstgrp.group_id 
								WHERE Grpauth.org_grp_id = " . $groupId . "
							) ";//で全部上位グループ

		
		return $result;
	}
	
	function deleteHstaltByGroupId($groupId)
	{
		$host_ids = "";
		$subsql = "SELECT Rlthstgrp.host_id FROM rlthstgrps AS Rlthstgrp WHERE Rlthstgrp.group_id = " . $groupId;
		$ids = $this->query($subsql);
		//debug($ids);
		foreach($ids as $id){
			$sql = "DELETE FROM {$this->useTable} WHERE {$this->useTable}.host_id =". $id;/////でグループだけ

			$result = $this->query($sql);
		}
		

		return $result;
	}
	
	function updateAll($conditions, $values)
	{
		$toset = array();
		foreach($values as $k => $v){
			$toset[] = "$k = $v";
		}
//		$sql = "DELETE FROM $this->useTable AS $this->name " . $this->_generateAsso($asso) . " WHERE " . implode(' AND ', $conditions) . " ";
		$sql = "UPDATE $this->useTable AS $this->name SET " . implode(", ", $toset) . " WHERE " . implode(' AND ', $conditions);
		$result = $this->query($sql);
		return $result;
	}
	
	/**
	 * 上位グループの設定情報を継承
	 *
	 * @param unknown_type $groupId
	 * def table : id, group_id, alert_id<service_id ...など>, org_grp_id
	 * @param unknown_type $children
	 * @return unknown
	 */
	function inheritAlertByParentId($groupId, $children )
	{
		$data = $this->findAll(array("{$this->name}.group_id = " . $groupId), null, null, null, null, -1);
		if(!empty($data)){
			foreach($data as $v){
				$v[$this->name] = array_values($v[$this->name]);
				foreach($children as $vl){
					$result = $this->save(array('group_id' => $vl, 
										$this->_tableInfo->value[2]['name'] => $v[$this->name][2], //alert_id		//add by wzy at 20071121 for 機能拡張rltgrpsvcs/rltgrpprocs
										'org_grp_id' => $v[$this->name][3])); //org_grp_id
					if(!$result){
						return false;
					}
				}
			}
		}
		return true;
	}
	
	function _generateAsso($asso)
	{
		$sql = '';
		if(empty($asso)){
			return $sql;
		}
		foreach($asso as $k => $v){
			$k = trim($k);
			$kk = explode(':', $k);
			$kk = implode(':', array($kk[1], $kk[0]));
			if(false === strpos(strtoupper($k), 'LEFT')){
				$sql .= "INNER JOIN " . str_replace(':', ' AS ', $kk) . " ON ";
			}
			//xinw start 20081017
			//modify for LV20R1-178
			elseif (strpos(strtoupper($k), 'LEFT MERGE'))
			{
				$sql .= "LEFT merge JOIN " . str_replace(':', ' AS ', $kk) . " ON ";
			}
			//xinw end 20081017
			else {
				$sql .= "LEFT JOIN " . str_replace(':', ' AS ', $kk) . " ON ";
			}
			$jc = array();
			foreach($v as $vl){
				$jc[] = $vl;
			}
			$sql .= implode(' AND ', $jc) . " ";
		}
		return $sql;
	}
	
	 function setByExtract($data, $groupby1, $groupby2)
    {
    	if(empty($data) || empty($groupby1) || empty($groupby2)){
    		return array();
    	}
		
		$keys = set :: extract($data, $groupby2);
		$vals = $data;

			$out = array();
				$group = Set::extract($data, $groupby1);
				if (!empty($group)) {
					$c = count($keys);
					for ($i = 0; $i < $c; $i++) {
						if(!isset($group[$i])) {
							$group[$i] = 0;
						}
						if (!isset($out[$group[$i]])) {
							$out[$group[$i]] = array();
						}
						$out[$group[$i]][$keys[$i]] = $vals[$i];
					}
				}
				else {
					return array();
				}
		return $out;
    }
}
?>