<?php
/*********************************************************************
*@filename assets_printer_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment

********************************************************************/
class AssetsSharefolderController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv');
	var $uses=array('Asthrd','Astose','Hrdnic','Sharefolder','Shareaccount','Grpauth','Hstloghead','Host','Rlthstgrp','Group');
	var $layout='assets';


	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('prt title',$return = true);// 'LVシステム管理／全体設定／センサー';
		//================================yin c=======================
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
		//		debug($_POST, true);
		//================================yin c=======================

	}

	function index($errorMessage = null)
	{
		//    	$glist = array(0 => __('whole',$return = true)); // 'すべて'
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		//		$glist[0] =  __('whole',$return = true);
		ksort($glist);
		$this->set('glist',$glist);
		
		$polllist = $this->Poll->generateList(null, null, null, '{n}.Poll.id', '{n}.Poll.poll_name', null);
		$polllist[0] =__('none_distribute', true);
		ksort($polllist);
		$this->set('plist',$polllist);
		
		if($errorMessage != null){
			echo "<div id='errmsg'>".
			__('index_error',$return = true).
			"</div>";
		}
	}
	function listdriver($csv = null)
	{
		$this->layout="ajax";
		
		$criteria[]="1=1";
		//入力データ取得
		$group = $this->_getUserGroup();
		if(isset($this->data['Group']['group_name']))
			$group = $this->data['Group']['group_name'];		
		
		$count = $this->data['Netscan']['count'];
		if(!is_numeric($count))
			$count = 20;
		
		$keyword = $this->data['Shareaccount']['name'];
		$keyword2 = $this->Lv->spec_char_dbm($keyword);
		$everyone = $this->data['Shareaccount']['everyone'];
		if($everyone == 1)
			$criteria[]="Shareaccount.name = 'Everyone'";
		else{
			if(isset($keyword2))
				$criteria[]="Shareaccount.name like '%".$keyword2."%'";
		}

		$mask = $this->data['Shareaccount']['mask'];
		if($mask == 3){
			$criteria[]="Shareaccount.mask & 0x40 = 0x40";
		}elseif($mask == 2){
			$criteria[]="Shareaccount.mask & 0x40 = 0";
			$criteria[]="Shareaccount.mask & 0x100 = 0x100";
		}elseif($mask == 1){
			$criteria[]="Shareaccount.mask & 0x40 = 0";
			$criteria[]="Shareaccount.mask & 0x100 = 0";
			$criteria[]="Shareaccount.mask & 0x80 = 0x80";
		}
		
		$group_ids = "";
		$glist = $this->Grpauth->getChildrenByParent($group);
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$criteria[]="Rlthstgrp.group_id in (".$group_ids.")";
		
		//var_dump($this->data['Shareaccount']);
//debug($this->data);

		//取得条件設定
		$asso = array(
			'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			'Asthrd : asthrds : LEFT' => array('Asthrd.host_id = Host.id'),
			'Astose : astoses' => array('Asthrd.id = Astose.hardware_id'),
			'Sharefolder : sharefolders' => array('Sharefolder.os_id = Astose.id'),
			'Shareaccount : shareaccounts' => array('Shareaccount.share_id = Sharefolder.id'),
			) ;
		
		$fields = array(
		'Group.group_name',
		'Host.host_name',
		'Sharefolder.name',
		'Sharefolder.path',
		'Shareaccount.name',
		'Shareaccount.mask',
		'((Shareaccount.mask )& 0x80 = 0x80) as Shareaccount__read',        //読み取り
		'((Shareaccount.mask )& 0x10000 = 0x10000) as Shareaccount__modify',    //変更
		'((Shareaccount.mask )& 0x1f01ff = 0x1f01ff) as Shareaccount__full',        //フル
		'((Shareaccount.file )& 0x80 = 0x80) as Shareaccount__read2',        //読み取り
		'((Shareaccount.file )& 0x10000 = 0x10000) as Shareaccount__modify2',    //変更
		'((Shareaccount.file )& 0x1f01ff = 0x1f01ff) as Shareaccount__full2',        //フル
		'((Shareaccount.file )& 0x80 = 0x80 && Shareaccount.file & 0x20 = 0x20) as Shareaccount__readexec2',        //読み取りと実行
		'((Shareaccount.file )& 0x1 = 0x1) as Shareaccount__list2',    //フォルダの内容の一覧表示
		'((Shareaccount.file )& 0x2 = 0x2) as Shareaccount__write2',        //書き込み
		'(Shareaccount.file = 4) as Shareaccount__other2',//、特殊なアクセス許可
		'Shareaccount.allow',
		);
	
		//$criteria["GROUP BY"]="Netscan.ip_address";

		//取得
		if($csv == 'csv'){
			$Hrdprts = $this->Host->findByAsso($criteria, $fields, 'Group.group_name, Host.host_name, Sharefolder.name, Shareaccount.name', null, null, $asso);
		
			$this->csvdown($Hrdprts,1);exit;
		}else{
			$this->Pagination->show = $count;
			list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'lists', 'url'=>'/assets_sharefolder/listdriver', 'modelClass'=>'Host', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 
			'sortBy' => $this->Lv->sortBy(
				'Group.group_name, Host.host_name, Sharefolder.name, Shareaccount.name')));
			$Hrdprts = $this->Host->findByAsso($criteria, $fields, $order, $limit, $page, $asso);
			$Hrdprts2 = $this->Host->findByAsso($criteria, $fields, null, null, null, $asso);
		}
		
//debug($Hrdprts);

		//表示データ設定
		!empty($Hrdprts)?$this->set('data',$Hrdprts):$this->set('data',"");
		$this->set('device_count',count($Hrdprts2));
		$this->set('countperpage',$count);	
		$this->set('group_id',$group);	
		$this->render('drivers');
	}

	function csvdown($data,$flag)
	{
		//$parent = $this->data['Selector']['parent_group'];
		$group = $this->data['Group']['group_name'];
		
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group));
		$group_n= $this->Group->findAll($criteria);
		$parent = $group_n[0]["Group"]["parent_id"];
		
		$this->data['Csv']['group'] = $this->groupName($group);
		
		$keyword = $this->data['Shareaccount']['name'];
		$everyone = $this->data['Shareaccount']['everyone'];
		if($everyone == 1)
			$this->data['Csv']['account'] = 'Everyone';
		else{
			if(isset($keyword))
				$this->data['Csv']['account'] = $keyword;
		}
		
		$mask = $this->data['Shareaccount']['mask'];
		if($mask == 3){
			$this->data['Csv']['access'] = __('access_full',$return = true);
		}elseif($mask == 2){
			$this->data['Csv']['access'] = __('access_modify',$return = true);
		}elseif($mask == 1){
			$this->data['Csv']['access'] = __('access_read',$return = true);
		}else
			$this->data['Csv']['access'] = __('access_none',$return = true);
		
		require_once( 'csv/DlFactory.php' );
		
		$filename="";

		foreach($data as $i => $d){
			if($d['Shareaccount']['allow'] == 1){
				if(!empty($d['Shareaccount']['full']))
					$data[$i]['Shareaccount']['full'] = '○';
				else
					$data[$i]['Shareaccount']['full'] = '';
				if(!empty($d['Shareaccount']['modify']))
					$data[$i]['Shareaccount']['modify'] = '○';
				else
					$data[$i]['Shareaccount']['modify'] = '';
				if(!empty($d['Shareaccount']['read']))
					$data[$i]['Shareaccount']['read'] = '○';
				else
					$data[$i]['Shareaccount']['read'] = '';
				
				if(!empty($d['Shareaccount']['full2']))
					$data[$i]['Shareaccount']['full2'] = '○';
				else
					$data[$i]['Shareaccount']['full2'] = '';
				if(!empty($d['Shareaccount']['modify2']))
					$data[$i]['Shareaccount']['modify2'] = '○';
				else
					$data[$i]['Shareaccount']['modify2'] = '';
				if(!empty($d['Shareaccount']['readexec2']))
					$data[$i]['Shareaccount']['readexec2'] = '○';
				else
					$data[$i]['Shareaccount']['readexec2'] = '';
				if(!empty($d['Shareaccount']['list2']))
					$data[$i]['Shareaccount']['list2'] = '○';
				else
					$data[$i]['Shareaccount']['list2'] = '';
				if(!empty($d['Shareaccount']['read2']))
					$data[$i]['Shareaccount']['read2'] = '○';
				else
					$data[$i]['Shareaccount']['read2'] = '';
				if(!empty($d['Shareaccount']['write2']))
					$data[$i]['Shareaccount']['write2'] = '○';
				else
					$data[$i]['Shareaccount']['write2'] = '';
				if(!empty($d['Shareaccount']['other2']))
					$data[$i]['Shareaccount']['other2'] = '○';
				else
					$data[$i]['Shareaccount']['other2'] = '';
			}else{
				if(!empty($d['Shareaccount']['full']))
					$data[$i]['Shareaccount']['full'] = '×';
				else
					$data[$i]['Shareaccount']['full'] = '';
				if(!empty($d['Shareaccount']['modify']))
					$data[$i]['Shareaccount']['modify'] = '×';
				else
					$data[$i]['Shareaccount']['modify'] = '';
				if(!empty($d['Shareaccount']['read']))
					$data[$i]['Shareaccount']['read'] = '×';
				else
					$data[$i]['Shareaccount']['read'] = '';
				
				if(!empty($d['Shareaccount']['full2']))
					$data[$i]['Shareaccount']['full2'] = '×';
				else
					$data[$i]['Shareaccount']['full2'] = '';
				if(!empty($d['Shareaccount']['modify2']))
					$data[$i]['Shareaccount']['modify2'] = '×';
				else
					$data[$i]['Shareaccount']['modify2'] = '';
				if(!empty($d['Shareaccount']['readexec2']))
					$data[$i]['Shareaccount']['readexec2'] = '×';
				else
					$data[$i]['Shareaccount']['readexec2'] = '';
				if(!empty($d['Shareaccount']['list2']))
					$data[$i]['Shareaccount']['list2'] = '×';
				else
					$data[$i]['Shareaccount']['list2'] = '';
				if(!empty($d['Shareaccount']['read2']))
					$data[$i]['Shareaccount']['read2'] = '×';
				else
					$data[$i]['Shareaccount']['read2'] = '';
				if(!empty($d['Shareaccount']['write2']))
					$data[$i]['Shareaccount']['write2'] = '×';
				else
					$data[$i]['Shareaccount']['write2'] = '';
				if(!empty($d['Shareaccount']['other2']))
					$data[$i]['Shareaccount']['other2'] = '×';
				else
					$data[$i]['Shareaccount']['other2'] = '';
			}
		}

		$csv = DlFactory::create("assets_sharefolder");
		if($flag == 1){
			$array = array(
				'Group/group_name'=>__('group_name', $return = true),
				'Host/host_name'=>__('host_name', $return = true),
				'Sharefolder/name'=>__('share_name', $return = true),
				'Sharefolder/path'=>__('share_path', $return = true),
				'Shareaccount/name'=>__('account', $return = true),
				'Shareaccount/full'=>__('access_full', $return = true),
				'Shareaccount/modify'=>__('access_modify', $return = true),
				'Shareaccount/read'=>__('access_read', $return = true),
				
				'Shareaccount/full2'=>__('access_full2', $return = true),
				'Shareaccount/modify2'=>__('access_modify', $return = true),
				'Shareaccount/readexec2'=>__('access_readexec', $return = true),
				'Shareaccount/list2'=>__('access_list', $return = true),
				'Shareaccount/read2'=>__('access_read', $return = true),
				'Shareaccount/write2'=>__('access_write', $return = true),
				'Shareaccount/other2'=>__('access_other', $return = true),
			);
			
			$filename=__('csv_file1',$return=true);
		}

		$csv->special_cols=$array;
		//debug($data);
		$csv->sendCSVFile($data,$this->data, $filename);

		exit;
	}
	
	function groupName($group_id)
	{
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}
}
?>