<?php
class AttendanceManagerController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check','RequestHandler');
	var $uses=array('Group', 'Host','Rlthstgrp','Grpauth','Authority','Rltuserauth','User','Configure','Validation',
	'Hstattendance','Workstatus');
	var $layout='attendance';
	
	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('menu_uptime',$retrun=true); 
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index($errorMessage = null)
	{
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		ksort($glist);
		$this->set('glist',$glist);
		
		
		$fields = array('Host.id', 
		'Host.host_name');
		$hosts = $this->Host->findAll($criteria, $fields, null, null, 1);
		$criteria = array();
		if(!empty($hosts)){
			$keys = Set::extract($hosts, '{n}.Host.id');
			$vals = Set::extract($hosts, '{n}.Host.host_name');
			$hosts = array_combine($keys, $vals);
		}
		$this->set('hosts',$hosts);
	}
	
	/*function search($type=null)
	{
		Configure::write('debug', 0);
		$this->layout="ajax";

		$criteria = array();
		$criteria[] = "1=1";
		$fields = array(
			'Host.id',
			'Host.host_name',
			'Hstattendance.tag',
			'Hstattendance.x',
			'Hstattendance.y',
			'Hstattendance.status',
			'Workstatus.name');
		$asso = array(
			'Host : hosts' => array('Hstattendance.host_id = Host.id'),
			'Workstatus : workstatus' => array('Workstatus.id = Hstattendance.status'),
		);
		$data = $this->Hstattendance->findByAsso($criteria, $fields, null, null, null, $asso);
$this->set(compact('data'));
	}*/
	
		function search2($type=null)
	{
		Configure::write('debug', 0);
		$this->layout="ajax";

		$criteria = array();
		$criteria[] = "1=1";
		$fields = array(
			'Host.id as id',
			'Host.host_name as hostname',
			'Hstattendance.tag as tag',
			'Hstattendance.x as x',
			'Hstattendance.y as y',
			'Hstattendance.status as status',
			'Workstatus.name as name');
		$asso = array(
			'Host : hosts' => array('Hstattendance.host_id = Host.id'),
			'Workstatus : workstatus' => array('Workstatus.id = Hstattendance.status'),
		);
		$data = $this->Hstattendance->findByAsso($criteria, $fields, null, null, null, $asso);
header("Content-Type: application/json; charset=utf-8");
$json = json_encode( $data ) ;
$this->set(compact('json'));
	}
	
	function add($host_id = null){
		$this->layout="ajax";
		
		if(is_null($host_id)){
			echo "0";
		}else{
			$host = $this->Hstattendance->findAll(array("host_id" => $this->Lv->spec_char_dbm($host_id)),null,null,null,null,null);
			//var_dump( $host);
			if(empty($host)){
				//echo "ssssss";
				$set_update=Array(
						'Hstattendance' => Array(
						'host_id' => $host_id,
						'status' => 1,
						'x' => 0,
						'y' => 0
						)
						);
				$this->Hstattendance->save($set_update);
				echo "1";
			}else
				echo "0";
		}
	}
	function update()
	{
		$this->layout="ajax";
		
		//var_dump($_POST);
		$data = json_decode($_POST['json']);
		//var_dump($data);
		foreach($data as $d){
			//var_dump($d[0]);
			if($d[0]->x < 0 || $d[0]->y < 0)
			{
				$this->Hstattendance->delete($d[0]->id);
				
			}else{
				$set_update=Array(
					'Hstattendance' => Array(
					'host_id' => $d[0]->id,
					'x' => $d[0]->x,
					'y' => $d[0]->y
					)
					);
				$this->Hstattendance->save($set_update);
			}
			
			//var_dump($set_update);
		}

	}
}
?>