<?php
/*********************************************************************
*@filename securities_controller.php
*@description oper_evtusers_controller 画面の機能クラス
*@note 
*@histories  rivision	author		date		comment
*            1.0        xinw        2008/10/16  modify for LV20R1-157
*            2.0        xinw        2008/10/22  modify for LV20R1-158
*            3.0        xinw        2008/11/14  modify for LV20R1-195
*            3.0        yzl        2009/09/14  modify for LogvillageChinese
********************************************************************/
class OperEvtusersController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Optuser','Group', 'Host','Rlthstgrp','Grpauth','Configure','Validation');
	var $layout='oper';
	function beforeFilter()
	{
		parent::beforeFilter();
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
			$this->set('back', $_POST['forHideVar1']);
		}
	}
	function index()
	{
		//xinw start 20080218
		//yzl   start     2009/09/14  modify for LogvillageChinese
		//$this->pageTitle = __('menu_oper',$return = true).'/'.__('log_on･log_off',$return = true);
		$this->pageTitle = __('menu_oper',$return = true).'/'.__('log_onlog_off',$return = true);
		//yzl   end     2009/09/14  modify for LogvillageChinese
		//xinw end 20080218
		$own_user_id = $this->_getUserGroup();
		$glist = $this->Grpauth->getChildrenByParent($own_user_id);
		$this->set('glist',$glist);
	}
	function search($judg = null,$acpc = null,$tim = null,$csv = null)
	{
		//xinw start 20080520
		(!empty($_SESSION['data_detail']))?session_unregister('data_detail'):"";
		//xinw end 20080520
		$this->layout='ajax';
		$dt= date('Y-m-d',time());
		$criteria = array();
		if($tim == 1){
			if(isset($this->data['dt_check'][0])){
				unset($this->data['dt_check'][0]);
			}
		}
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();
		$err=array();
		if(isset($this->data['Host']['host_name']))
		{
			if(!$this->Check->checkAllHalf($this->data['Host']['host_name']))
			{
				$err['client_pc_name'][] = 'E-00400';
			}
			if(!$this->Validation->maxLength($this->data['Host']['host_name'],127))
			{
				$err['client_pc_name'][] = 'E-00300';
			}
		}
		if(isset($this->data['Optuser']['account']))
		{
			//xinw start 20081016
			//modify for LV20R1-157
/*			if(!$this->Check->checkAllHalf($this->data['Optuser']['account']))
			{
				$err['logon account'][] = 'E-00400';
			}*/
			//xinw end 20081016
			if(!$this->Validation->maxLength($this->data['Optuser']['account'],127))
			{
				$err['logon account'][] = 'E-00300';
			}
		}
		if(!empty($by_kw['error']) || !empty($by_dt['error']) || !empty($err))
		{
			empty($by_kw['error']) ? null : $this->set('by_kw_err',$by_kw['error']);
			empty($by_dt['error']) ? null : $this->set('by_dt_err',$by_dt['error']);
			empty($err) ? $err = array() : $this->set('err',$err);
			$this->render();
			exit();
		}
		if(empty($by_dt) && empty($by_kw))
		{
			$criteria[]="datepart(Optuser.tslog)= '".$dt."'";
		}
		else
		{
			empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
			empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
		}
		if($judg == '1'){
			//wangs start 20080202
			//$criteria[] = "Optuser.account = '".$acpc."' ";
			$criteria[] = " lower(Optuser.account) = '".strtolower($acpc)."' ";
			//wangs end 20080202
			if(empty($tim)){
				isset($_POST['forHideVar1'])?$this->set('forHideVar', $_POST['forHideVar1']."&data%5BOptuser%5D%5Baccount%5D=$acpc"):null;
				isset($_POST['forHideVar'])?$this->set('forHideVar', $_POST['forHideVar']."&data%5BOptuser%5D%5Baccount%5D=$acpc"):null;
				$this->acdate($criteria,$acpc);
			}
			else{
				if($tim==1){
					$this->detail($criteria,$acpc,$tim,$judg);
				}
				elseif($tim=='csv'){
					isset($_POST['forHideVar1'])?$this->set('forHideVar', $_POST['forHideVar1']."&data%5BOptuser%5D%5Baccount%5D=$acpc"):null;
					isset($_POST['forHideVar'])?$this->set('forHideVar', $_POST['forHideVar']."&data%5BOptuser%5D%5Baccount%5D=$acpc"):null;
					$this->acdate($criteria,$acpc,$tim);
				}
				else{
					$criteria[] = "DATEPART(Optuser.tslog) = '".$tim."' ";
					$this->detail($criteria,$acpc,$tim,$judg,$csv);
				}
			}
		}
		elseif($judg == '2'){
			//wangs start 20080202
			//$criteria[] = "Host.host_name = '".$acpc."' ";
			$criteria[] = " lower(Host.host_name) = '".strtolower($acpc)."' ";
			//wangs end 20080202
			if(empty($tim)){
				isset($_POST['forHideVar1'])?$this->set('forHideVar', $_POST['forHideVar1']."&data%5BHost%5D%5Bhost_name%5D=$acpc"):null;
				isset($_POST['forHideVar'])?$this->set('forHideVar', $_POST['forHideVar']."&data%5BHost%5D%5Bhost_name%5D=$acpc"):null;
				$this->pcdate($criteria,$acpc);
			}
			else{
				if($tim==1){
					$this->detail($criteria,$acpc,$tim,$judg,$csv);
				}
				elseif($tim=='csv'){
					isset($_POST['forHideVar1'])?$this->set('forHideVar', $_POST['forHideVar1']."&data%5BHost%5D%5Bhost_name%5D=$acpc"):null;
					isset($_POST['forHideVar'])?$this->set('forHideVar', $_POST['forHideVar']."&data%5BHost%5D%5Bhost_name%5D=$acpc"):null;
					//xinw start 20080819
					$this->pcdate($criteria,$acpc,$tim);
					//xinw end 20080819
				}
				else{
					$criteria[] = "DATEPART(Optuser.tslog) = '".$tim."' ";
					$this->detail($criteria,$acpc,$tim,$judg,$csv);
				}
			}
		}
		else{
			if($this->data['Optuser']['account_pc']=='1')
			{
				$this->pc($criteria,$judg);
			}
			else
			{
				$_SESSION['by_dt'] = $by_dt;
				$this->account($criteria,$judg);
			}
		}
	}
	//xinw start 20080819
	function getgrpid($id)
	{
		$glist = $this->Grpauth->getChildrenByParent($id);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$search_str=" Rlthstgrp.group_id in (".$condition.") ";
		return $search_str;
	}
	//xinw end 20080819
	function account(& $criteria,$type=null)
	{

		$this->layout='ajax';
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			//xinw start 20080819
			//$criteria[]=" Grpauth.org_grp_id = $own_user_id ";
			$criteria[]=$this->getgrpid($own_user_id);
			//xinw end 20080819
		}else
		{
			//xinw start 20080819
			//$criteria[]=" Grpauth.org_grp_id=".$this->data['Optuser']['group']." ";
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
			//xinw end 20080819
		}
		$criteria3 = $criteria;
		//$criteriaex = $criteria;

		//$criteriaex['GROUP BY']="Optuser.LogonID,Optuser.host_id having Optuser__minst = Optuser__maxst and Optuser__minst = 1";
		
		//wangs start 20080221
		$criteria[]="Optuser.log_status not in (3,4,5)";
		//wangs end 20080221

		//xinw start 20080616
		$criteria[]=" Optuser.account <> '' ";
		//xinw end 20080616

		//xinw start 20080515
		$criteri_detail=$criteria;
		//xinw start 20080806
		$_SESSION['criteri_detail']=$criteri_detail;
		//$_SESSION['criteri_ex']=$criteriaex;
		$_SESSION['criteri_3']=$criteria3;
		//xinw end 20080806
		//xinw end 20080515
		//xinw start 20080819
		//$criteria['GROUP BY']="Optuser.account";
		$criteria['GROUP BY']="Optuser__account,Optuser.log_status";
		//xinw end 20080819
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers (id serial, name  varchar(127), login integer,logout integer,logerr integer)');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}
		//xinw start 20080819
		//$order_all="Optuser.account";
		$order_all="Optuser__account";
		/*$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
		);*/
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		/*		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),*/
		);
		//$opts = $this->Optuser->findByAsso($criteria, array("Optuser.account as Optuser__account"),$order_all,null,null,$asso);
		$opts = $this->Optuser->findByAsso($criteria, array("lower(Optuser.account) as Optuser__account,Optuser.log_status as Optuser__log_status,count(Optuser.log_status) as Optuser__con"),$order_all,null,null,$asso);
//アカウント毎の切断回数をだすwasay
		$logerrs =  $this->GetDisconnect($criteria3,$asso,'account');
		//debug ($logerrs);
		$logonoffnum = array();
		for ($i=0;$i<count($opts);$i++){
			$name = strtolower($opts[$i]['Optuser']['account']);
			$logonoffnum[$name][$opts[$i]['Optuser']['log_status']] = $opts[$i]['Optuser']['con'];
		}//debug ($logonoffnum);
		foreach ($logonoffnum as $key => $value){
			$login = 0;
			$logout = 0;
			$logerr = 0;
		
			if(isset($logerrs[$key]))
				$logerr = $logerrs[$key];
			if(isset($value[1]))
				$login = $value[1];
			if(isset($value[2]))
				$logout = $value[2];
			
			$this->Optuser->query("INSERT INTO temppsoptusers VALUES(null,'{$this->Lv->spec_char_dbm($key)}', {$login}, {$logout}, {$logerr});");
		}		
		/*$user_name=strtolower($opts[0]['Optuser']['account']);
		for ($i=0;$i<=count($opts);$i++){
			if (strtolower($opts[$i]['Optuser']['account'])==strtolower($user_name)) {
				if ($opts[$i]['Optuser']['log_status']==1){
					$login = $opts[$i]['Optuser']['con'];
				}
				elseif($opts[$i]['Optuser']['log_status']==2){
					$logout = $opts[$i]['Optuser']['con'];
				}
				elseif($opts[$i]['Optuser']['log_status']==0){
					$logerr = $opts[$i]['Optuser']['con'];
				}
			}else
			{
				isset($login)?null:$login = 0;
				isset($logout)?null:$logout = 0;
				isset($logerr)?null:$logerr = 0;
				$this->Optuser->query("INSERT INTO temppsoptusers VALUES(null,'{$this->Lv->spec_char_dbm($user_name)}', {$login}, {$logout}, {$logerr});");
				$user_name=strtolower($opts[$i]['Optuser']['account']);
				unset($login);
				unset($logout);
				unset($logerr);
				$i--;
			}
		}*/
		//xinw end 20080819
		$this->addModel("Temp");
		$this->Temp->useTable = "temppsoptusers";
		$order_now = "Temp.name";
		$condition = array("1=1");
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search', 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso'), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr"),$order,$limit,$page);

		//xinw start 20080515
		$total=0;
		foreach ($data as $da)
		{
			$total+=$da['Temp']['login'];
			$total+=$da['Temp']['logout'];
			$total+=$da['Temp']['logerr'];
		}
		$this->set('total',$total);
		//xinw end 20080515

		empty($data)? $data=array():$data;
		$this->set('data',$data);
		if($type=='csv'){
			$all_data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr"),$order,null,null);
			$this->csvdown($criteria,$all_data,1);exit;
		}
		$this->render('account_wasay');
	}
	function pc(& $criteria,$type=null)
	{

		$this->layout='ajax';
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			//xinw start 20080819
			//$criteria[]=" Grpauth.org_grp_id = $own_user_id ";
			$criteria[]=$this->getgrpid($own_user_id);
			//xinw end 20080819
		}else
		{
			//xinw start 20080819
			//$criteria[]=" Grpauth.org_grp_id=".$this->data['Optuser']['group']." ";
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
			//xinw end 20080819
		}
		//$criteriaex = $criteria;
	$criteria3 = $criteria;
		//$criteriaex['GROUP BY']="Optuser.LogonID,Optuser.host_id having Optuser__minst = Optuser__maxst and Optuser__minst = 1";
		
		//xinw start 20080819
		//$criteria['GROUP BY']="Host.host_name";
		$criteria['GROUP BY']="Host.host_name,Optuser.log_status";
		//xinw end 20080819
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers (id serial, name  varchar(127), login integer,logout integer,logerr integer)');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}
		$order_all="Host.host_name";
		//xinw start 20080819
		/*		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
		);*/
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		/*		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),*/
		);
		//$opts = $this->Optuser->findByAsso($criteria, array("Host.host_name as Host__host_name"),$order_all,null,null,$asso);
		$opts = $this->Optuser->findByAsso($criteria, array("Host.host_name as Host__host_name,Optuser.log_status as Optuser__log_status,count(Optuser.log_status) as Optuser__con"),$order_all,null,null,$asso);
//host毎の切断回数をだすwasay
		$logerrs =  $this->GetDisconnect($criteria3,$asso,'host');
		$logonoffnum = array();
		for ($i=0;$i<count($opts);$i++){
			$name = strtolower($opts[$i]['Host']['host_name']);
			$logonoffnum[$name][$opts[$i]['Optuser']['log_status']] = $opts[$i]['Optuser']['con'];
		}//debug ($logonoffnum);
		foreach ($logonoffnum as $key => $value){
			$login = 0;
			$logout = 0;
			$logerr = 0;
		
			if(isset($logerrs[$key]))
				$logerr = $logerrs[$key];
			if(isset($value[1]))
				$login = $value[1];
			if(isset($value[2]))
				$logout = $value[2];
			
			$this->Optuser->query("INSERT INTO temppsoptusers VALUES(null,'{$this->Lv->spec_char_dbm($key)}', {$login}, {$logout}, {$logerr});");
		}		
		/*
		$host_name=strtolower($opts[0]['Host']['host_name']);
		for ($i=0;$i<=count($opts);$i++){
			if (strtolower($opts[$i]['Host']['host_name'])==strtolower($host_name)) {
				if ($opts[$i]['Optuser']['log_status']==1){
					$login = $opts[$i]['Optuser']['con'];
				}
				elseif($opts[$i]['Optuser']['log_status']==2){
					$logout = $opts[$i]['Optuser']['con'];
				}
				elseif($opts[$i]['Optuser']['log_status']==0){
					$logerr = $opts[$i]['Optuser']['con'];
				}
			}else
			{
				isset($login)?null:$login = 0;
				isset($logout)?null:$logout = 0;
				isset($logerr)?null:$logerr = 0;
				$this->Optuser->query("INSERT INTO temppsoptusers VALUES(null,'{$host_name}', {$login}, {$logout}, {$logerr});");
				$host_name=strtolower($opts[$i]['Host']['host_name']);
				unset($login);
				unset($logout);
				unset($logerr);
				$i--;
			}
		}*/
		//xinw end 20080819
		$this->addModel("Temp");
		$this->Temp->useTable = "temppsoptusers";
		$order_now = "Temp.name";
		$condition = array("1=1");
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search', 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso'), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr"),$order,$limit,$page);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		if($type=='csv'){
			$all_data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr"),$order,null,null);
			$this->csvdown($criteria,$all_data,2);exit;
		}
		$this->render('pc_wasay');
	}
	function acdate(& $criteria,$acpc=null,$type=null)
	{

		$this->layout='ajax';
		$this->set('back',$criteria);

		//xinw start 20080505
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			//xinw start 20080819
			//$criteria[]=" Grpauth.org_grp_id = $own_user_id ";
			$criteria[]=$this->getgrpid($own_user_id);
			//xinw end 20080819
		}else
		{
			//xinw start 20080819
			//$criteria[]=" Grpauth.org_grp_id=".$this->data['Optuser']['group']." ";
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
			//xinw end 20080819
		}	$criteria3 = $criteria;
		//xinw end 20080505
//$criteriaex = $criteria;
//$criteriaex['GROUP BY']="Optuser.LogonID,Optuser.host_id having Optuser__minst = Optuser__maxst and Optuser__minst = 1";
		
		//xinw start 20080616
		$criteria[]=" Optuser.log_status not in (3,4,5)";
		$criteria[]=" Optuser.account <> '' ";
		//xinw end 20080616

		//xinw start 20080819
		//$criteria['GROUP BY']="DATEPART(tslog)";
		$criteria['GROUP BY']="DATEPART(tslog),Optuser.log_status,TIMEPART(tslog),Optuser.AccessFrom";
		//xinw end 20080819
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers (id serial, name date, login integer,logout integer,logerr integer,used_time time)');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}
		$order_all="DATEPART(tslog)";
		//xinw start 20080819
		/*		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		//xinw start 20080505
		'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
		//xinw end 20080505
		);*/
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		);
		//$opts = $this->Optuser->findByAsso($criteria, array("DATEPART(tslog) as Optuser__date"),$order_all,null,null,$asso);
		$opts = $this->Optuser->findByAsso($criteria, array("DATEPART(tslog) as Optuser__date,Optuser.log_status as Optuser__log_status,count(Optuser.log_status) as Optuser__con,TIMEPART(tslog) as Optuser__time,Optuser.AccessFrom as Optuser__AccessFrom"),$order_all,null,null,$asso);
		
		//追加するオフの時間を取得 acc
		$logerrs = $this->GetDisconnect2($criteria3,$asso);
		//debug($logerrs);
		//debug($opts);

		for ($i=0;$i<count($logerrs);$i++)
		{
			for ($j=0;$j<count($opts);$j++)
			{
				if($opts[$j]['Optuser']['date'] == $logerrs[$i][0]['Optuser']['date']){
					array_splice($opts, $j, 0, $logerrs[$i]);break;
				}
			}
		}
		//debug($opts);

		
		$date=$opts[0]['Optuser']['date'];
		$array_temp=array();
		$j=0;
		for ($i=0;$i<count($opts);$i++)
		{
			if ($date==$opts[$i]['Optuser']['date'])
			{
				$array_temp[$j][]=$opts[$i];
			}
			else
			{
				$date=$opts[$i]['Optuser']['date'];
				$i--;
				$j++;
			}
		}
		foreach($array_temp as $v){
			unset($login);
			unset($logout);
			unset($logerr);
			foreach ($v as $pass_log){
				if ($pass_log['Optuser']['log_status']==1){
					$login = $login+$pass_log['Optuser']['con'];
				}
				elseif($pass_log['Optuser']['log_status']==2){
					$logout = $logout+$pass_log['Optuser']['con'];
				}
				elseif($pass_log['Optuser']['log_status']==0){
					$logerr = $logerr+$pass_log['Optuser']['con'];
				}
			}
			isset($login)?null:$login = 0;
			isset($logout)?null:$logout = 0;
			isset($logerr)?null:$logerr = 0;
			$shu = 0;
			$lytime = '00:00:00';

			foreach ($v as $value){//echo $value['Optuser']['log_status']."-".$value['Optuser']['time']."-".$value['Optuser']['AccessFrom']."-".$shu."</br>";
				//logon
				if($value['Optuser']['log_status'] == 1 && empty($value['Optuser']['AccessFrom'])){
					$shu = $shu-strtotime($value['Optuser']['time']);
				}
				elseif(empty($value['Optuser']['AccessFrom'])){
					$shu = $shu+strtotime($value['Optuser']['time']);
				}
			}
			if($shu < 0){
				if(date('Y-m-d') == $v[0]['Optuser']['date'])
				{
					$shu = $shu+strtotime(date("H:i:s"));
				}
				else{
					$shu = 86399+$shu;
					$shu=$shu+1185894000;
				}
			}
			if($shu<11858940){
				$shu=$shu+1185894000;
			}
			$lytime = date("H:i:s",$shu);
			$this->Optuser->query("INSERT INTO temppsoptusers VALUES(null,'{$v[0]['Optuser']['date']}', {$login}, {$logout}, {$logerr}, '{$lytime}');");
		}
		//xinw end 20080819
		$this->addModel("Temp");
		$this->Temp->useTable = "temppsoptusers";
		$order_now = "Temp.name";
		$condition = array("1=1");
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search/1/'.$acpc, 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso'), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr,Temp.used_time as Temp__used_time"),$order,$limit,$page);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		$this->set('acpc',$acpc);
		$this->set('data',$data);
		if($type=='csv'){
			$all_data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr,Temp.used_time as Temp__used_time"),$order,null,null);
			$this->csvdown($criteria,$all_data,3);exit;
		}
		$this->render('acdate_wasay');
	}
	function pcdate(& $criteria,$acpc=null,$type=null)
	{

		$this->layout='ajax';

		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers (id serial, name date, login integer,logout integer,logerr integer,used_time time)');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}



		//xinw start 20080505
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			//xinw start 20080819
			//$criteria[]=" Grpauth.org_grp_id = $own_user_id ";
			$criteria[]=$this->getgrpid($own_user_id);
			//xinw end 20080819
		}else
		{
			//xinw start 20080819
			//$criteria[]=" Grpauth.org_grp_id=".$this->data['Optuser']['group']." ";
			$criteria[]=$this->getgrpid($this->data['Optuser']['group']);
			//xinw end 20080819
		}	$criteria3 = $criteria;
		//xinw end 20080505
//$criteriaex = $criteria;
//$criteriaex['GROUP BY']="Optuser.LogonID,Optuser.host_id having Optuser__minst = Optuser__maxst and Optuser__minst = 1";
		//xinw start 20080819
		//$criteria['GROUP BY']="DATEPART(tslog)";
		$criteria['GROUP BY']="DATEPART(tslog),Optuser.log_status,TIMEPART(tslog),Optuser.AccessFrom";
		//xinw end 20080819
		//xinw start 20080616
		$criteria[]=" Optuser.log_status not in (3,4,5)";
		$criteria[]=" Optuser.account <> '' ";
		//xinw end 20080616


		$order_all="DATEPART(tslog)";
		//xinw start 20080819
		/*		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		//xinw start 20080505
		'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
		//xinw end 20080505
		);*/
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		//'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		//xinw start 20080505
		//'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
		//xinw end 20080505
		);
		//$opts = $this->Optuser->findByAsso($criteria, array("DATEPART(tslog) as Optuser__date"),$order_all,null,null,$asso);
		$opts = $this->Optuser->findByAsso($criteria, array("DATEPART(tslog) as Optuser__date,Optuser.log_status as Optuser__log_status,count(Optuser.log_status) as Optuser__con,TIMEPART(tslog) as Optuser__time,Optuser.AccessFrom as Optuser__AccessFrom"),$order_all,null,null,$asso);
		
		//追加するオフの時間を取得 host
		$logerrs = $this->GetDisconnect2($criteria3,$asso);
		//debug($logerrs);

		for ($i=0;$i<count($logerrs);$i++)
		{
			for ($j=0;$j<count($opts);$j++)
			{
				if($opts[$j]['Optuser']['date'] == $logerrs[$i][0]['Optuser']['date']){
					array_splice($opts, $j, 0, $logerrs[$i]);break;
				}
			}
		}
		//debug($opts);

		
		
		$date=$opts[0]['Optuser']['date'];
		$array_temp=array();
		$j=0;
		for ($i=0;$i<count($opts);$i++)
		{
			if ($date==$opts[$i]['Optuser']['date'])
			{
				$array_temp[$j][]=$opts[$i];
			}
			else
			{
				$date=$opts[$i]['Optuser']['date'];
				$i--;
				$j++;
			}
		}

		foreach($array_temp as $v){
			unset($login);
			unset($logout);
			unset($logerr);
			foreach ($v as $pass_log){
				if ($pass_log['Optuser']['log_status']==1){
					$login = $login+$pass_log['Optuser']['con'];
				}
				elseif($pass_log['Optuser']['log_status']==2){
					$logout = $logout+$pass_log['Optuser']['con'];
				}
				elseif($pass_log['Optuser']['log_status']==0){
					$logerr = $logerr+$pass_log['Optuser']['con'];
				}
			}
			isset($login)?null:$login = 0;
			isset($logout)?null:$logout = 0;
			isset($logerr)?null:$logerr = 0;
			$shu = 0;
			$lytime = '00:00:00';

			foreach ($v as $value){
				//xinw start 20080923
				if($value['Optuser']['log_status'] == 1 && empty($value['Optuser']['AccessFrom'])){
				//xinw end 20080923
					$shu = $shu-strtotime($value['Optuser']['time']);
				}
				//xinw start 20080923
				elseif(empty($value['Optuser']['AccessFrom'])){
				//xinw end 20080923
					$shu = $shu+strtotime($value['Optuser']['time']);
				}
			}
			if($shu < 0){
				if(date('Y-m-d') == $v[0]['Optuser']['date'])
				{
					$shu = $shu+strtotime(date("H:i:s"));
				}
				else{
					$shu = 86399+$shu;
					$shu=$shu+1185894000;
				}
			}
			if($shu<11858940){
				$shu=$shu+1185894000;
			}
			$lytime = date("H:i:s",$shu);
			$this->Optuser->query("INSERT INTO temppsoptusers VALUES(null,'{$v[0]['Optuser']['date']}', {$login}, {$logout}, {$logerr}, '{$lytime}');");
		}
		//xinw end 20080819
		$this->addModel("Temp");
		$this->Temp->useTable = "temppsoptusers";
		$order_now = "Temp.name";
		$condition = array("1=1");
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search/2/'.$acpc, 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso'), 'sortBy' => $this->Lv->sortBy($order_now)));
		$data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr,Temp.used_time as Temp__used_time"),$order,$limit,$page);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		$this->set('acpc',$acpc);
		$this->set('data',$data);
		if($type=='csv'){
			$all_data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr,Temp.used_time as Temp__used_time"),$order,null,null);
			$this->csvdown($criteria,$all_data,4);exit;
		}
		$this->render('pcdate_wasay');
	}
	function detail(& $criteria,$acpc=null,$tim=null,$judg=null,$type=null)
	{
		
		$this->layout='ajax';
		$time = $tim;
		if ($tim == 1){
			$criteria[] = "DATEPART(Optuser.tslog) = '{$this->data['dt_check']['start_year']}-{$this->data['dt_check']['start_month']}-{$this->data['dt_check']['start_day']}' ";
		$time = "{$this->data['dt_check']['start_year']}-{$this->data['dt_check']['start_month']}-{$this->data['dt_check']['start_day']}";
		}
		
		//一時的にテーブルを変える
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers like optusers');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}

		$this->Optuser->query("insert into temppsoptusers select * from optusers where tslog BETWEEN '$time' and '$time' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND ");

		$oldtable = $this->Optuser->useTable;
		$this->Optuser->useTable = "temppsoptusers";
		//$this->Optuser->setSource('temppsoptusers');

$criteria3 = $criteria;

//$criteriaex = $criteria;
//$criteriaex['GROUP BY']="Optuser.LogonID,Optuser.host_id having Optuser__minst = Optuser__maxst and Optuser__minst = 1";

		//xinw start 20080613
		$criteria[]="Optuser.log_status not in (3,4,5)";
		$criteria[]="Optuser.account <> '' ";
		//xinw end 20080613

		//xinw start 20080505
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
			$criteria[]=" Grpauth.org_grp_id = $own_user_id ";
		}else
		{
			$criteria[]=" Grpauth.org_grp_id=".$this->data['Optuser']['group']." ";
		}
		//xinw end 20080505



		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		//xinw start 20080505
		'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
		//xinw end 20080505
		);
		
		//追加するオフの時間を取得 
		$logerrs = $this->GetDisconnect2($criteria3,$asso);
		//debug($logerrs);
		foreach($logerrs as $value)
		{
			$host_id = $value[0]['Optuser']['host_id'];
			$account = $value[0]['Optuser']['account'];
			$log_status = $value[0]['Optuser']['log_status'];
			$tslog = $value[0]['Optuser']['tslog'];
			$LogonID = $value[0]['Optuser']['LogonID'];
			$AccessFrom = $value[0]['Optuser']['AccessFrom'];
			$this->Optuser->query("insert into temppsoptusers(host_id,account,log_status,tslog,LogonID,AccessFrom) values({$host_id},'{$account}',{$log_status},'{$tslog}','{$LogonID}','{$AccessFrom}')");
		}
		
		
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_evtusers/search/'.$judg."/".$acpc."/".$tim, 'modelClass'=>'Optuser', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('Optuser.tslog')));
		//xinw start 20080917
		//$data = $this->Optuser->findByAsso($criteria, array('Optuser.tslog as Optuser__tslog,Group.group_name as Group__group_name,Host.host_name as Host__host_name,Optuser.account as Optuser__account,Optuser.log_status as Optuser__log_status,Optuser.reason as Optuser__reason'), $order, $limit, $page, $asso);
		$data = $this->Optuser->findByAsso($criteria, array('Optuser.tslog as Optuser__tslog,Group.group_name as Group__group_name,Host.host_name as Host__host_name,Optuser.account as Optuser__account,Optuser.log_status as Optuser__log_status,Optuser.reason as Optuser__reason,Optuser.AccessFrom as Optuser__AccessFrom'), $order, $limit, $page, $asso);
		//xinw end 20080917
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		$this->set('judg',$judg);
		$this->set('acpc',$acpc);
		$this->set('tim',$tim);
		if($type=='csv'){
			//xinw start 20080917
			//$all_data = $this->Optuser->findByAsso($criteria, array('Optuser.tslog as Optuser__tslog,Group.group_name as Group__group_name,Host.host_name as Host__host_name,Optuser.account as Optuser__account,Optuser.log_status as Optuser__log_status,Optuser.reason as Optuser__reason'), $order, null, null, $asso);
			$all_data = $this->Optuser->findByAsso($criteria, array('Optuser.tslog as Optuser__tslog,Group.group_name as Group__group_name,Host.host_name as Host__host_name,Optuser.account as Optuser__account,Optuser.log_status as Optuser__log_status,Optuser.reason as Optuser__reason,Optuser.AccessFrom as Optuser__AccessFrom'), $order, null, null, $asso);
			//xinw end 20080917
			$this->csvdown($criteria,$all_data,5);exit;
		}
				//利用テーブルを戻す
		//$this->Optuser->setSource($oldtable);
		$this->Optuser->useTable = $oldtable;
		$this->render('detail_wasay');
	}
	function groupName($group_id)
	{
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}

	function csvdown($criteria=array(),$data=array(),$type=null)
	{
		require_once( 'csv/DlFactory.php' );
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
		}else
		{
			$own_user_id = $this->data['Optuser']['group'];
		}
		$this->data["Optuser"]["group"] = $this->groupName($own_user_id);
		if($this->data['Optuser']['account_pc']==1){
			$this->data['Optuser']['account_pc'] = __("client_view",true);
		}else{
			$this->data['Optuser']['account_pc'] = __("login_account_view",true);
		}
		if($type==1){
			$csv = DlFactory::create("oper_evtusers");
			$csv->special_cols = array(
			"Temp/name"=>__('login_account_name',$return = true),
			"Temp/login"=>__('count_login',$return = true),
			"Temp/logout"=>__('count_logout_nom_change_wasay',$return = true),
			"Temp/logerr"=>__('count_logout_err_change_wasay',$return = true),
			);
			//xinw start 20080218
			//yzl   start     2009/09/14  modify for LogvillageChinese
			//$csv->sendCSVFile($data,$this->data,__('log_on･log_off',$return = true));
			$csv->sendCSVFile($data,$this->data,__('log_onlog_off',$return = true));
			//yzl   end     2009/09/14  modify for LogvillageChinese
			//xinw end 20080218
		}
		elseif($type==2){
			$csv = DlFactory::create("oper_evtusers");
			$csv->special_cols = array(
			"Temp/name"=>__('computer_name',$return = true),
			"Temp/login"=>__('count_login',$return = true),
			"Temp/logout"=>__('count_logout_nom_change_wasay',$return = true),
			"Temp/logerr"=>__('count_logout_err_change_wasay',$return = true),
			);
			//xinw start 20080218
			//yzl   start     2009/09/14  modify for LogvillageChinese
			//$csv->sendCSVFile($data,$this->data,__('log_on･log_off',$return = true));
			$csv->sendCSVFile($data,$this->data,__('log_onlog_off',$return = true));
			//yzl   end     2009/09/14  modify for LogvillageChinese
			//xinw end 20080218
		}
		elseif($type==3){
			$csv = DlFactory::create("oper_evtusers");
			$csv->special_cols = array(
			"Temp/name"=>__('dating',$return = true),
			"Temp/login"=>__('count_login',$return = true),
			"Temp/logout"=>__('count_logout_nom_change_wasay',$return = true),
			"Temp/logerr"=>__('count_logout_err_change_wasay',$return = true),
			"Temp/used_time"=>__('usetime',$return = true)
			);
			//xinw start 20080218
			//yzl   start     2009/09/14  modify for LogvillageChinese
			//$csv->sendCSVFile($data,$this->data,__('log_on･log_off',$return = true));
			$csv->sendCSVFile($data,$this->data,__('log_onlog_off',$return = true));
			//yzl   end     2009/09/14  modify for LogvillageChinese
			//xinw end 20080218
		}
		elseif($type==4){
			$csv = DlFactory::create("oper_evtusers");
			$csv->special_cols = array(
			"Temp/name"=>__('dating',$return = true),
			"Temp/login"=>__('count_login',$return = true),
			"Temp/logout"=>__('count_logout_nom_change_wasay',$return = true),
			"Temp/logerr"=>__('count_logout_err_change_wasay',$return = true),
			"Temp/used_time"=>__('usetime',$return = true)
			);
			//xinw start 20080218
			//yzl   start     2009/09/14  modify for LogvillageChinese
			//$csv->sendCSVFile($data,$this->data,__('log_on･log_off',$return = true));
			$csv->sendCSVFile($data,$this->data,__('log_onlog_off',$return = true));
			//yzl   end     2009/09/14  modify for LogvillageChinese
			//xinw end 20080218
		}
		elseif($type==5){
			$csv = DlFactory::create("oper_evtusers");
			$csv->special_cols = array(
			"Optuser/tslog"=>__('dating',$return = true),
			"Group/group_name"=>__('group_name',$return = true),
			"Host/host_name"=>__('computer_name',$return = true),
			"Optuser/account"=>__('login_account_name',$return = true),
			//xinw start 20080917
			//"Optuser/AccessFrom"=>__('network_access',$return = true),
			//xinw end 20080917
			"Optuser/log_status"=>__('status',$return = true),
			);
			$login=__("login",true);//ログオン
			$logout_status=__("logout_status",true);//ログオフ（正常?�?


			$logout_reason=__("logout_reason",true);//ログオフ�?


			$end_logout_reason=__("end_logout_reason",true);//?�?
			foreach ($data as $output){
				if($output['Optuser']['log_status'] == '1'){
					$status = $login;
				}
				elseif($output['Optuser']['log_status'] == '2'){
					$status = $logout_status;
				}
				elseif($output['Optuser']['log_status'] == '0'){
					$status = $logout_reason.$output['Optuser']['reason'].$end_logout_reason;
				}
				$output_data = array(
				'Optuser' => array(
				'tslog' => $output['Optuser']['tslog'],
				//xinw start 20081022
				//modify for LV20R1-158
				//'account' => $output['Optuser']['account'],
				'account' => strtolower($output['Optuser']['account']),
				//xinw end 20081022
				//xinw start 20080917
				'AccessFrom' => $output['Optuser']['AccessFrom'],
				//xinw end 20080917
				'log_status' => $status
				),
				'Group' => array(
				'group_name' => $output['Group']['group_name'],
				),
				'Host' => array(
				'host_name' => $output['Host']['host_name'],
				)
				);
				$final_data[] = $output_data;
			}
			//xinw start 20080218
			//yzl   start     2009/09/14  modify for LogvillageChinese
			//$csv->sendCSVFile($final_data,$this->data,__('log_on･log_off',$return = true));
			$csv->sendCSVFile($final_data,$this->data,__('log_onlog_off',$return = true));
			//yzl   end     2009/09/14  modify for LogvillageChinese
			//xinw end 20080818
		}
	}

	//xinw start 20080515
	function csvdown_detail()
	{
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("oper_evtusers");
		if($this->data['Optuser']['group']=='0' || empty($this->data['Optuser']['group']))
		{
			$own_user_id = $this->_getUserGroup();
		}else
		{
			$own_user_id = $this->data['Optuser']['group'];
		}
		$this->data["Optuser"]["group"] = $this->groupName($own_user_id);
		$csv->special_cols = array(
		"Optuser/tslog"=>__('dating',$return = true),
		"Group/group_name"=>__('group_name',$return = true),
		"Host/host_name"=>__('computer_name',$return = true),
		"Optuser/account"=>__('login_account_name',$return = true),
		"Optuser/log_status"=>__('status',$return = true),
		);
		//xinw start 20080806
		$asso = array('Host : hosts' => array('Optuser.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optuser.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		//xinw start 20081114
		//modify for LV20R1-195
		//'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
		//xinw end 20081114
		);
		
		//一時的にテーブルを変える
		$result = $this->Optuser->query('CREATE TEMPORARY TABLE temppsoptusers like optusers');
		if($result === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}
$by_dt = implode(' and ', $_SESSION['by_dt']);
		$this->Optuser->query("insert into temppsoptusers select * from optusers as Optuser where {$by_dt}");

		$oldtable = $this->Optuser->useTable;
		$this->Optuser->useTable = "temppsoptusers";
		
						//追加するオフの時間を取得 acc
		$logerrs = $this->GetDisconnect2($_SESSION['criteri_3'],$asso);
		//debug($logerrs);
		foreach($logerrs as $value)
		{
			$host_id = $value[0]['Optuser']['host_id'];
			$account = $value[0]['Optuser']['account'];
			$log_status = $value[0]['Optuser']['log_status'];
			$tslog = $value[0]['Optuser']['tslog'];
			$LogonID = $value[0]['Optuser']['LogonID'];
			$AccessFrom = $value[0]['Optuser']['AccessFrom'];
			$this->Optuser->query("insert into temppsoptusers(host_id,account,log_status,tslog,LogonID,AccessFrom) values({$host_id},'{$account}',{$log_status},'{$tslog}','{$LogonID}','{$AccessFrom}')");
		}
		
		$data_detail = $this->Optuser->findByAsso($_SESSION['criteri_detail'], array('Group.group_name','Host.host_name','Optuser.account','Optuser.log_status','Optuser.tslog'),null,null,null,$asso);
		$data=$data_detail;
		
		$this->Optuser->useTable = "optusers";
		
		//$data=$_SESSION['data_detail'];
		//xinw end 20080806
		//session_unregister('data_detail');

		$login=__("login",true);//ログオン
		$logout_status=__("logout_status",true);//ログオフ（正常?�?
		$logout_reason=__("logout_reason",true);//ログオフ�?
		$end_logout_reason=__("end_logout_reason",true);//?�?

		foreach ($data as $output){
			if($output['Optuser']['log_status'] == '1'){
				$status = $login;
			}
			elseif($output['Optuser']['log_status'] == '2'){
				$status = $logout_status;
			}
			elseif($output['Optuser']['log_status'] == '0'){
				$status = $logout_reason.$output['Optuser']['reason'].$end_logout_reason;
			}
			$output_data = array(
			'Optuser' => array(
			'tslog' => $output['Optuser']['tslog'],
			'account' => $output['Optuser']['account'],
			'log_status' => $status
			),
			'Group' => array(
			'group_name' => $output['Group']['group_name'],
			),
			'Host' => array(
			'host_name' => $output['Host']['host_name'],
			)
			);
			$final_data[] = $output_data;
		}

		//yzl   start     2009/09/14  modify for LogvillageChinese
		//$csv->sendCSVFile($final_data,$this->data,__('log_on･log_off',$return = true));
		$csv->sendCSVFile($final_data,$this->data,__('log_onlog_off',$return = true));
		//yzl   end     2009/09/14  modify for LogvillageChinese
	}
	function csv_detail($total=null,$type=null,$hidevar=null)
	{
		$this->layout='ajax';
		//$hidevar=$_SESSION['hidevar'];

		$hidevar=$this->Lv->url_param_decode2($hidevar);
		//$data = $this->Temp->findByAsso($condition, array("Temp.name as Temp__name,Temp.login as Temp__login,Temp.logout as Temp__logout,Temp.logerr as Temp__logerr"),$order,$limit,$page);
		//print_r($data);
		$this->set('total',$total);
		$this->set('hidevar',$hidevar);
		if ($type=='csvdown_detail1')
		{
			$this->csvdown_detail();
		}
	}
	//xinw end 20080515
	//xinw start 20080613
	/*	function delete_repeat($temp)
	{
	for($i=0;$i<count($temp)-1;$i++)
	{
	for($j=$i+1;$j<count($temp);$j++)
	{
	if(strtolower($temp[$i]['Optuser']['account'])==strtolower($temp[$j]['Optuser']['account']))
	{
	if (ereg("^[A-Z]+$",substr($temp[$i]['Optuser']['account'],0,1))) {
	unset($temp[$j]);
	}elseif(ereg("^[A-Z]+$",substr($temp[$j]['Optuser']['account'],0,1)))
	{
	unset($temp[$i]);
	}else
	{
	unset($temp[$j]);
	}
	sort($temp);
	}
	}
	}
	sort($temp);
	return $temp;
	}*/
	//xinw end 20080613

	function GetDisconnect($criteria3=null,$asso=null,$type=null)
	{
			$criteriaex = $criteria3;
$criteriaex['GROUP BY']="Optuser.LogonID,Optuser.host_id having Optuser__minst = Optuser__maxst and Optuser__minst = 1";
	//ホストorアカウント毎の切断回数をだすwasay
		$onwooff = $this->Optuser->findByAsso($criteriaex, array("Host.host_name as Host__host_name,Optuser.LogonID as Optuser__LogonID,lower(Optuser.account) as Optuser__account,Optuser.host_id as Optuser__host_id,Optuser.tslog as Optuser__tslog, count(*) as Optuser__cnt, max(log_status) as Optuser__maxst, min(log_status) as Optuser__minst"),null,null,null,$asso);
//debug($onwooff);
//debug($opts);
$logerrs = array();
		for ($i=0;$i<count($onwooff);$i++){
			//echo $i."<br>";
			//debug($onwooff[$i]['Optuser']);
			$criteria4 = $criteria3;
			$criteria4[] = "Optuser.tslog > '".$onwooff[$i]['Optuser']['tslog']."'";
			//$criteria4[] = "Optuser.log_status in (3,5)";
			$criteria4[] = "(Optuser.log_status in (3,5) or (Optuser.log_status =1 and Optuser.AccessFrom = ''))";
			$criteria4[] = "Optuser.host_id = ".$onwooff[$i]['Optuser']['host_id'];
			$startorcut = $this->Optuser->findByAsso($criteria4, array("Optuser.id as Optuser__id"),null,null,null,$asso);
			//var_dump($startorcut);
			if(count($startorcut)>0){
				if($type == 'host'){
					$name = strtolower($onwooff[$i]['Host']['host_name']);
					if(isset($logerrs[$name]))
						$logerrs[$name]++;
					else
						$logerrs[$name] = 1;
				}else if($type == 'account'){
					$name = strtolower($onwooff[$i]['Optuser']['account']);
					if(isset($logerrs[$name]))
						$logerrs[$name]++;
					else
						$logerrs[$name] = 1;
				}
			}
		}
		return $logerrs;
	}
	
	function GetDisconnect2($criteria3=null,$asso=null)
	{//debug($criteriaex);debug($criteria3);
		//wasay
		$criteriaex = $criteria3;
$criteriaex['GROUP BY']="Optuser.LogonID,Optuser.host_id having Optuser__minst = Optuser__maxst and Optuser__minst = 1";
		$criteria_new2 = array();
		foreach($criteria3 as $value)
		{
			if(false == strstr($value,"lower(Optuser.account) ="))
				$criteria_new2[] = $value;
		}
		$onwooff = $this->Optuser->findByAsso($criteriaex, array("Optuser.AccessFrom as Optuser__AccessFrom,Host.host_name as Host__host_name,Optuser.LogonID as Optuser__LogonID,lower(Optuser.account) as Optuser__account,Optuser.host_id as Optuser__host_id,Optuser.tslog as Optuser__tslog, count(*) as Optuser__cnt, max(log_status) as Optuser__maxst, min(log_status) as Optuser__minst"),null,null,null,$asso);
//debug($onwooff);

$logerrs = array();
		for ($i=0;$i<count($onwooff);$i++){
			//echo $i."<br>";
			//debug($onwooff[$i]['Optuser']);
			$criteria4 = $criteria_new2;
			$criteria4[] = "Optuser.tslog > '".$onwooff[$i]['Optuser']['tslog']."'";
			//$criteria4[] = "Optuser.log_status in (3,5)";
			$criteria4[] = "(Optuser.log_status in (3,5) or (Optuser.log_status =1 and Optuser.AccessFrom = ''))";
			$criteria4[] = "Optuser.host_id = ".$onwooff[$i]['Optuser']['host_id'];
			$startorcut = $this->Optuser->findByAsso($criteria4, array("Optuser.tslog as Optuser__tslog,DATEPART(tslog) as Optuser__date,TIMEPART(tslog) as Optuser__time"),"tslog asc","limit 1",null,$asso);
			if(count($startorcut)==1){
				$startorcut[0]['Optuser']['log_status'] = 0;
				$startorcut[0]['Optuser']['con'] = 1;
				$startorcut[0]['Optuser']['AccessFrom'] = $onwooff[$i]['Optuser']['AccessFrom'];
				
				$startorcut[0]['Optuser']['host_id'] = $onwooff[$i]['Optuser']['host_id'];
				$startorcut[0]['Optuser']['account'] = $onwooff[$i]['Optuser']['account'];
				//$startorcut[0]['Optuser']['tslog'] = $onwooff[$i]['Optuser']['tslog'];

				$startorcut[0]['Optuser']['LogonID'] = $onwooff[$i]['Optuser']['LogonID'];
				
				
				$logerrs[] = $startorcut;
				
				//debug($startorcut);
			}
		}
		return $logerrs;
	}
}
?>