<?php
/*********************************************************************
*@filename assets_printer_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment

********************************************************************/
class OperFileserverController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv');
	var $uses=array('Serverfile','Fileserver','Grpauth','Group');
	var $layout='oper';


	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('prt title',$return = true);// 'LVシステム管理／全体設定／センサー';
		//================================yin c=======================
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
		//		debug($_POST, true);
		//================================yin c=======================

	}

	function index($errorMessage = null)
	{
		//    	$glist = array(0 => __('whole',$return = true)); // 'すべて'
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		//		$glist[0] =  __('whole',$return = true);
		ksort($glist);
		$this->set('glist',$glist);
		
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$fields = array('Fileserver.server_id', 'Fileserver.servername');
		//$criteria[]="Fileserver.group_id in (".$group_ids.")";
		$elist = $this->Fileserver->findAll($criteria, $fields, null, null, 1);
		if(!empty($elist)){
			$keys = Set::extract($elist, '{n}.Fileserver.server_id');
			$vals = Set::extract($elist, '{n}.Fileserver.servername');
			$elist = array_combine($keys, $vals);
		}
		$elist = array(""=>"指定なし") + $elist;
		$this->set('elist',$elist);
		
		$this->oplist();
		
		if($errorMessage != null){
			echo "<div id='errmsg'>".
			__('index_error',$return = true).
			"</div>";
		}
	}
	
	function oplist(){
		$olist = array();
		$olist[-1] = __('op_all',$return = true);
		$olist[0] = __('op_access',$return = true);
		$olist[10] = __('op_update',$return = true);
		$olist[2] = __('op_create',$return = true);
		$olist[8] = __('op_copy',$return = true);
		$olist[7] = __('op_move',$return = true);
		$olist[6] = __('op_rename',$return = true);
		$olist[3] = __('op_delete',$return = true);
		$this->set('olist',$olist);
	}
	
	function listdriver($csv = null)
	{
		$this->layout="ajax";
		
		$this->oplist();
		
		$criteria[]="1=1";
		//入力データ取得
		if(!empty($this->data['Date']['start']) && !empty($this->data['Time']['start'])){
			$starttime = $this->data['Date']['start']." ".$this->data['Time']['start'];
			$endtime = $this->data['Date']['end']." ".$this->data['Time']['end'];
			$criteria[]="Serverfile.operation_time between '".$this->Lv->spec_char_dbm($starttime)."' and '".$this->Lv->spec_char_dbm($endtime)."'";
		}
	
		if(!empty($this->data['Fileserver']['server_name']))
			$criteria[]="Fileserver.server_id = '".$this->Lv->spec_char_dbm($this->data['Fileserver']['server_name'])."'";

		if(!is_null($this->data['Serverfile']['operation'])){
			$op_input = $this->data['Serverfile']['operation'];
			if($op_input != -1)
				$criteria[]="Serverfile.operation = '".$this->Lv->spec_char_dbm($op_input)."'";
		}
		
		//var_dump($this->data['Netscan']['count']);
		$count = $this->data['Netscan']['count'];
		if(!is_numeric($count))
			$count = 20;
		//echo $count;
		
		if(!empty($this->data['Serverfile']['file_name']))
			if(!empty($this->data['Filename']['part']))
				$criteria[]="Serverfile.file_name like '%".$this->Lv->spec_char_dbm($this->data['Serverfile']['file_name'])."%'";
			else
				$criteria[]="Serverfile.file_name = '".$this->Lv->spec_char_dbm($this->data['Serverfile']['file_name'])."'";
		
		if(!empty($this->data['Serverfile']['extention']))
			if(!empty($this->data['Extention']['part']))
				$criteria[]="Serverfile.extention like '%".$this->Lv->spec_char_dbm($this->data['Serverfile']['extention'])."%'";
			else
				$criteria[]="Serverfile.extention = '".$this->Lv->spec_char_dbm($this->data['Serverfile']['extention'])."'";
		
		if(!empty($this->data['Serverfile']['accessfrom']))
			if(!empty($this->data['Accessfrom']['part']))
				$criteria[]="Serverfile.accessfrom like '%".$this->Lv->spec_char_dbm($this->data['Serverfile']['accessfrom'])."%'";
			else
				$criteria[]="Serverfile.accessfrom = '".$this->Lv->spec_char_dbm($this->data['Serverfile']['accessfrom'])."'";
		
//var_dump($this->data);
//var_dump($criteria);
		//取得条件設定
		$asso = array(
			'Serverfile : serverfiles' => array('Serverfile.server_id = Fileserver.server_id'),
			) ;
		
		$fields = array(
			'Serverfile.id',
			'Fileserver.servername',
			'Serverfile.operation_time',
			'Serverfile.operation',
			'Serverfile.username',
			'Serverfile.file_name',
			'Serverfile.extention',
			'Serverfile.directory',
			'Serverfile.username',
			'Serverfile.accessfrom',
		);
	
		//$criteria["GROUP BY"]="Netscan.ip_address";

		//取得
		if($csv == 'csv'){
			$Hrdprts = $this->Fileserver->findByAsso($criteria, $fields, 'Serverfile.operation_time, Serverfile.file_name', null, null, $asso);
		
			$this->csvdown($Hrdprts,1);exit;
		}else{
			$this->Pagination->show = $count;
			list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'lists', 'url'=>'/oper_fileserver/listdriver', 'modelClass'=>'Fileserver', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 
			'sortBy' => $this->Lv->sortBy(
				'Serverfile.operation_time, Serverfile.file_name')));
			$Hrdprts = $this->Fileserver->findByAsso($criteria, $fields, $order, $limit, $page, $asso);
			$Hrdprts2 = $this->Fileserver->findByAsso($criteria, $fields, null, null, null, $asso);
		}
		
//debug($Hrdprts);

		//表示データ設定
		!empty($Hrdprts)?$this->set('data',$Hrdprts):$this->set('data',"");
		$this->set('device_count',count($Hrdprts2));
		$this->set('countperpage',$count);	

		$this->render('drivers');
	}

	function csvdown($data,$flag)
	{
		//$parent = $this->data['Selector']['parent_group'];
		$group = $this->data['Group']['group_name'];
		
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group));
		$group_n= $this->Group->findAll($criteria);
		$parent = $group_n[0]["Group"]["parent_id"];
		
		$this->data['Csv']['group'] = $this->groupName($group);
		
		$this->data['Csv']['host'] = $this->data['Host']['host_name'];
		$this->data['Csv']['file'] = $this->data['Serverfile']['file_name'];
		$this->data['Csv']['ext'] = $this->data['Serverfile']['extention'];
		
		if(!empty($this->data['Host']['part']))
			$this->data['Csv']['host'] .= "(".__('part_conform', $return = true).")";
		if(!empty($this->data['Serverfile']['part']))
			$this->data['Csv']['file'] .= "(".__('part_conform', $return = true).")";
		

		require_once( 'csv/DlFactory.php' );
		
		$filename="";


		$csv = DlFactory::create("assets_filescan");
		if($flag == 1){
			$array = array(
				'Group/group_name'=>__('group_name', $return = true),
				'Host/host_name'=>__('host_name', $return = true),
				'Serverfile/file_name'=>__('file_name', $return = true),
				'Serverfile/extention'=>__('extention', $return = true),
				'Serverfile/size'=>__('size', $return = true),
				'Serverfile/directory'=>__('directory', $return = true),
				'Serverfile/file_modify'=>__('file_modify', $return = true),
				'Serverfile/polling_time'=>__('polling_time', $return = true),
			);
			
			$filename=__('csv_file1',$return=true);
		}

		$csv->special_cols=$array;
		//debug($data);
		$csv->sendCSVFile($data,$this->data, $filename);

		exit;
	}
	
	function detail($fileid)
	{
		$this->oplist();
		
		$this->layout="ajax";
		$criteria = array("Serverfile.id =".$this->Lv->spec_char_dbm($fileid));
		$asso = array(
			'Fileserver : fileservers' => array('Serverfile.server_id = Fileserver.server_id'),
			) ;
		
		$fields = array(
			'Serverfile.id',
			'Fileserver.servername',
			'Serverfile.operation_time',
			'Serverfile.operation',
			'Serverfile.username',
			'Serverfile.file_name',
			'Serverfile.extention',
			'Serverfile.directory',
			'Serverfile.subfile_name',
			'Serverfile.subdirectory',
			'Serverfile.username',
			'Serverfile.accessfrom',
		);
	
		//$criteria["GROUP BY"]="Netscan.ip_address";
//var_dump($criteria);
		//取得
		$files = $this->Serverfile->findByAsso($criteria, $fields, null, null, null, $asso);
		if(count($files) > 0)
			$this->set('output',$files[0]);	
	}
	
	function groupName($group_id)
	{
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}
}
?>