<?php
class SystemAllActivedirectoryController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','GenerateFiles','Check');
	var $uses=array('Configure','Validation','Activedirectory');
	var $layout='system';

	function beforeFilter()
	{
		parent::beforeFilter();
	}
	function index($a=null)
	{
		$this->pageTitle =__('title',$return = true);
		
		$ad = $this->Activedirectory->find();
		$domain_name  = $ad['Activedirectory']['domain_name'];
		$domain_controller  = $ad['Activedirectory']['dc'];
		$domain_admin  = $ad['Activedirectory']['adminuser'];
//var_dump($ad);
		$this->set('domain_name', $domain_name);
		$this->set('domain_controller', $domain_controller);
		$this->set('domain_admin', $domain_admin);
		$this->render('index');
	}

	function update($f=null)
	{   
		$this->pageTitle =__('title',$return = true);
		$this->layout='ajax';
		$errorMessage = array();

		if($f=='init'){
			$ad = $this->Activedirectory->find();
			if(!empty($ad)){
				$this->data['Activedirectory']['domain_name'] = $ad['Activedirectory']['domain_name'];
				$this->data['Activedirectory']['domain_controller'] = $ad['Activedirectory']['dc'];
				$this->data['Activedirectory']['adminuser'] = $ad['Activedirectory']['adminuser'];
				//$this->data['Activedirectory']['password'] = $ad['Activedirectory']['password'];
				//$this->data['Activedirectory']['rpassword'] = $ad['Activedirectory']['password'];
			}
			$this->set('checked', false);
		}else if($f==1){//check
			$domain_name  = $this->data['Activedirectory']['domain_name'];
			$domain_controller  = $this->data['Activedirectory']['domain_controller'];
			$adminuser  = $this->data['Activedirectory']['adminuser'];
			$password  = $this->data['Activedirectory']['password'];
			$rpassword  = $this->data['Activedirectory']['rpassword'];
			//入力のチェック
			if($domain_name == ""){
				$errorMessage['domain_name'][]= 'E-00100';
			}
			if($domain_controller == ""){
				$errorMessage['domain_controller'][]= 'E-00100';
			}
			if($adminuser == ""){
				$errorMessage['domain_admin'][]= 'E-00100';
			}
			if($password == ""){
				$errorMessage['password'][]= 'E-00100';
			}
			if($rpassword == ""){
				$errorMessage['rpassword'][]= 'E-00100';
			}
			
			if(!$this->Check->checkAllHalf($domain_name)){
				$errorMessage['domain_name'][] = 'E-00400';
			}
			if(!$this->Check->checkAllHalf($domain_controller)){
				$errorMessage['domain_controller'][] = 'E-00400';
			}
			if(!$this->Check->checkAllHalf($adminuser)){
				$errorMessage['domain_admin'][] = 'E-00400';
			}
			if(!$this->Check->checkAllHalf($password)){
				$errorMessage['password'][] = 'E-00400';
			}
				
			if($password != $rpassword)
			{
				$errorMessage['password'][] = 'E-01400';
			}
			
			//接続確認
			if(empty($errorMessage)){
				$connect = $this->_checkConnect($domain_controller, $adminuser, $password);
				//echo $connect;
				if($connect != 0)
					$errorMessage['connect'][] = 'connect_error';
			}
			
			$this->set('errorMessage',$errorMessage);

			if(empty($errorMessage)){
				$this->set('checked', true);
				//$this->layout='system';
			}else{
				$this->set('checked', false);
				//$this->layout='system';
			}
		}else if($f==2){//save
			$domain_name  = $this->data['Activedirectory']['domain_name'];
			$domain_controller  = $this->data['Activedirectory']['domain_controller'];
			$adminuser  = $this->data['Activedirectory']['adminuser'];
			$password  = $this->data['Activedirectory']['password'];

			$add = array('Activedirectory' => array(
					'domain_name' => $this->Lv->spec_char_dbm($domain_name),
					'dc' => $this->Lv->spec_char_dbm($domain_controller),
					'adminuser' => $this->Lv->spec_char_dbm($adminuser),
					'password' => $this->Lv->save_encode($password)
				)
			);
			$this->Activedirectory->deleteAll(array("1=1"));
			$this->Activedirectory->save($add);

			$this->redirect("/system_all_activedirectory/");
		}

	}

	function decode($license_code)
	{
		$new_code = str_replace(" - ", "", $license_code);
		$v_path=(VENDORS);

		$tmpfname = tempnam("/tmp", "DECODE");
		rename($tmpfname, $tmpfname . ".exe");
		$tmpfname = $tmpfname . ".exe";
		copy(sprintf("%sdecode.exe", $v_path), $tmpfname);
		session_write_close();									//add by wzy at 2007-09-18 for exec() no bug
		$result = exec( sprintf("%s %s", $tmpfname,$new_code) );
		session_start();										//add by wzy at 2007-09-18 for exec() no bug
		unlink($tmpfname);

		return $result;
	}
		
	function set_str_encoding($name)
    {
        $result= mb_convert_encoding($name,__('CharacterSet',$retrun=true),"UTF-8"); 
        return $result;
    } 
	
	function _checkConnect($domain_controller, $domain_admin, $domain_password){
		//設定ファイル内容
		$contents = "[Config]\r\n";
		$contents .= "Type=WMI";
		$contents .= "\r\n";
		$contents .= "Mode=Connect";
		$contents .= "\r\n";
		$contents .= "DomainController=".$domain_controller;
		$contents .= "\r\n";
		$contents .= "UserName=".$domain_admin;
		$contents .= "\r\n";
		$contents .= "PassWord=".$domain_password;
		$contents .= "\r\n";
		
		//一時ファイル作成　BEGIN
		$filename = "ad".substr(md5(time().rand(0,1000000)),0,10) . ".ini";
		$csv_folder=ROOT.DS.APP_DIR.DS."tmp".DS."csv".DS;
		$file = $csv_folder.$filename;
		$fp = fopen($file, 'w');  

		$enc= $this->set_str_encoding($contents);
		fputs($fp, $enc);
		
		fclose($fp);
	
		//exe実行
		$v_path=(VENDORS);
		$tmpfname = "LvADCheckTool.exe";
		$wd = getcwd();
		chdir($v_path);
		$result = exec( sprintf("%s \"%s\"", $tmpfname, $file), $output, $return_var);

		//一時ファイル削除
		unlink($file);
		chdir($wd);
		return $return_var;
	}
	
	
}
?>