<?php
/*********************************************************************
*@filename       system_grpset_services_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2008/12/23   modify for LV20R1-131
*            2.0        sunhy        2009/05/05   modify for YBR-33
********************************************************************/
class SystemGrpsetServicesController extends AppController {
	var $name = 'SystemGrpsetServices';
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Grpsvc','Group','Rltgrpsvc','Grpauth', 'Configure','Validation','Uselgcsvc');
	var $layout='system';


	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle = __('title',$return = true);
		//$this->Configure->write('debug', 0);
	}
	function index($flag=null) {
		if($flag==1){
			$this->layout='ajax';
		}

		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		//ksort($glist);
		$this->set('glist',$glist);

		//$criteria[]=" Group.id=".$this->data['optweb']['group']." ";
		$criteria[]="Grpauth.org_grp_id=".$this->_getUserGroup();
		$asso = array(
		'Group : groups' => array('Grpsvc.group_id = Group.id'),
		'Grpauth : grpauths' => array('Grpsvc.group_id = Grpauth.group_id'),
		);
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'change', 'url'=>'/system_grpset_services/index/1', 'modelClass'=>'Grpsvc', 'queryType' => array('function' => 'findByAsso','asso'=>$asso), 'sortBy' => $this->Lv->sortBy('Grpsvc.group_id'), 'ajaxFormId'=>'form1'));
		$result = $this->Grpsvc->findByAsso($criteria, array('Grpsvc.service_name', 'Grpsvc.id','Grpsvc.specification','Grpsvc.disp_name','Group.group_name','Grpsvc.group_id'),$order,$limit, $page, $asso);
		//$this->set('count',$result1=$this->Grpsvc->findByAsso($criteria, array('count(*) as count'),null,null, null, $asso));

		//sunhy start 2009/05/05 added for YBR-33
		$result = empty($result) ? null : $result;
		//sunhy end 2009/05/05 added for YBR-33
		$this->set("result",$result);
		$this->set('glist',$glist);
	}
	function control($depand=null,$yesorno=null) {
		$this->layout='ajax';
		$err=array();
		if($depand=='1'){	////////////変更する/////////////////
			//debug($this->data);
			$this->set('yesorno', $yesorno);
			if(isset($this->data['Grpsvc']['id'])){

				$word_id  = $this->data['Grpsvc']['id'];
				//debug($word_id);
				foreach ($word_id as $check){
					$svc_name=trim($this->data['Grpsvc']['service_name_'.$check]);
					$flag=0;
					foreach ($word_id as $id){
						if(($check != $id) and ($flag ==0)) {
							if ($svc_name == trim($this->data['Grpsvc']['service_name_'.$id])){
								$flag=1;
							}
						}
					}
					if($flag==1){
						if(!(in_array(__('service',$return = true)."　".__('E-01900',$return = true),$err))){
							$err[]=__('service',$return = true)."　".__('E-01900',$return = true);
						}
					}


					if(!$this->Validation->maxLength($this->data['Grpsvc']['disp_name_'.$check],200))
					{

						$err[]=__('show_svc_name',$return = true)."　".__('E-00300',$return = true);


					}
					if(!$this->Validation->maxLength($this->data['Grpsvc']['service_name_'.$check],200))
					{

						$err[]=__('svc_name',$return = true)."　".__('E-00300',$return = true);


					}
					if(!$this->Validation->maxLength($this->data['Grpsvc']['specification_'.$check],2000))
					{

						$err[]=__('specification',$return = true)."　".__('E-00300',$return = true);


					}


					if($this->Lv->is_empty($this->data['Grpsvc']['disp_name_'.$check]))
					{
						$err[]=__('show_svc_name',$return = true)."　".__('E-00100',$return = true);
					}
					if($this->Lv->is_empty($this->data['Grpsvc']['service_name_'.$check]))
					{
						$err[]=__('svc_name',$return = true)."　".__('E-00100',$return = true);
					}
					if($this->Lv->is_empty($this->data['Grpsvc']['specification_'.$check]))
					{
						$err[]=__('specification',$return = true)."　".__('E-00100',$return = true);
					}



					if(!$this->Check->checkAllHalf($this->data['Grpsvc']['service_name_'.$check]))
					{
						$err[]=__('svc_name',$return = true)."　".__('E-00400',$return = true);
					}

					if(!empty($err)){
						$this->set('seccess',1);
					}
					if(empty($err))
					{
						$updid=$this->data['Grpsvc']['group_'.$check];
						$upddispname=trim($this->Lv->spec_char_dbm($this->data['Grpsvc']['disp_name_'.$check]));
						$updsvcname=trim($this->Lv->spec_char_dbm($this->data['Grpsvc']['service_name_'.$check]));
						$updspec=trim($this->Lv->spec_char_dbm($this->data['Grpsvc']['specification_'.$check]));
						//echo echo echo "$updid";
						$condition="service_name='$updsvcname' and group_id=$updid";
						$result=$this->Grpsvc->findAll($condition,null,null,'0',null,null);
						if(count($result)<=1){
							//if((count($result)==1)&&($result[0]['Grpsvc']['group_id']==$updid)){
							if(!($this->Lv->is_empty($updid))&&!($this->Lv->is_empty($updsvcname))){
								$insertdate=Array(
								'Grpsvc' => Array(
								'id' => $check,
								'group_id' => $updid,
								'service_name' =>$updsvcname,
								'specification'=>$updspec,
								'disp_name'=>$upddispname
								)
								);
								$this->Grpsvc->save($insertdate);
							}
							//$this->set('seccess',1);
						}
						else{
							if(!(in_array('E-01900',$err))){
								$err[]=__('svc_name',$return = true)."　".__('E-01900',$return = true);
								$this->set('seccess',1);
							}
						}
					}
				}
			}
			else
			{
				$err[]=__('service',$return = true)."　".__('E-00200',$return = true);

				//				$this->set('err', $err);
			}
		}
		elseif($depand=='2'){///////////////削除する////////////////////
			$this->set('yesorno', $yesorno);
			if(isset($this->data['Grpsvc']['id'])){
				//debug($this->data)	;
				$word_id  = $this->data['Grpsvc']['id'];
				foreach ($word_id as $check){
					$this->Grpsvc->del($check);                     // grpsvcsテーブル操作 //
					//		         	$groupid=$this->data['Grpsvc']['group_'.$check];
					//		         	$condition = "service_id=$check and org_grp_id=$groupid";
					//		         	$result = $this->Rltgrpsvc->findAll($condition,null,null,'0',null,null);
					//		         	//debug($result);
					//  	         	    foreach ($result as $rs){
					//	        			$this->Rltgrpsvc->del($rs['Rltgrpsvc']['id']);// rltgrpsvcsテーブル操作 //
					//		         	}
				}
			}
			else
			{
				$err[]=__('service',$return = true)."　".__('E-00200',$return = true);
				//				$this->set('err', $err);
			}
		}
		elseif($depand=='3'){/////////////////追加する/////////////
			$this->set('yesorno', $yesorno);
			//debug($this->data);
			$addgroupid=$this->data['Grpsvc']['add_group_id'];
			if($this->data['Grpsvc']['add_disp_name']==""){
				$adddispname=$this->Lv->spec_char_dbm($this->data['Grpsvc']['add_svcs_name']);
			}
			else{
				$adddispname=$this->Lv->spec_char_dbm($this->data['Grpsvc']['add_disp_name']);
			}
			$addsvcsname=trim($this->Lv->spec_char_dbm($this->data['Grpsvc']['add_svcs_name']));
			$addspec=trim($this->Lv->spec_char_dbm($this->data['Grpsvc']['add_spec']));

			$condition="service_name='$addsvcsname' and group_id=$addgroupid"; ////////////////////　不重　//////////////////////////////////
			$result=$this->Grpsvc->findAll($condition,null,null,'0',null,null);
			if(empty($result)){
				if((!empty($addgroupid)&&!empty($addsvcsname))){ ////////////////////////////// grpsvcsテーブル操作　///////////////////////////
					if(!$this->Validation->maxLength($addsvcsname,200))
					{
						$err[]=__('svc_name',$return = true)."　".__('E-00300',$return = true);
					}
					if(!$this->Validation->maxLength($addspec,2000))
					{
						$err[]=__('specification',$return = true)."　".__('E-00300',$return = true);
					}
					if(!$this->Validation->maxLength($adddispname,200))
					{
						$err[]=__('show_svc_name',$return = true)."　".__('E-00300',$return = true);
					}

					if($this->Lv->is_empty($adddispname))
					{
						$err[]=__('show_svc_name',$return = true)."　".__('E-00100',$return = true);
					}

					if($this->Lv->is_empty($addsvcsname))
					{
						$err[]=__('svc_name',$return = true)."　".__('E-00100',$return = true);
					}

					if($this->Lv->is_empty($addspec))
					{
						$err[]=__('specification',$return = true)."　".__('E-00100',$return = true);
					}

					if(!$this->Check->checkAllHalf($addsvcsname))
					{
						$err[]=__('svc_name',$return = true)."　".__('E-00400',$return = true);
					}
					if(!empty($err)){
						$this->set('seccess',1);
					}
					if(empty($err))
					{
						$insertdate=Array(
						'Grpsvc' => Array(
						'group_id' => $addgroupid,
						'service_name' =>  $addsvcsname,
						'specification' => $addspec,
						'disp_name'=>$adddispname
						)
						);
						$this->Grpsvc->save($insertdate);
						$result = $this->Grpsvc->getLastInsertID();//////////////////////// rltgrpsvcs テーブル操作 ////////////
						$glist = $this->Grpauth->getChildrenByParent($addgroupid);
						foreach ($glist as $key=>$value){
							$insertdate=Array(
							'Rltgrpsvc' => Array(
							'group_id' => $key,
							'service_id' =>  $result,
							'org_grp_id' => $addgroupid,
							)
							);
							$this->Rltgrpsvc->save($insertdate); 		//////////////////////////////////////////////////////////////////////////
						}
						$this->data['Grpsvc']['add_disp_name']="";
						$this->data['Grpsvc']['add_svcs_name']="";
						$this->data['Grpsvc']['add_spec']="";

					}

				}
				else
				{
					if(empty($addgroupid))
					{
						$err[]=__('group',$return = true)."　".__('E-00100',$return = true);
					}
					if(empty($addsvcsname))
					{
						$err[]=__('svc_name',$return = true)."　".__('E-00100',$return = true);
					}
					$this->set('seccess',1);
				}
			}
			else
			{
				$err[]=__('service',$return = true)."　".__('E-01900',$return = true);
				$this->set('seccess',1);
			}
		}
		//$this->search();
		$this->set('err', $err);
		$this->index();
		$this->render('control');
		exit();

	}
	function add($add){
		$this->layout='ajax';
		$err=array();
		if ($add ==1){
			//debug($this->data);
			if(isset($this->data['Grpsvc']['add_id']))
			{
				$word_id  = $this->data['Grpsvc']['add_id'];
				//debug($word_id );
				foreach ($word_id as $check){

					$svcname = $this->Lv->spec_char_dbm($this->data['Grpsvc']['svc_name'.$check]);
					$spec = $this->Lv->spec_char_dbm($this->data['Grpsvc']['spec'.$check]);
					$dispname = $this->Lv->spec_char_dbm($this->data['Grpsvc']['show_svc_name'.$check]);

					$flag=0;
					foreach ($word_id as $id){
						if(($check != $id) and ($flag ==0)) {
							if ($svcname == $this->data['Grpsvc']['svc_name'.$id]){
								$flag=1;
							}
						}
					}
					if($flag==1){
						if(!(in_array(__('service',$return = true)."　".__('E-01900',$return = true),$err))){
							$err[]=__('service',$return = true)."　".__('E-01900',$return = true);
						}
					}

					else{
						$groupid=$this->data['Grpsvc']['groupid'];

						$condition="service_name = '$svcname' and group_id = $groupid";
						$result = $this->Grpsvc->findAll($condition,null,null,'0',null,null);
						if (!empty($result)){
							if(!(in_array(__('service',$return = true)."　".__('E-01900',$return = true),$err))){
								$err[]=__('service',$return = true)."　".__('E-01900',$return = true);
							}
						}

						if($dispname==""){
							$dispname=$svcname;
						}
						//

						if(!empty($svcname)){

							//						debug($dispname);
							if(!$this->Validation->maxLength($dispname,200))
							{
								$err[]=__('show_svc_name',$return = true)."　".__('E-00300',$return = true);
							}

							if(empty($err))
							{
								empty($dispname)? $dispname=$svcname:null;
								$insertdate=Array(
								'Grpsvc' => Array(
								'group_id' => $groupid,
								'service_name' =>$svcname,
								'disp_name' => $dispname,
								'specification' => $spec
								)
								);
								//								debug($insertdate);
								$this->Grpsvc->save($insertdate);
								$result = $this->Grpsvc->getLastInsertID();
								$glist = $this->Grpauth->getChildrenByParent($groupid);
								foreach ($glist as $key=>$value){
									$insertdate=Array(
									'Rltgrpsvc' => Array(
									'group_id' => $key,
									'service_id' =>  $result,
									'org_grp_id' => $groupid,
									)
									);
									//debug($insertdate);
									$this->Rltgrpsvc->save($insertdate); 		//////////////////////////////////////////////////////////////////////////
								}
							}
						}
					}
				}
				if(empty($err))
				{
					$this->index();$this->render('index');exit();
				}
			}
			else
			{
				$err[]=__('service',$return = true)."　".__('E-00200',$return = true);
			}

		}

		$this->set('err', $err);
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		//ksort($glist);
		$this->set('glist',$glist);

		$this->search($err);
	}
	function search($err=null){
		if(!isset($err))
		{
			$err=null;
		}
		if(isset($this->data['Grpsvc']['searchname'])){
			$searchname  = $this->data['Grpsvc']['searchname'];
			$searchspec   = $this->data['Grpsvc']['searchspec'];
		}
		else{
			if(isset($this->data['Grpsvc']['hsvcname'])){
				$searchname   = $this->data['Grpsvc']['hsvcname'];
				$searchspec   = $this->data['Grpsvc']['hspec'];
			}
			else{
				$searchname='';
				$searchspec='';
			}
		}

		if(!$this->Validation->maxLength($searchname,200))
		{
			$err[]=__('svc_name',$return = true)."　".__('E-00300',$return = true);
		}
		if(!$this->Validation->maxLength($searchspec,2000))
		{
			$err[]=__('specification',$return = true)."　".__('E-00300',$return = true);
		}
		if(!$this->Validation->alphaNumeric($searchname))
		{
			$err[]=__('svc_name',$return = true)."　".__('E-00400',$return = true);
		}

		$this->set('err',$err);
		$condition = array("1=1");

		if(empty($err))
		{
			$this->set('hsvcname', $searchname);
			$this->set('hspec', $searchspec);


			if(!empty($searchname)){
				//xinw start 20080512
				
				//xinw start 20081223
				//modify for LV20R1-131
				//$condition[] = "lower(service_name) like '%".strtolower($searchname)."%'";
				$condition[] = "lower(Uselgcsvc.service_name) like '%".strtolower($this->Lv->spec_char_like($searchname))."%'";
				//xinw end 20081223
				
				//xinw end 20080512
			}
			if(!empty($searchspec)){
				//xinw start 20080512
				
				//xinw start 20081223
				//modify for LV20R1-131
				//$condition[] ="lower(specification) like '%".strtolower($searchspec)."%'";
				$condition[] ="lower(Uselgcsvc.specification) like '%".strtolower($this->Lv->spec_char_like($searchspec))."%'";
				//xinw end 20081223
				
				//xinw end 20080512
			}

		}

		//xinw start 20081223
		//modify for LV20R1-131
		$asso=array(
		'Temp:(select aa.service_name,max(length(aa.specification)) maximum from uselgcsvcs aa group by aa.service_name)'=>array('Uselgcsvc.service_name=Temp.service_name','length(Uselgcsvc.specification)=Temp.maximum'),
		);
		//xinw end 20081223

		//wq		$condition['GROUP BY']="Usesvc.service_name,Usesvc.specification";
		$condition['GROUP BY']="Uselgcsvc.service_name,Uselgcsvc.specification";
		//		debug($condition,true);
		//echo "condition:".$condition;
		$result = array();
		//wq		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'sub_main', 'url'=>'/system_grpset_services/add/0', 'modelClass'=>'Usesvc', 'queryType' => array('function' => 'findAll'), 'sortBy' => $this->Lv->sortBy('Usesvc.service_name'), 'ajaxFormId'=>'form1'));
		
		//xinw start 20081223
		//modify for LV20R1-131
		//list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'sub_main', 'url'=>'/system_grpset_services/add/0', 'modelClass'=>'Uselgcsvc', 'queryType' => array('function' => 'findAll'), 'sortBy' => $this->Lv->sortBy('UPPER(Uselgcsvc.service_name)'), 'ajaxFormId'=>'form1'));
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'sub_main', 'url'=>'/system_grpset_services/add/0', 'modelClass'=>'Uselgcsvc', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('UPPER(Uselgcsvc.service_name)'), 'ajaxFormId'=>'form1'));
		//xinw end 20081223
		
		//wq		$result =$this->Usesvc->findAll($condition,array('Usesvc.service_name', 'Usesvc.specification'),$order,$limit,$page,-1);
		
		//xinw start 20081223
		//modify for LV20R1-131
		//$result =$this->Uselgcsvc->findAll($condition,('Uselgcsvc.service_name , Uselgcsvc.specification'),$order,$limit,$page,-1);
		$result =$this->Uselgcsvc->findByAsso($condition,array('Uselgcsvc.service_name','Uselgcsvc.specification'),$order,$limit,$page,$asso);
		//xinw end 20081223
		
		//		debug($condition);
		$this->set('result', $result);
		//$this->set('count',$result1 =$this->Usesvc->findAll($condition,'count(*) as count',null,null,null,null));

	}
}
?>
