<?php
class SystemGrpsetTargetextController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
	var $uses=array('Group', 'Host','Rlthstgrp','Grpauth','Authority','Rltuserauth','User','Configure','Validation',
	'Targetext');
	var $layout='system';
	
	
	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('title',$retrun=true); 
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index($errorMessage = null)
	{
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		ksort($glist);
		$this->set('glist',$glist);
		
		$groups = "";
		$this->Group->unbindModel(array('hasMany' => array('Grpauth')));
		$gtree = $this->Group->findAllThreaded(null, null, 'Group.group_name', $this->_getUserGroup());
		$temp = $this->Group->findAllById($this->_getUserGroup());
		$temp[0]['Parentgroup'] = array('id' => NULL, 'parent_id' => NULL, 'group_name' => NULL);
		$temp[0]['children'] = $gtree;
		$gtree = $temp;
		//var_dump($gtree);
		
		foreach($glist as $gid => $gname)
		{
			$groups .=  $gid.",";
		}
		$groups = substr($groups,0,-1);	//echo $groups;
		
		$criteria = array("Group.id in (".$groups.")");
		$criteria['GROUP BY'] =  "Group.id";
		$asso = array(
			'Targetext : targetexts : left' => array('Group.id = Targetext.group_id'),
		);
		
		$fields = array(
			'Group.id',
			'Group.group_name',
			"GROUP_CONCAT(Targetext.extention order by Targetext.number separator ', ') as Targetext__extentions",
		);
		$data = $this->Group->findByAsso($criteria, $fields, null,null,null, $asso);
		//var_dump($data);
		//$this->set('data', $data);
		$output = array();
		$this->settree($gtree, $data, $output, 0);
	//	var_dump($output);
		$this->set('data', $output);
		
	}
	
	function settree(&$gtree, &$data, &$output, $layer){
		foreach($gtree as $num => $group1){
			foreach($data as $d){
				if($group1["Group"]["id"] == $d["Group"]["id"]){
					$gtree[$num]["Targetext"] = $d["Targetext"];
					break;
				}
			}
			unset($gtree[$num]["Parentgroup"]);
			$temp["Group"]["layer"] = $layer;
			$temp["Group"]["id"] = $gtree[$num]["Group"]["id"];
			$temp["Group"]["group_name"] = $gtree[$num]["Group"]["group_name"];
			$temp["Targetext"] = $gtree[$num]["Targetext"];
			$output[] = $temp;
			
			$this->settree($gtree[$num]["children"], $data, $output, $layer+1);	
		}
	}
	
	function search($group_id = null)
	{
		$this->layout="ajax";
		
		if(!empty($this->data['Group']['id']))
			$group_id = $this->data['Group']['id'];
		
		$gd = $this->Group->findById($group_id);
		$this->set('group_name', $gd['Group']['group_name']);

		$data = array();
		//既存設定の読み込み
		$setting = $this->Targetext->find(array('Targetext.group_id' => $group_id));
		if(empty($setting))
			$data['Targetext']['group_id'] = $group_id;
		else
			$data['Targetext'] = $setting['Targetext'];
			
		$this->set('data', $data);
		
		$this->set('group_id', $group_id);
		//debug($this->data);
	}
	
	function form($group_id, $rand){
		$this->layout='ajax';

		$gd = $this->Group->findById($group_id);
		$this->set('group_name', $gd['Group']['group_name']);
		
		//既存設定の読み込み
		$settings = $this->Targetext->findAll(array('Targetext.group_id' => $group_id));
		if(empty($settings)){
			$this->set('exists', false);
		}else{
			$this->set('exists', true);
		}
		
		$this->data['Targetext']['group_id'] = $group_id;
		$this->set('count',count($settings));
		$this->set('confs',$settings);
		//debug($this->data);
	}
	
	function addline($count){
		$this->layout='ajax';
		
		$this->set('myid', $count);
	}
	
	function update()
	{
		$this->layout="ajax";
		$group_id = $this->data['Targetext']['group_id'];

		$err= array();
		$errline= array();

//var_dump($this->data['conf']);

		$adddatas = array();
		$number = 0;
		foreach($this->data['conf'] as $i => $conf){
			$lineid = trim($conf['Targetext']['id']);
			$extention = trim($conf['Targetext']['ext']);
		//	echo $i."-".$extention;
			//値のチェック
			$valid = true;
			if($this->Validation->blank($extention)){
				$err['blank']=__('blank_error',$return = true);
				$valid = false;
			}
			if(!$this->Check->checkAllHalf($extention)){
				$err['allhalf'] = __('E-00400',$return = true);
				$valid = false;
			}
			if(!$this->Validation->maxLength($extention,40)){
				$err['length'] = __('E-00300',$return = true);
				$valid = false;
			}
			
			foreach($this->data['conf'] as $j => $conf2){
				if($i == $j)
					continue;
				$extention2 = trim($conf2['Targetext']['ext']);
				if($extention == $extention2)
				{
					$err['dupe']=__('dupe_error',$return = true);
					$valid = false;
				}
			}
	
			if($valid){
				$adddatas[] = Array(
					'number' => $number,
					'group_id'=> $group_id,
					'extention'=> $extention,
				);
				$errline[$lineid] = 0;
				$number++;
			}else{
				$errline[$lineid] = 1;
			}
		}

		if(count($this->data['conf']) > 10){
			$err['count']=__('count_error',$return = true);
			$valid = false;
		}
		
		$success="";
		$this->set('errline',$errline);
		if(!empty($err))
		{
			$this->set('err',$err);
		}else{
			$success=__('success',$return = true);
			$this->Targetext->deleteAll(array('group_id ='.$group_id));
			//追加
			foreach($adddatas as $add){
				$this->Targetext->save($add);
			}
			$this->GenerateFiles->hook_by_ps(0, array('targetext'), 1);
		}
		$this->set('success',$success);	
	}
	
	function delete()
	{
		$this->layout="ajax";
		$group_id = $this->data['Targetext']['group_id'];
		
		$this->Targetext->deleteAll(array('group_id ='.$group_id));
		
		$this->GenerateFiles->hook_by_ps(0, array('targetext'), 1);
		
		exit();
	}
}
?>