<?php
class SystemGrpsetUsersController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
    	var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
    	var $uses=array('User','Group','Grpauth','Rltuserauth','Authority','Configure','Mail','Validation','Someauth');
    	var $layout='system';
    	function beforeFilter()
    	{
		parent::beforeFilter();
		if(isset($_POST['forHideVar'])){
    			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
	    		$this->set('forHideVar', $_POST['forHideVar1']);
		}
    	}   	
     	function index()
    	{
    		$this->pageTitle = __('title',$return = true);
		 	$search= $this->requestAction('/system_grpset_users/search',array('return'));
		 	$this->set('search',$search);
    	}
     	function search($type ="", $unlock_userid = null)
    	{
			$this->layout = 'ajax';
			$errorMessage = array();
			$own_user_id = $this->_getUserGroup();
			if($type == "unlock" && !is_null($unlock_userid)){
				$update = array(
						'id' => $unlock_userid,
						'errorcount' => 0,
						'errortime' => 0
					);//debug($update);
				$this->User->save($update);
			}
		
			if(!$this->Lv->is_empty($this->data['User']['user_name'])){
				if(!$this->Check->checkAllHalf($this->data['User']['user_name']) || !$this->Validation->maxLength($this->data['User']['user_name'],127)){
					if(!$this->Validation->maxLength($this->data['User']['user_name'],127)){
						$errorMessage['user name'][] = 'E-00300';
					}				
					if(!$this->Check->checkAllHalf($this->data['User']['user_name'])){
						$errorMessage['user name'][] = 'E-00400';
					}
				}	
			}
			if(!$this->Lv->is_empty($this->data['Mail']['mail_address'])){
				if(!$this->Check->checkAllHalf($this->data['Mail']['mail_address']) || !$this->Validation->maxLength($this->data['Mail']['mail_address'],256)){
					if(!$this->Validation->maxLength($this->data['Mail']['mail_address'],256)){
						$errorMessage['mail_address'][] = 'E-00300';
					}
					if(!$this->Check->checkAllHalf($this->data['Mail']['mail_address'])){
						$errorMessage['mail_address'][] = 'E-00400';
					}
				}				
			}
			if(!$this->Lv->is_empty($this->data['User']['etc'])){
				if(!$this->Validation->maxLength($this->data['User']['etc'],100)){
					$errorMessage['etc'][] = 'E-00300';
				}			
			}
			if(!empty($errorMessage)){
				$this->set('errorMessage',$errorMessage); 
			}
			else{
				
				$criteria[] = "lower(User.user_name) like '%".strtolower($this->Lv->spec_char_like($this->data['User']['user_name']))."%'";	
				if($this->data['Mail']['mail_address'] == '' || $this->data['Mail']['mail_address'] == ' '){
					$criteria[] = "(lower(Mail.mail_address) like '%".strtolower($this->Lv->spec_char_like($this->data['Mail']['mail_address']))."%' OR Mail.mail_address is NULL)";				
				}else{
					$criteria[] = "(lower(Mail.mail_address) like '%".strtolower($this->Lv->spec_char_like($this->data['Mail']['mail_address']))."%')";
				}			
				if($this->data['User']['etc'] == '' || $this->data['User']['etc'] == ' '){
					$criteria[] = "(lower(User.etc) like '%".strtolower($this->Lv->spec_char_like($this->data['User']['etc']))."%' OR User.etc is NULL)";				
				}else{
					$criteria[] = "(lower(User.etc) like '%".strtolower($this->Lv->spec_char_like($this->data['User']['etc']))."%')";
				}
				//wangs end 20080202
			}
			if(!$this->Lv->is_empty($this->data['User']['group_id'])){
				$group_id = $this->data['User']['group_id'];
				if ($group_id == 0){
					$criteria[] = "Grpauth.org_grp_id = $own_user_id";	
				}else{
					$criteria[] = "Group.id = $group_id";
				}			
			}
			else{
//				$criteria[] = "Group.id = $own_user_id";	///changed by wzy at 2007/09/18 for initial
				$criteria[] = "Grpauth.org_grp_id = $own_user_id";
			}				
			$this->pg($criteria,$errorMessage);
    	} 
    	
    	function pg(& $criteria,$errorMessage)
    	{ 		
    		$this->layout='ajax';      		
    		$own_user_id = $this->_getUserGroup();		
    		$glist = $this->Group->getChildrenByParent($own_user_id);
			$tmp=array();
		$tmp[0] ='';
		$glist = $tmp + $glist;
 	 	//$glist[0] = '';
	  	//ksort($glist);	
	 	$this->set('glist',$glist); 
		if (isset($this->data['User']['group_id'])){
			$this->set('flist',$this->data['User']['group_id']); 
		}else{
//			$this->set('flist',$own_user_id); 		///changed by wzy at 2007/09/18 for initial
			$this->set('flist',""); 
		}
	 	$criteria[] = 'User.id <> 0';
		$criteria['GROUP BY'] = 'User.id,User.user_name,Group.group_name,User.etc';
		$asso = array(
			'Mail : mails:left' => array('User.id = Mail.user_id'),
			'Group : groups' => array('User.group_id = Group.id'), 
			'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'), 		
									);																																		
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'view', 'url'=>'/system_grpset_users/search/', 'modelClass'=>'User', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('User.user_name')));						
		
		$lockout_count = 5;
		$lockout_hour = 2;
		$dir=LOG_LIMIT;
		$ini_array = parse_ini_file($dir,true);
		if (!empty($ini_array) ){
			if(ereg("^[0-9]{1,}$",$ini_array['Config']['LockoutCount'])) {
				$lockout_count = $ini_array['Config']['LockoutCount'];
			}
			if(ereg("^[0-9]{1,}$",$ini_array['Config']['LockoutHour'])) {
				$lockout_hour = $ini_array['Config']['LockoutHour'];
			}
		}

		$data = $this->User->findByAsso($criteria, 
			array('User.id as User__id',
			'User.user_name as User__user_name',
'case when (User.errorcount >= '.$lockout_count.' and UNIX_TIMESTAMP() - UNIX_TIMESTAMP(User.errortime) < '.$lockout_hour.'*60*60 ) then User.errortime else 0 end as User__lockout',
			'Group.group_name as Group__group_name',
			'User.etc as User__etc'), $order, $limit, $page, $asso);
		if(!empty($data)){
			$user = array();
			foreach ($data as $key=>$value){
				$user_id = $value['User']['id'];
				if($this->Lv->is_empty($this->data['Mail']['mail_address'])){
					$condition = "Mail.user_id = $user_id";
				}
				else {
					if(!empty($errorMessage)){
						$condition = "Mail.user_id = $user_id";
					}
					else{
						//wangs start 20080202
						//$condition = "Mail.user_id = $user_id and Mail.mail_address like '%".$this->data['Mail']['mail_address']."%'";
						$condition = "Mail.user_id = $user_id and lower(Mail.mail_address) like '%".strtolower($this->Lv->spec_char_like($this->data['Mail']['mail_address']))."%'";
						//wangs end 20080202
					}					
				}
				$mail = $this->Mail->findAll($condition,'Mail.mail_address');
				if (!empty($mail)){
					foreach ($mail as $mail){
						$user[$key]['User']['id'] = $value['User']['id'];
						$user[$key]['User']['user_name'] = $value['User']['user_name'];
						$user[$key]['User']['etc'] = $value['User']['etc'];
						$user[$key]['Group']['group_name'] = $value['Group']['group_name'];
						$user[$key]['Mail'][] = $mail['Mail'];
						$user[$key]['User']['lockout'] = $value['User']['lockout'];
					}					
				}else{
					$user[$key]['User']['id'] = $value['User']['id'];
					$user[$key]['User']['user_name'] = $value['User']['user_name'];
					$user[$key]['User']['etc'] = $value['User']['etc'];
					$user[$key]['Group']['group_name'] = $value['Group']['group_name'];
					$user[$key]['Mail'][] = array('mail_address'=>'');
					$user[$key]['User']['lockout'] = $value['User']['lockout'];					
				}

			}	
		}
		empty($user)? $user=array():$user;	
		$this->set('user',$user); 	 			
		$this->render('pg');
    	} 
    	function userName($user_id){
    		$user = $this->User->find("User.id = $user_id");
    		return $user['User']['user_name'];
    	}
    	function delete()
    	{
    		$this->layout='ajax';  
	    	if(isset($this->data['User']['id'])){
	    		foreach ($this->data['User']['id'] as $id){
	    			$user_id = $this->_getUserId();
	    			$user_name = $this->userName($user_id);	
	    			if ($id == $user_id){
	    				$errorMessage[$user_name][] = 'E-02800';
	    			}
	    		}
	    		if (isset($errorMessage)){
	    			$this->set('errorMessage',$errorMessage); 
	    		}
	    		else{
					foreach($this->data['User']['id'] as $delid){
						$this->User->del($delid);
					}						
	    		}
	    	}
	    	else{
	    		$errorMessage['user name'][] = 'E-00200';
	    		$this->set('errorMessage',$errorMessage); 
	    	}	
		$this->search();	
    		exit();
    	}
    	function adduser($id = null,$input = array())
    	{ 	
    		$this->layout = 'ajax';
    		$own_user_id = $this->_getUserGroup();	
    		$glist = $this->Group->getChildrenByParent($own_user_id);
	 	$this->set('glist',$glist);  
	 	if (empty($input)){
		 	if(!$this->Lv->is_empty($id)){
				$condition = array("User.id = $id");
				$user = $this->User->find($condition);
				$password = $user['User']['password'];
				$pwd = $user['User']['password'];
				$condition = array("Mail.user_id = $id");
				$mail = $this->Mail->findAll($condition);				
				$this->set('password',$password = null);	
				$this->set('pwd',$pwd = null);
				$this->set('user',$user);	
				$this->set('mail',$mail);			 			
		 	}
		 	else{ 	
		 		$this->set('password',$password=null);	
		 		$this->set('pwd',$pwd=null);	 			 			
		 		$this->set('user',$user=null);
		 		$this->set('mail',$mail=array());
		 	}	 		
	 	}else{	
	 		if (isset($this->data['User']['user_name_add'])){
		 		$user['User']['id'] = $this->data['User']['id'];	
		 		$user['User']['password'] = $this->data['User']['pwd_add'];	
		 		$user['User']['user_name'] = $this->data['User']['user_name_add'];
		 		$mail[] = array(
		 			'Mail' => array(
		 				'mail_address' => $this->data['User']['mail_add']
		 			)
		 		);		
		 		$user['User']['group_id'] = $this->data['User']['group_id_add'];
		 		$user['User']['etc'] = $this->data['User']['etc_add'];
		 		$this->set('password',$password=null);	
		 		$this->set('pwd',$pwd=null);	 	 		 			
		 		$this->set('user',$user);
		 		$this->set('mail',$mail);		 			
	 		}
	 		else{
		 		$user['User']['id'] = $input['User']['id'];	
		 		$user['User']['password'] = $input['User']['db_pwd'];	
		 		$user['User']['user_name'] = $input['User']['user_name_edit'];
		 		$mail[] = array(
		 			'Mail' => array(
		 				'mail_address' => $input['Mail']['mail_address_edit']
		 			)
		 		);		
		 		$user['User']['group_id'] = $input['Mail']['group_id'];
		 		$user['User']['etc'] = $input['User']['etc_edit'];
		 		$this->set('password',$password=null);	
		 		$this->set('pwd',$pwd=null);	 	 		 			
		 		$this->set('user',$user);
		 		$this->set('mail',$mail);		 			
	 		}	 				  		
	 	}		 			 	
    	} 
    	function add()
    	{ 	
    		$this->layout = 'ajax';
    		$id = $this->data['User']['id'];
			$uname = $this->Lv->spec_char_dbm($this->data['User']['user_name_edit']);
			$password = $this->data['User']['password'];
			$pwd = $this->data['User']['pwd'];
			$db_pwd = $this->data['User']['db_pwd'];
			$mail = $this->data['Mail']['mail_address_edit'];
			$group = $this->data['Mail']['group_id'];
			$etc = $this->data['User']['etc_edit'];		
			$mail_all = explode(';',$mail);
			
			if($this->Lv->is_empty($uname)){
				$errorMessage['user name'][] = 'E-00100';
			}
			//if(!$this->Validation->alphaNumeric($uname)){
			if($this->Validation->custom($uname, '/[^\\dA-Z-\._]/i')){
				$errorMessage['user name'][] = 'E-00400';
			}
			if(!$this->Validation->maxLength($uname,127)){
				$errorMessage['user name'][] = 'E-00300';
			}

			if(!$this->Validation->maxLength($password,127)){
				$errorMessage['password'][] = 'E-00300';
			}
			if(!$this->Validation->maxLength($pwd,127)){
				$errorMessage['password_conform'][] = 'E-00300';
			}
			
			$dir=LOG_LIMIT;
			$ini_array = parse_ini_file($dir,true);
			if(!($this->Lv->is_empty($password) && $this->Lv->is_empty($pwd))){
				if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['Config']['PasswordLength'])) {
					if(!$this->Validation->minLength($password, $ini_array['Config']['PasswordLength'])){
						$errorMessage['password'][] = $ini_array['Config']['PasswordLength'].__('E-00350', true);
					}
				}
			}
	
			if($password != $pwd){
				$errorMessage['password'][] = __('passwordConform',$return = true);
			}
			
			if(!$this->Validation->maxLength($mail,256)){
				$errorMessage['mail_address'][] = 'E-00300';
			}
			if(!$this->Check->checkAllHalf($mail)){
				$errorMessage['mail_address'][] = 'E-00400';
			}			

			foreach ($mail_all as $value){
				if(!$this->Validation->email($value)){
					$error=1;				
				}			
			}
			if(isset($error) && !$this->Lv->is_empty($mail)){
				$errorMessage['mail_address'][] = 'E-02200';
			}				
			if(!$this->Lv->is_empty($etc) && !$this->Validation->maxLength($etc,100)){
				$errorMessage['etc'][] = 'E-00300';
			}
			
			if(empty($id)){	
				$same_name = $this->User->find("User.user_name = '".$uname."'");	
				if($same_name){
					$errorMessage['user name'][] = 'E-01900';	
				}
				if($this->Lv->is_empty($password)){
					$errorMessage['password'][] = 'E-00100';
				}
				if($this->Lv->is_empty($pwd)){
					$errorMessage['password_conform'][] = 'E-00100';
				}
				if (!isset($errorMessage)){
					$md5_pwd = md5($this->data['User']['password']);	
					$this->data['User']['id']=null;
					$this->data['User']['user_name_add']=$uname;
					$this->data['User']['group_id_add']=$group;
					$this->data['User']['pwd_add']=$md5_pwd;
					$this->data['User']['etc_add']=$etc;
					$this->data['User']['mail_add']=$mail;				
				}					
			}
			else{				
				$same_name = $this->User->find("User.user_name = '".$uname."' AND User.id <> $id");	
				if($same_name){
					$errorMessage['user name'][] = 'E-01900';	
				}else{
					if($this->Check->checkAllHalfAndS($password) && $this->Check->checkAllHalfAndS($pwd)){
						if ($this->Lv->is_empty($password) && $this->Lv->is_empty($pwd)){
							$md5_pwd = $db_pwd;
						}
						else{
							$md5_pwd = md5($this->data['User']['password']);
						}								
						$this->data['User']['id']=$id;
						$this->data['User']['user_name_add']=$uname;
						$this->data['User']['group_id_add']=$group;
						$this->data['User']['pwd_add']=$md5_pwd;
						$this->data['User']['etc_add']=$etc;
						$this->data['User']['mail_add']=$mail;					
					}
					else{
						$errorMessage['password'][] = 'E-03000';	
					}
					
				}
			}		
				
			if(isset($errorMessage)){
				$this->set('errorMessage',$errorMessage); 
				$this->adduser($id,$this->data);					
				$this->render('adduser');
			}
			else {							
				$this->authority();					
				$this->render('authority');			
			}
    	}     	
    	function authority()
    	{ 	
    		$this->layout = 'ajax';
    		$cons = $this->Authority->findAll();
    		$ids = set :: extract($cons, "{n}.Authority.id");
    		$vls = set :: extract($cons, "{n}.Authority.controller_name");
    		$names = set :: extract($cons, "{n}.Authority.authority_name");
    		$cons = array_combine($vls, $ids);
    		$authoritys = array_combine($vls, $names);   		
    		$this->set('cons', $cons);				//controller_name -> authority_id
    		$this->set('authoritys', $authoritys);	//controller_name -> authority_name
    		$this->set_menus();   		
    		$user_id = $this->data['User']['id'];
    		if ($this->Lv->is_empty($user_id)){
    			$user_id = null;
    			$groups = array();
    		}
    		else{
 			$asso = array(
				'Rltuserauth : rltuserauths' => array('Authority.id = Rltuserauth.authority_id'),	
										);																																							
			$authority = $this->Authority->findByAsso(array("Rltuserauth.user_id = $user_id"), array('Authority.id as Authority__id,Authority.controller_name as Authority__controller_name'), null, null, null, $asso);			
		    	if(!empty($authority)){
		    		$keys = Set::extract($authority, '{n}.Authority.controller_name');
				$vals = Set::extract($authority, '{n}.Authority.id');
				$groups = array_combine($keys, $vals);								
		    	}
		    	else {
		    		$groups = array();
		    	}   			
    		}
    		$this->set('id', $user_id);	
    		$this->set('user_name_edit',$this->data['User']['user_name_add']);				
		if (isset($this->data['Rltuserauth'])){
			$groups = array();
		}												    			    							  						
    		$this->data['Rltuserauth'] = $groups;     	
	    	$auth_ass = md5('assetstail');
	    	$ass = $this->Someauth->findAll(array("Someauth.authoritied" => $auth_ass));	
	    	//zhangs start 20080307
	    	$auth_opt = md5('opttail');
	    	$opt = $this->Someauth->findAll(array("Someauth.authoritied" => $auth_opt));
	    	//zhangs end 20080307	 
	    	//jinl start 20080328
	    	$auth_opu = md5('oputail');
	    	$opu = $this->Someauth->findAll(array("Someauth.authoritied" => $auth_opu));
	    	//jinl end 20080328	   	
	    	$auth_oper = md5('opertail');
	    	$oper = $this->Someauth->findAll(array("Someauth.authoritied" => $auth_oper));		    	
	    	$auth_use = md5('usetail');
	    	$use = $this->Someauth->findAll(array("Someauth.authoritied" => $auth_use));
			$auth_alerts = md5('alertstail');
	    	$alertsh = $this->Someauth->findAll(array("Someauth.authoritied" => $auth_alerts));
	    	//yuanxiaojun start 20080523
	    	$backupFlag=0;
	    	if((isset($this->data['Mail']['group_id']) && $this->data['Mail']['group_id'] == 1 )|| (isset($this->data['User']['group_id_add']) && $this->data['User']['group_id_add'] == 1)){
	    		$backupFlag=1;
	    	}
	    	//yuanxiaojun end 20080523
	    	$this->set('backupFlag',$backupFlag); 	
	    	empty($ass)?null:$this->set('ass',$ass); 
	    	empty($oper)?null:$this->set('oper',$oper); 
	    	empty($opt)?null:$this->set('opt',$opt);
	    	//jinl start 20080331
	    	empty($opu)?null:$this->set('opu',$opu);
	    	//jinl end 20080331
		    empty($use)?null:$this->set('use',$use); 
			 empty($alertsh)?null:$this->set('alertsh',$alertsh); 
	    	if(empty($oper) && empty($use)){
	    		$this->set('oper_use',1); 		    		
	    	}    		
    	}  
	function insert()
	{		
		$authority_id=array();
		$authority = array_values($this->data['Rltuserauth']);
		if (!empty($this->data['Rltuserauth']['alerts_webs']) || !empty($this->data['Rltuserauth']['alerts_prints']) || !empty($this->data['Rltuserauth']['alerts_evtusers']) || !empty($this->data['Rltuserauth']['alerts_devices']) || !empty($this->data['Rltuserauth']['alerts_files']) ||  !empty($this->data['Rltuserauth']['alerts_evtlogs']) || !empty($this->data['Rltuserauth']['alerts_services']) || !empty($this->data['Rltuserauth']['alerts_processes']) || !empty($this->data['Rltuserauth']['alerts_vptns']) || !empty($this->data['Rltuserauth']['alerts_apps']) || !empty($this->data['Rltuserauth']['alerts_perfs'])){
			$alerts = $this->Authority->find("Authority.controller_name = 'alerts'");
			$authority_id[] = $alerts['Authority']['id'];				
		}
		foreach ($authority as $value){
			if(!empty($value)){
				$authority_id[] = $value;
			}else{
				$check = 1;
			}
		}
		if(empty($authority_id)){
			$errorMessage['authority'][] = 'E-00200';
			$this->set('errorMessage',$errorMessage); 
			$this->authority();	
			$this->layout = 'system';				
			$this->render('authority');			
		}
		else{
			$count = $this->User->query("select count(*) from users;");			
			if ($count[0][0]['count(*)']==1 && ($this->data['User']['group_id_add'] <>1 || isset($check))){
				$errorMessage[''][] = 'E-03300';
				$this->set('errorMessage',$errorMessage); 
				$auth_tmp = $this->data['Rltuserauth'];
				$this->authority();	
				$this->data['Rltuserauth'] = $auth_tmp;
				$this->layout = 'system';			
				$this->render('authority');				
			}else{
				$id = $this->data['User']['id'];	
				$mail = $this->data['User']['mail_add'];
				$mail_all = explode(';',$mail);			
				if ($this->Lv->is_empty($id)){
					$adduser = array(
						'User' => array(
							'user_name' => $this->data['User']['user_name_add'],
							'password' => $this->data['User']['pwd_add'],
							'etc' => $this->Lv->spec_char_dbm($this->data['User']['etc_add']),
							'group_id' => $this->data['User']['group_id_add'],
						)
					); 					
					if($this->User->save($adduser)){
						$user_id = $this->User->getLastInsertID();
						foreach ($mail_all as $value){
							$addmail = array(
								'Mail' => array(
									'user_id' => $user_id,
									'mail_address' => $value,
								)					
							);  
							$this->Mail->save($addmail);
						}
						$this->GenerateFiles->hook_by_group($this->data['User']['group_id_add'], array('group'));
					}
					$id = $user_id;												
				}
				else{
					$adduser = array(
						'User' => array(
							'id' => $id,
							'user_name' => $this->data['User']['user_name_add'],
							'password' => $this->data['User']['pwd_add'],
							'etc' => $this->Lv->spec_char_dbm($this->data['User']['etc_add']),
							'group_id' => $this->data['User']['group_id_add'],
						)
					); 				
					$this->User->save($adduser);
					$mail_id = $this->Mail->findAll(array("Mail.user_id" => $id),'Mail.id');
					foreach ($mail_id as $out){
						//$del_id[] = $out['Mail']['id'];
						$this->Mail->del($out['Mail']['id']);
					}
					//$this->Mail->del(array($del_id));
					foreach ($mail_all as $value){	
						$addmail = array(
							'Mail' => array(
								'user_id' => $id,
								'mail_address' => $value,
							)					
						);  
						$this->Mail->save($addmail);						
					}
					$this->GenerateFiles->hook_by_group($this->data['User']['group_id_add'], array('group'));				
					$del = $this->Rltuserauth->findAll(array("Rltuserauth.user_id" => $id),'Rltuserauth.id');			
					if(!empty($del)){
						foreach ($del as $value){
							//$del_id[]=$value['Rltuserauth']['id'];
							$this->Rltuserauth->del($value['Rltuserauth']['id']);
						}
						//$this->Rltuserauth->del(array($del_id));
					}										
				}		
				//yuanxiaojun start 20080718
				$backup_id=null;
				$folderchange_id=null;
				$backup=$this->Authority->findAll("controller_name='system_monitor_databackups'",null,null,null,null,null);
				if(!empty($backup)){
				      $backup_id=$backup[0]['Authority']['id'];
				}
				$folderchange=$this->Authority->findAll("controller_name='system_monitor_folderchange'",null,null,null,null,null);	
				if(!empty($folderchange)){
				      $folderchange_id=$folderchange[0]['Authority']['id'];
				}
				foreach ($authority_id as $id_values){
					if($id_values==$backup_id){
						$authority_id[]=$folderchange_id;
					}
				}
                                    //yuanxiaojun end 20080718			
				foreach ($authority_id as $input){
					$addauth = array(
						'Rltuserauth' => array(
							'user_id' => $id,
							'authority_id' => $input,
						)					
					);  	
					
					$this->Rltuserauth->save($addauth);	
					$this->_destroy_menu_session();												
				}													
				$this->redirect("/system_grpset_users/");				
			}
		}		
	} 	
	/***********************************************************/
	/**
	 * add by wzy
	 *
	 */
	function set_menus()
	{
		$auths = $this->Someauth->findAll();
		$auths = set :: extract($auths, "{n}.Someauth.authoritied");
		$this->set_menu('assets', $auths, array('assets_%'), null,2);
		//zhangs start 20080307
		$this->set_menu('opt', $auths, array('opt_%'), null,2);
		//zhangs end 20080307
		//jinl start 20080328
		$this->set_menu('opu', $auths, array('opu_%'), null,2);
		//jinl end 20080328
    	         $this->set_menu('opers', $auths, array('oper_%'), null,2);
		$this->set_menu('uses', $auths, array('use_%'), null,2);
		$this->set_menu('alerts', $auths, array('alerts_%'), array(),2);
		$this->set_menu('uptime', $auths, array('uptime_%'), array(),3);
		$this->set_menu('attendance', $auths, array('attendance_%'), array(),3);
		$this->set_menu('remote', $auths, array('remote_%'), array(),2);
		//yuanxiaojun start 20080529
//		if((isset($this->data['Mail']['group_id']) && $this->data['Mail']['group_id'] == 1 )|| (isset($this->data['User']['group_id_add']) && $this->data['User']['group_id_add'] == 1)){
//			$this->set_menu('system', $auths, array('system_%'), array(), 4);
//			$this->set_menu('system_all', $auths, array('system_all_%'), null, 4);
//		}
//		else {
//			$this->set_menu('system', $auths, array('system_%'), array('system_all_%'), 4);
//		}
		if((isset($this->data['Mail']['group_id']) && $this->data['Mail']['group_id'] == 1 && $_SESSION['asp_id']==0)|| (isset($this->data['User']['group_id_add']) && $this->data['User']['group_id_add'] == 1&& $_SESSION['asp_id']==0)){
			$this->set_menu('system', $auths, array('system_%'), array(), 4);
			$this->set_menu('system_all', $auths, array('system_all_%'), null, 4);
			$this->set_menu('system_monitor', $auths, array('system_monitor_%'), null, 3);
		}
		else {
			$this->set_menu('system', $auths, array('system_2_%'), array('system_all_2_%'), 4);
			$this->set_menu('system_monitor', $auths, array('system_monitor_2_%'), null, 3);
			
		}
		//yuanxiaojun end 20080529
		$this->set_menu('system_grpset', $auths, array('system_grpset_%'), array(),3);
		//yuanxiaojun start 20080529
		//$this->set_menu('system_monitor', $auths, array('system_monitor_%'), null, 3);
		//yuanxiaojun end 20080529
		$this->set_menu('system_userinfos', $auths, array('system_userinfos'), null, 2);
		$this->set_menu('securities', $auths, array('securities'), null, 2);
	}
	/**
	 * add by wzy
	 *
	 * @param unknown_type $title
	 * @param unknown_type $like
	 * @param unknown_type $notlike
	 * @param unknown_type $depth
	 */	
    	function set_menu($title, $auths, $like, $notlike, $depth = 2)
    	{        
    		//yuanxiaojun start 20080529
    		$flag=0;
    		if(!empty($notlike)&&($notlike[0]=='system_all_2_%')){
    		    $notlike[0]='system_all_%';	
    		    $flag=1;
    		}
    		if(!empty($like)&&($like[0]=='system_2_%')){
    		    $like[0]='system_%';	
    		    $flag=2;
    		}
    		if(!empty($like)&&($like[0]=='system_monitor_2_%')){
    		    $like[0]='system_monitor_%';	
    		    $flag=3;
    		}
    		//yuanxiaojun end 20080529
		$menu = array();
		$criteria = array();
		if(!empty($like)){
	    		foreach ($like as $v){
	    			$criteria[] = "Authority.controller_name LIKE '" . $v . "'"; 
	    		}
	    	}
	    	if(!empty($notlike)){
	    		foreach ($notlike as $v){
	    			$criteria[] = "Authority.controller_name NOT LIKE '" . $v . "'"; 
	    		}
	    	}
    		$cons = $this->Authority->findAll($criteria);
    		//yuanxiaojun start 20080610
    		$con_menus=array();
    		$con_menus1 = set :: extract($cons, "{n}.Authority.controller_name");
    		if( $flag==1||$flag==2||$flag==3){
    			
    			foreach ($con_menus1 as $v){
    				if($v!='system_monitor_databackups'&&$v!='system_monitor_folderchange'){
    					$con_menus[]=$v;
    				}
    			}
    		}else{  
    			foreach ($con_menus1 as $v){
    				if($v!='system_monitor_folderchange'){
    					$con_menus[]=$v;
    				}
    			}
    		}
    		//$con_menus = set :: extract($cons, "{n}.Authority.controller_name");
    		//yuanxiaojun end 20080610
    		$unsetcons= array();
    		foreach ($con_menus as $v){
    			if(!in_array(md5($v."tail"), $auths)){
    				continue;
    			}
    			$vs = explode('_', $v);
    			if(count($vs) > $depth){
    				$temp = $vs;
    				unset($temp[count($temp) - 1]);
    				$temp = implode('_', $temp);
    				isset($menu[$temp]) ? $menu[$temp][] = $v
    									: $menu[$temp] = array($v);
    				$unsetcons[] = $temp;
    			}
    			else {
    					$menu[] = $v;
    			}
    		}    		
    		foreach ($menu as $k => $v){
    			if(in_array($v, $unsetcons)){
    				unset($menu[$k]);
    			}
    		}
    		$this->set($title, $menu);
    	}	
	/***********************************************************/
}
?>