<?php
// psauth_controller.php: AppController クラスの具象クラス
/*********************************************************************
*@filename psauth_controller.php
*@description AppController クラスの具象クラス
*@note 
*@histories  rivision	author		date		comment
*			 2.0		yohei		2009/11/04  Mantis 547 PSのMacアドレスを末尾に追加
*            2.0        chenhao     2009/11/09   merge source with so-ten code
*********************************************************************/
//////////////////////////////////////////////////////////////////////
class UpnpController extends AppController
{   
	var $uses=array('Poll','Group', 'Host','Configure', 'Validation','License','User',
		'Remoteport','Remotemac');
	var $components = array("GenerateFiles");

	function beforeFilter()
	{

	}
	
    function open($psid, $tag, $macaddr, $ip, $pc){
		//macアドレス確認
		$mac = $this->Remotemac->find(
			array(
				"Remotemac.macaddr" => $this->Lv->spec_char_dbm($macaddr)
				)
		);
		//あればポート解放
		//無ければmacを登録して終了
		if(empty($mac)){
			$newmac=Array(
					'Remotemac' => Array(
						'macaddr' => $this->Lv->spec_char_dbm($macaddr),
						'hostname' => $this->Lv->spec_char_dbm($pc),
						'ipaddr' => $this->Lv->spec_char_dbm($ip),
						'access_time' => date('Y-m-d H:i:s',time())
					)
				);
			$this->Remotemac->save($newmac);
			echo "deny1";
			exit;
		}else if($mac['Remotemac']['status'] == 1){

		}else{//不許可
			echo "deny2";
			exit;
		}
		
		$port = $this->Remoteport->find(
			array(
				"Remoteport.tag" => $this->Lv->spec_char_dbm($tag),
				"Remoteport.ps_id" => $this->Lv->spec_char_dbm($psid)
				)
		);
		if(empty($port)){
			echo "ng";
			exit;
		}else if($port['Remoteport']['status'] == -1){//close
			$newport=Array(
					'Remoteport' => Array(
					'ps_id' => $psid,
					'status' => 2,
					'tag' => $tag
					)
			);
			$this->Remoteport->save($newport);
				
			$this->GenerateFiles->hook_by_ps($psid, array('remote'));
			echo "ok";
			exit;
		}else{
			echo "ng";
			exit;
		}
	}
	
	function check($psid, $tag){
		$port = $this->Remoteport->find(
			array(
				"Remoteport.tag" => $this->Lv->spec_char_dbm($tag),
				"Remoteport.ps_id" => $this->Lv->spec_char_dbm($psid)
				)
		);
		if(empty($port)){
			exit;
		}else if($port['Remoteport']['status'] == -1){//ポート閉じている
			echo "closed";
		}else if($port['Remoteport']['status'] == 0){//closing
			echo "closing";
		}else if($port['Remoteport']['status'] == 1){//解放
			//ポート状態テーブル更新
			$newport=Array(
				'Remoteport' => Array(
				'ps_id' => $psid,
				'access_time' => date('Y-m-d H:i:s',time()),
				'status' => 3,//接続中
				)
			);
			$this->Remoteport->save($newport);
				
			//接続用の情報
			header("LVREMOTETARGET: ".$port['Remoteport']['ipaddr']);
			header("LVREMOTEPORT: ".$port['Remoteport']['port']);
			header("LVREMOTEUSER: LV_RMUSER");
			$pwd = $port['Remoteport']['password'];
			header("LVREMOTEPASSWORD: ".$pwd);
			header("LVREMOTETAG: ".$tag);
			header("LVREMOTEPSID: ".$psid);
			echo "opened";
		}else if($port['Remoteport']['status'] == 2){//解放処理中
			echo "opening";
		}else if($port['Remoteport']['status'] == 3){//接続中
			echo "used";
		}else if($port['Remoteport']['status'] == 4){//UPnP失敗
			echo "unsupported";
		}
		exit;
	}
	//接続終了後にポートを閉じる
    function close($psid, $tag)
    {	
		$port = $this->Remoteport->find(
			array(
				"Remoteport.tag = '".$tag."'",
				"Remoteport.ps_id = ".$psid
				)
		);
		if(empty($port))
			exit;
		
		//ポート状態テーブル更新
		$newport=Array(
			'Remoteport' => Array(
			'ps_id' => $psid,
			'status' => 0
			)
		);
		$this->Remoteport->save($newport);
		$this->GenerateFiles->hook_by_ps($psid, array('remote'));
    	echo $psid;
		exit;
    }
}
?>