<?php
class UptimeDayConfController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check','GenerateFiles','Holiday');
	var $uses=array('Group', 'Host','Rlthstgrp','Grpauth','Hstalt','Authority','Rltuserauth','User','Configure','Validation',
	'Hsttime','Hstshutdown','Employeetime','Employee','Employeeaccount','Timecontrol','Grpholiday');
	var $layout='uptime';
	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('menu_uptime',$retrun=true); 
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index($errorMessage = null)
	{
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		ksort($glist);
		$this->set('glist',$glist);
		
				//グループ所属の社員ID
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$fields = array('Employee.id', 
		'concat(Employee.id_name, " ", Employee.name) as Employee__name', 
		'Employee.id_name');
		$criteria[]="Employee.group_id in (".$group_ids.")";
		$elist = $this->Employee->findAll($criteria, $fields, "Employee.id_name", null, 1);
		if(!empty($elist)){
			$keys = Set::extract($elist, '{n}.Employee.id');
			$vals = Set::extract($elist, '{n}.Employee.name');
			$elist = array_combine($keys, $vals);
		}
		$elist = array(""=>"全て") + $elist;
		//debug($elist);
		$this->set('elist',$elist);
	}
	
	function getTimecontrol($groupid)
	{
		$default = $this->Timecontrol->find(array("group_id" => $groupid));
		if(empty($default))
		{
			$parent = $this->Group->group_father_id($groupid);
			if(!empty($parent))
				$default = $this->getTimecontrol($parent);
		}
		return $default;
	}
	
	//1週間の期間休暇と祝日をグループごとに取得
	function getDefault($parent, $startdate)
	{
		//祝日の取得
		$holidays = array();
		$date = new DateTime($startdate);
		for($i = 0; $i < 7; $i++){
			$day = $date->format('Y-m-d');
			$unixtime = $date->format('U');
			
			$name = $this->Holiday->ktHolidayName($unixtime);
			if(!empty($name)){
				$holidays[$day] = true;
			}else
				$holidays[$day] = false;
			$date->modify('+1 days');
		}
		
		$glist = $this->Grpauth->getChildrenByParent($parent);
		$defaults = array();
		foreach($glist as $gid => $gname)
		{
			$default = $this->getTimecontrol($gid);
			$defaults[$gid] = $default;
			$defweek = array(
				$default['Timecontrol']['sunday'],
				$default['Timecontrol']['monday'],
				$default['Timecontrol']['tuesday'],
				$default['Timecontrol']['wednesday'],
				$default['Timecontrol']['thursday'],
				$default['Timecontrol']['friday'],
				$default['Timecontrol']['saturday'],
			);

			$date = new DateTime($startdate);
			for($i = 0; $i < 7; $i++){
				$w = (int)$date->format('w');
				$day = $date->format('Y-m-d');
				if($defweek[$w] == 1 || ($default['Timecontrol']['holiday'] == 1 && $holidays[$day])){
					//休み 祝祭日,曜日
					$defaults[$gid]["Vacations"][$day] = true;
				}else{
					$owner_gid = $defaults[$gid]['Timecontrol']['group_id'];
					$cond = array(
						"group_id =".$owner_gid,
						"(('".$day."' between start and end + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND)"
						." or ".
						"('".$day."' = start and end is null))"
						);
					//$cond[] = ;
					$ret = $this->Grpholiday->find($cond);
					//debug($ret);
					if(empty($ret))
						$defaults[$gid]["Vacations"][$day] = false;
					else
						$defaults[$gid]["Vacations"][$day] = true;
				}
					
				$date->modify('+1 days');
			}
			
		}
		return $defaults;
	}
	function search()
	{
		$criteria = array();
		$group_id = $this->data['Group']['id'];
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$criteria[] = "Group.id in (". $group_ids.")";
		$emp_id = $this->data['Employee']['id'];
		if(!empty($emp_id))
			$criteria[] = "Employee.id = ".$emp_id;

		//$criteria[] = groupid
//$criteria['GROUP BY'] = "Employee.id";//
		$criteria['GROUP BY'] = "Host.id";//
		
		$asso = array(
			'Employeeaccount : employeeaccounts : left' => array('Employee.id = Employeeaccount.employee_id'),
			'Host : hosts' => array('Host.id = Employeeaccount.host_id'),
			'Group : groups : left' => array('Group.id = Employee.group_id'),
		);
		
		$fields = array(
			'count(Host.id) as Employee__count',
		);
		$data = $this->Employee->findByAsso($criteria, $fields, null, null, null, $asso);
		//debug($data);
		$peremployee = true;
		foreach($data as $d)
		{
			iF($d['Employee']['count'] != 1)
			{
				$peremployee = false;
				break;
			}
		}
		
		if(!$peremployee)
			$this->search1();//ホスト+アカウント毎に表示
		else
			$this->search2();//社員ごとに表示
		
		$this->set('peremployee', $peremployee);
	}
	
	//同じホストが複数登録されている場合
	function search1()
	{
		$this->layout="ajax";
		
		//debug($_POST);
        $dt = $this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-".$this->data['dt_check']['start_day'];
	   // debug($dt);
		
		$group_id = $this->data['Group']['id'];
		//$default = $this->Timecontrol->find(array("group_id" => $group_id));
		//debug($default);
		
		//設定と休日
		$defaults = $this->getDefault($group_id, $dt);
		//debug($defaults);
		$criteria = array();  
		
		
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$criteria[] = "Group.id in (". $group_ids.")";
		
		$emp_id = $this->data['Employee']['id'];
		if(!empty($emp_id))
		$criteria[] = "Employee.id = ".$emp_id;
//$criteria[] = "Employeeaccount.account != ''";
		//$criteria[] = groupid
		$criteria['GROUP BY'] = "Employee.id, Employeeaccount.account";//
		
		$asso = array(
			//'Employeeaccount : employeeaccounts' => array('Host.id = Employeeaccount.host_id'),
			'Employeeaccount : employeeaccounts : left' => array('Employee.id = Employeeaccount.employee_id'),
			'Host : hosts' => array('Host.id = Employeeaccount.host_id'),
			'Hsttime : hsttimes : left' => array(
				'Hsttime.host_id = Employeeaccount.host_id',
				'Hsttime.account = Employeeaccount.account',
				"Hsttime.target_day BETWEEN '".$dt."' and '".$dt."' + INTERVAL 7 DAY - INTERVAL 1 MICROSECOND "
				),
			'Hstshutdown : hstshutdowns : left' => array(
				'Hstshutdown.host_id = Employeeaccount.host_id',
				"Hstshutdown.target_day BETWEEN '".$dt."' and '".$dt."' + INTERVAL 7 DAY - INTERVAL 1 MICROSECOND "
				),
			/*'Employeeadacc : employeeadaccs : left' => array('Employee.id = Employeeadacc.employee_id'),
			'Employeetime : employeetimes : left' => array(
				'Employeetime.employee_id = Employee.id',
				"Employeetime.target_day BETWEEN '".$dt."' and '".$dt."' + INTERVAL 7 DAY - INTERVAL 1 MICROSECOND "
				),*/
			//'Employee : employees : left' => array('Employee.id = Employeeaccount.employee_id'),
			//'Rlthstgrp : rlthstgrps : left' => array('Rlthstgrp.host_id = Host.id'),
			//'Group : groups : left' => array('Group.id = Rlthstgrp.group_id'),
			'Group : groups : left' => array('Group.id = Employee.group_id'),
		);
		
		$fields = array(
			'Employee.id',
			'Host.id',
			'Host.host_name',
			'Group.id',
			'Group.group_name',
			'Employee.name',
			'Employee.id_name',
			'Employeeaccount.account',
			'GROUP_CONCAT(Hsttime.start_work order by Hsttime.target_day) as Hsttime__start_work',
			'GROUP_CONCAT(Hsttime.end_work order by Hsttime.target_day) as Hsttime__end_work',
			//'GROUP_CONCAT(Hsttime.shutdown order by Hsttime.target_day) as Hsttime__shutdown',
			'GROUP_CONCAT(Hsttime.target_day order by Hsttime.target_day) as Hsttime__target_day',
			'GROUP_CONCAT(Hstshutdown.shutdown order by Hstshutdown.target_day) as Hstshutdown__shutdown',
			'GROUP_CONCAT(Hstshutdown.target_day order by Hstshutdown.target_day) as Hstshutdown__target_day',
			/*'Employeeadacc.account',
			'GROUP_CONCAT(Employeetime.start_work order by Employeetime.target_day) as Employeetime__start_work',
			'GROUP_CONCAT(Employeetime.end_work order by Employeetime.target_day) as Employeetime__end_work',
			'GROUP_CONCAT(Employeetime.shutdown order by Employeetime.target_day) as Employeetime__shutdown',
			'GROUP_CONCAT(Employeetime.target_day order by Employeetime.target_day) as Employeetime__target_day',
		*/);
		//$this->Pagination->show = 1;//100
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/uptime_day_conf/search/', 'modelClass'=>'Employee', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 
			'sortBy' => $this->Lv->sortBy('Group.group_name, Employee.id_name, Employee.name, Host.host_name')));
		$data = $this->Employee->findByAsso($criteria, $fields, $order,$limit,$page, $asso);
		//debug($data);
		
		
		$data2 = array();
		foreach($data as $value){
			$tmp = array();
			$tmp['Host'] = $value['Host'];
			$tmp['Group'] = $value['Group'];
			$tmp['Employee'] = $value['Employee'];
			$tmp['Employeeaccount'] = $value['Employeeaccount'];
			
			$days = explode(",", $value['Hsttime']['target_day']);
			$start_work = explode(",", $value['Hsttime']['start_work']);
			$end_work = explode(",", $value['Hsttime']['end_work']);
			$shutdown = explode(",", $value['Hstshutdown']['shutdown']);
			$days2 = explode(",", $value['Hstshutdown']['target_day']);
			/*$days = explode(",", $value['Employeetime']['target_day']);
			$start_work = explode(",", $value['Employeetime']['start_work']);
			$end_work = explode(",", $value['Employeetime']['end_work']);
			$shutdown = explode(",", $value['Employeetime']['shutdown']);*/
			
			$default = $defaults[$value['Group']['id']];
			$date = new DateTime($dt);
			for($i = 0; $i < 7; $i++){
				$day = $date->format('Y-m-d');
				$date->modify('+1 days');
				
				$index = array_search($day, $days);
				$index2 = array_search($day, $days2);
				if($index === false && $index2 === false )//
					continue;
				//$day = $days[$i];
				if($index !== false){
					if(!empty($start_work[$index])){
						$tmp[$day]['start_work'] =  $start_work[$index];
						if($default['Timecontrol']['start_work'] < $default['Timecontrol']['end_work'])
							if($default['Timecontrol']['start_work'] <= $tmp[$day]['start_work'] && $tmp[$day]['start_work'] < $default['Timecontrol']['end_work'])
								$tmp[$day]['start_over'] = 0;
							else 
								$tmp[$day]['start_over'] = 1;
						else
							if($default['Timecontrol']['end_work'] <= $tmp[$day]['start_work'] && $tmp[$day]['start_work'] < $default['Timecontrol']['start_work'])
								$tmp[$day]['start_over'] = 1;
							else 
								$tmp[$day]['start_over'] = 0;
						//$tmp[$day]['start_over'] = $default['Timecontrol']['start_work'] > $tmp[$day]['start_work'] ? 1 : 0;
						if($tmp[$day]['start_work'] == "-"){
							$tmp[$day]['start_over'] = 0;
						}
						if($tmp[$day]['start_work'] == "x"){
							$tmp[$day]['start_over'] = 0;
						}					
					}
					
					if(!empty($end_work[$index])){
						$tmp[$day]['end_work'] =  $end_work[$index];
						if($default['Timecontrol']['start_work'] < $default['Timecontrol']['end_work'])
							if($default['Timecontrol']['start_work'] < $tmp[$day]['end_work'] && $tmp[$day]['end_work'] <= $default['Timecontrol']['end_work'])
								$tmp[$day]['end_over'] = 0;
							else 
								$tmp[$day]['end_over'] = 1;
						else
							if($default['Timecontrol']['end_work'] < $tmp[$day]['end_work'] && $tmp[$day]['end_work'] <= $default['Timecontrol']['start_work'])
								$tmp[$day]['end_over'] = 1;
							else 
								$tmp[$day]['end_over'] = 0;
						//$tmp[$day]['end_over'] = $default['Timecontrol']['end_work'] < $tmp[$day]['end_work'] ? 1 : 0;
						if($tmp[$day]['end_work'] == "-"){
							$tmp[$day]['end_over'] = 0;
						}

						if($tmp[$day]['end_work'] == "x"){
							$tmp[$day]['end_over'] = 0;
						}
					}
					
					//if(!empty($shutdown[$index]))
					//	$tmp[$day]['shutdown'] =  $shutdown[$index];
					
				}
				if($index2 !== false && !empty($shutdown[$index2]))
					$tmp[$day]['shutdown'] =  $shutdown[$index2];
				
			}

			$data2[] = $tmp;
		}
	//	debug($data2);
	
	//domainアカウント
		$criteria = array();  
		$criteria[] = "Group.id in (". $group_ids.")";
		if(!empty($emp_id))
			$criteria[] = "Employee.id = ".$emp_id;
		$criteria['GROUP BY'] = "Employee.id, Employeeadacc.employee_id";//
		
		$asso = array(
			'Employeeadacc : employeeadaccs : left' => array('Employee.id = Employeeadacc.employee_id'),
			'Employeetime : employeetimes : left' => array(
				'Employeetime.employee_id = Employee.id',
				"Employeetime.target_day BETWEEN '".$dt."' and '".$dt."' + INTERVAL 7 DAY - INTERVAL 1 MICROSECOND "
				),
			'Group : groups : left' => array('Group.id = Employee.group_id'),
		);
		
		$fields = array(
			'Employee.id',
			'Group.id',
			'Group.group_name',
			'Employee.name',
			'Employee.id_name',
			'Employeeadacc.account',
			'GROUP_CONCAT(Employeetime.start_work order by Employeetime.target_day) as Employeetime__start_work',
			'GROUP_CONCAT(Employeetime.end_work order by Employeetime.target_day) as Employeetime__end_work',
			'GROUP_CONCAT(Employeetime.shutdown order by Employeetime.target_day) as Employeetime__shutdown',
			'GROUP_CONCAT(Employeetime.target_day order by Employeetime.target_day) as Employeetime__target_day',
		);
		
		$data_d = $this->Employee->findByAsso($criteria, $fields, null,null,null, $asso);
		//debug($data);
		
		foreach($data_d as $value){
			$tmp = array();
			$tmp['Host']['id'] = -1;
			$tmp['Host']['host_name'] = "-";
			$tmp['Group'] = $value['Group'];
			$tmp['Employee'] = $value['Employee'];
			$tmp['Employeeaccount'] = $value['Employeeadacc'];
			$tmp['Domain']= true;
			
			$days = explode(",", $value['Employeetime']['target_day']);
			$start_work = explode(",", $value['Employeetime']['start_work']);
			$end_work = explode(",", $value['Employeetime']['end_work']);
			
			$default = $defaults[$value['Group']['id']];
			$date = new DateTime($dt);
			for($i = 0; $i < 7; $i++){
				$day = $date->format('Y-m-d');
				$date->modify('+1 days');
				
				$index = array_search($day, $days);
				if($index === false)//
					continue;
				//$day = $days[$i];
				if($index !== false){
					if(!empty($start_work[$index])){
						$tmp[$day]['start_work'] =  $start_work[$index];
						if($default['Timecontrol']['start_work'] < $default['Timecontrol']['end_work'])
							if($default['Timecontrol']['start_work'] <= $tmp[$day]['start_work'] && $tmp[$day]['start_work'] < $default['Timecontrol']['end_work'])
								$tmp[$day]['start_over'] = 0;
							else 
								$tmp[$day]['start_over'] = 1;
						else
							if($default['Timecontrol']['end_work'] <= $tmp[$day]['start_work'] && $tmp[$day]['start_work'] < $default['Timecontrol']['start_work'])
								$tmp[$day]['start_over'] = 1;
							else 
								$tmp[$day]['start_over'] = 0;
						//$tmp[$day]['start_over'] = $default['Timecontrol']['start_work'] > $tmp[$day]['start_work'] ? 1 : 0;
						if($tmp[$day]['start_work'] == "-"){
							$tmp[$day]['start_over'] = 0;
						}
						if($tmp[$day]['start_work'] == "x"){
							$tmp[$day]['start_over'] = 0;
						}					
					}
					
					if(!empty($end_work[$index])){
						$tmp[$day]['end_work'] =  $end_work[$index];
						if($default['Timecontrol']['start_work'] < $default['Timecontrol']['end_work'])
							if($default['Timecontrol']['start_work'] < $tmp[$day]['end_work'] && $tmp[$day]['end_work'] <= $default['Timecontrol']['end_work'])
								$tmp[$day]['end_over'] = 0;
							else 
								$tmp[$day]['end_over'] = 1;
						else
							if($default['Timecontrol']['end_work'] < $tmp[$day]['end_work'] && $tmp[$day]['end_work'] <= $default['Timecontrol']['start_work'])
								$tmp[$day]['end_over'] = 1;
							else 
								$tmp[$day]['end_over'] = 0;
						//$tmp[$day]['end_over'] = $default['Timecontrol']['end_work'] < $tmp[$day]['end_work'] ? 1 : 0;
						if($tmp[$day]['end_work'] == "-"){
							$tmp[$day]['end_over'] = 0;
						}

						if($tmp[$day]['end_work'] == "x"){
							$tmp[$day]['end_over'] = 0;
						}
					}
				}
			}

			$data2[] = $tmp;
		}
		//debug($data2);
		$this->sortData($data2, $order);//echo $order; //Group.group_name, Employee.id_name, Employee.name, Host.host_name ASC 
		
		//$this->set('vacation', $vacation);
		$this->set('data', $data2);
		$this->set('defaults', $defaults);
		$this->set('dt', $dt);
		
		//$this->render('search');
	}
	function search2()
	{
		$this->layout="ajax";
		
		//debug($_POST);
        $dt = $this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-".$this->data['dt_check']['start_day'];
	   // debug($dt);
		
		$group_id = $this->data['Group']['id'];
		//$default = $this->Timecontrol->find(array("group_id" => $group_id));
		//debug($default);
		
		//設定と休日
		$defaults = $this->getDefault($group_id, $dt);
		//debug($defaults);
		$criteria = array();  
		
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$criteria[] = "Group.id in (". $group_ids.")";
		
		$emp_id = $this->data['Employee']['id'];
		if(!empty($emp_id))
		$criteria[] = "Employee.id = ".$emp_id;

	//domainアカウント
		$criteria['GROUP BY'] = "Employee.id, Employeeadacc.employee_id";//
		
		$asso = array(
			'Employeeaccount : employeeaccounts : left' => array('Employee.id = Employeeaccount.employee_id'),
			'Host : hosts : left' => array('Host.id = Employeeaccount.host_id'),
			'Employeeadacc : employeeadaccs : left' => array('Employee.id = Employeeadacc.employee_id'),
			'Employeetime : employeetimes : left' => array(
				'Employeetime.employee_id = Employee.id',
				"Employeetime.target_day BETWEEN '".$dt."' and '".$dt."' + INTERVAL 7 DAY - INTERVAL 1 MICROSECOND "
				),
			'Group : groups : left' => array('Group.id = Employee.group_id'),
		);
		
		$fields = array(
			'Host.id',
			'Host.host_name',
			'Employee.id',
			'Group.id',
			'Group.group_name',
			'Employee.name',
			'Employee.id_name',
			'(case when Employeeadacc.account is null then Employeeaccount.account else Employeeadacc.account end ) as Employeeaccount__account',
			'GROUP_CONCAT(Employeetime.start_work order by Employeetime.target_day) as Employeetime__start_work',
			'GROUP_CONCAT(Employeetime.end_work order by Employeetime.target_day) as Employeetime__end_work',
			'GROUP_CONCAT(Employeetime.shutdown order by Employeetime.target_day) as Employeetime__shutdown',
			'GROUP_CONCAT(Employeetime.target_day order by Employeetime.target_day) as Employeetime__target_day',
		);
		//$this->Pagination->show = 1;//100
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/uptime_day_conf/search/', 'modelClass'=>'Employee', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 
			'sortBy' => $this->Lv->sortBy('Group.group_name, Employee.id_name, Employee.name, Host.host_name')));
		$data = $this->Employee->findByAsso($criteria, $fields, $order,$limit,$page, $asso);
		
		//debug($data);
		
		foreach($data as $value){
			$tmp = array();
			$tmp['Host'] = $value['Host'];
			$tmp['Group'] = $value['Group'];
			$tmp['Employee'] = $value['Employee'];
			$tmp['Employeeaccount'] = $value['Employeeaccount'];
			//$tmp['Domain']= true;
			
			$days = explode(",", $value['Employeetime']['target_day']);
			$start_work = explode(",", $value['Employeetime']['start_work']);
			$end_work = explode(",", $value['Employeetime']['end_work']);
			$shutdown = explode(",", $value['Employeetime']['shutdown']);
			
			
			$default = $defaults[$value['Group']['id']];
			$date = new DateTime($dt);
			for($i = 0; $i < 7; $i++){
				$day = $date->format('Y-m-d');
				$date->modify('+1 days');
				
				$index = array_search($day, $days);
				if($index === false)//
					continue;
				//$day = $days[$i];
				if($index !== false){
					if(!empty($start_work[$index])){
						$tmp[$day]['start_work'] =  $start_work[$index];
						if($default['Timecontrol']['start_work'] < $default['Timecontrol']['end_work'])
							if($default['Timecontrol']['start_work'] <= $tmp[$day]['start_work'] && $tmp[$day]['start_work'] < $default['Timecontrol']['end_work'])
								$tmp[$day]['start_over'] = 0;
							else 
								$tmp[$day]['start_over'] = 1;
						else
							if($default['Timecontrol']['end_work'] <= $tmp[$day]['start_work'] && $tmp[$day]['start_work'] < $default['Timecontrol']['start_work'])
								$tmp[$day]['start_over'] = 1;
							else 
								$tmp[$day]['start_over'] = 0;
						//$tmp[$day]['start_over'] = $default['Timecontrol']['start_work'] > $tmp[$day]['start_work'] ? 1 : 0;
						if($tmp[$day]['start_work'] == "-"){
							$tmp[$day]['start_over'] = 0;
						}
						if($tmp[$day]['start_work'] == "x"){
							$tmp[$day]['start_over'] = 0;
						}					
					}
					
					if(!empty($end_work[$index])){
						$tmp[$day]['end_work'] =  $end_work[$index];
						if($default['Timecontrol']['start_work'] < $default['Timecontrol']['end_work'])
							if($default['Timecontrol']['start_work'] < $tmp[$day]['end_work'] && $tmp[$day]['end_work'] <= $default['Timecontrol']['end_work'])
								$tmp[$day]['end_over'] = 0;
							else 
								$tmp[$day]['end_over'] = 1;
						else
							if($default['Timecontrol']['end_work'] < $tmp[$day]['end_work'] && $tmp[$day]['end_work'] <= $default['Timecontrol']['start_work'])
								$tmp[$day]['end_over'] = 1;
							else 
								$tmp[$day]['end_over'] = 0;
						//$tmp[$day]['end_over'] = $default['Timecontrol']['end_work'] < $tmp[$day]['end_work'] ? 1 : 0;
						if($tmp[$day]['end_work'] == "-"){
							$tmp[$day]['end_over'] = 0;
						}

						if($tmp[$day]['end_work'] == "x"){
							$tmp[$day]['end_over'] = 0;
						}
					}
					
					if(!empty($shutdown[$index]))
						$tmp[$day]['shutdown'] =  $shutdown[$index];
					
				}
			}

			$data2[] = $tmp;
		}
		//debug($data2);

		//$this->set('vacation', $vacation);
		$this->set('data', $data2);
		$this->set('defaults', $defaults);
		$this->set('dt', $dt);
		
		//$this->render('search');
	}
	
	function update()
	{
		$this->layout="ajax";
		$errorMessage = array();
		
		$emp_id = $this->data['Employee']['id'];
		$host_id = $this->data['Host']['id'];
		$target_day = $this->data['Hsttime']['target_day'];
		$account = $this->data['Hsttime']['account'];
		$start_work = $this->data['Hsttime']['start_work'];
		$end_work = $this->data['Hsttime']['end_work'];
		$shutdown = $this->data['Hstshutdown']['shutdown'];
		
		$group_id = $this->data['Group']['id'];
		$group_all = false;
		if(isset($this->data['Group']['all']) && $this->data['Group']['all'] != 0)
			$group_all = true;
		
		$pc_all = false;
		if(isset($this->data['Employee']['allpc']) && $this->data['Employee']['allpc'] != 0)
			$pc_all = true;
		
		if($pc_all){
			//1社員
			$errorMessage = $this->updateEmp($emp_id, $target_day, $start_work, $end_work, $shutdown);
			$this->GenerateFiles->hook_by_ps(0, array('uptimeaccount','hostaccount'), 1);
		}
		
		if(!$group_all){
			if($host_id == -1)//domainアカウント
				$errorMessage = $this->updateEmp($emp_id, $target_day, $start_work, $end_work, $shutdown, false);
			else//1PC
				$errorMessage = $this->updateHost($host_id, $target_day, $account, $start_work, $end_work, $shutdown);
			$this->GenerateFiles->hook_by_ps(0, array('uptimeaccount','hostaccount'), 1);
		}else{
			//グループに設定
			$employees = $this->Employee->findAll(array("group_id" => $group_id));
			foreach($employees as $emp)
			{
				$eid = $emp['Employee']['id'];
				$errorMessage = $this->updateEmp($eid, $target_day, $start_work, $end_work, $shutdown);
			}
			/*$hosts = $this->Rlthstgrp->findAll(array("group_id" => $group_id));
			foreach($hosts as $host)
			{
				$accounts = $this->Employeeaccount->findAll(array("host_id" => $host['Rlthstgrp']['host_id']));
				foreach($accounts as $accountdata){
					$hid = $accountdata['Employeeaccount']['host_id'];
					$acc = $accountdata['Employeeaccount']['account'];
					//echo $hid."-".$acc;
					$errorMessage = $this->updateHost($hid, $target_day, $acc, $start_work, $end_work, $shutdown);
				}
			}*/
			$this->GenerateFiles->hook_by_ps(0, array('uptimeaccount','hostaccount'), 1);
		}
		$this->set('errorMessage', $errorMessage);
	}
	
	function updateHost($host_id, $target_day, $account, $start_work, $end_work, $shutdown)
	{
		$errorMessage = array();
		
		$crit = array(
			"host_id" => $host_id, 
			"target_day" => $target_day,
		);
		$sd = $this->Hstshutdown->find($crit);
		if(!empty($sd)){
			if(empty($shutdown)){//シャットダウンで標準を選んだ場合
				$query = "delete from hstshutdowns where host_id ={$host_id} and target_day ='{$target_day}' ";
				$this->Hstshutdown->execute($query);
			}else{
				$query = "update hstshutdowns set shutdown='{$shutdown}' where host_id ={$host_id} and target_day ='{$target_day}' ";
				$this->Hstshutdown->execute($query);
			}
		}else{
			if(empty($shutdown)){
			}else{
				$newHstshutdown = array(
					'Hstshutdown' => array(
						'host_id' => $host_id,
						'target_day' => $target_day,
						'shutdown' => $shutdown,
					)
				); 						
				$this->Hstshutdown->save($newHstshutdown);
			}
		}
		
		$crit["account"] = $account;
		$acc = $this->Hsttime->find($crit);
		if(!empty($acc)){
			if(empty($start_work) && empty($end_work) ){//全て標準を選んだ場合
				$query = "delete from hsttimes where host_id ={$host_id} and target_day ='{$target_day}' and account ='{$account}'";
				$this->Hsttime->execute($query);
			}else{
				$query = "update hsttimes set start_work='{$start_work}', end_work='{$end_work}' where host_id ={$host_id} and target_day ='{$target_day}' and account ='{$account}'";
				$this->Hsttime->execute($query);
			}
		}else{
			if(empty($start_work) && empty($end_work) ){
				
			}else{
				$newHsttime = array(
					'Hsttime' => array(
						'host_id' => $host_id,
						'target_day' => $target_day,
						'account' => $account,
						'start_work' => $start_work,
						'end_work' => $end_work,
						//'shutdown' => $shutdown,
					)
				); 						
				$this->Hsttime->save($newHsttime);
			}
		}
		
		//exit();
	}
	
	function updateEmp($emp_id, $target_day, $start_work, $end_work, $shutdown, $owned_pc = true)
	{
		$errorMessage = array();

		$crit = array(
			"employee_id" => $emp_id, 
			"target_day" => $target_day,
		);
		$sd = $this->Employeetime->find($crit);
		if(!empty($sd)){
			if(empty($start_work) && empty($end_work) && empty($shutdown)){//シャットダウンで標準を選んだ場合
				$query = "delete from employeetimes where employee_id ={$emp_id} and target_day ='{$target_day}' ";
				$this->Employeetime->execute($query);
			}else{
				$shut = $shutdown;
				if(empty($shutdown)){
					$emp = $this->Employee->find(array("id" => $emp_id));
					$group_id = $emp['Employee']['group_id'];
					$default = $this->getTimecontrol($group_id);
					$shut = $default['Timecontrol']['shutdown'];
				}
				$query = "update employeetimes set start_work='{$start_work}', end_work='{$end_work}', shutdown='{$shut}' where employee_id ={$emp_id} and target_day ='{$target_day}' ";
				$this->Employeetime->execute($query);
			}
		}else{
			$shut = $shutdown;
			if(empty($shutdown)){
				$emp = $this->Employee->find(array("id" => $emp_id));
				$group_id = $emp['Employee']['group_id'];
				$default = $this->getTimecontrol($group_id);
				$shut = $default['Timecontrol']['shutdown'];
			}
		
			$newHstshutdown = array(
				'Employeetime' => array(
					'employee_id' => $emp_id,
					'target_day' => $target_day,
					'start_work' => $start_work,
					'end_work' => $end_work,
					'shutdown' => $shut,
				)
			); 						
			$this->Employeetime->save($newHstshutdown);
			
		}
		
		if($owned_pc){
			$accounts = $this->Employeeaccount->findAll(array("employee_id" => $emp_id));
			foreach($accounts as $accountdata){
				$hid = $accountdata['Employeeaccount']['host_id'];
				$acc = $accountdata['Employeeaccount']['account'];
				//echo $hid."-".$acc;
				$errorMessage = $this->updateHost($hid, $target_day, $acc, $start_work, $end_work, $shutdown);
			}
			
			//同じホストを持つ社員が1pcであればemployeetimesも更新
			/*$crit = array("Employeeaccount.employee_id != ".$emp_id,
						"Employeeaccount.host_id in (select host_id from employeeaccounts where employee_id ={$emp_id})");
			$crit['GROUP BY'] = "Employee.id";
			$asso = array('Employee : employees' => array('Employee.id = Employeeaccount.employee_id'));
			$fld = array("Employee.id");
			$others = $this->Employeeaccount->findByAsso($crit, $fld, null,null,null, $asso);
			debug($others);
			if(!empty($others))
			{
				foreach($others as $emp)
				{
					$ea = $this->Employeeaccount->find(array("employee_id" => $emp['Employee']['id']));
					if(count($ea) == 1)
					{
						$this->updateEmp($emp['Employee']['id'], $target_day, $start_work, $end_work, $shutdown, false);
					}
				}
			}*/
				
		}
		//exit();
	}
	
	function sortData(&$data, $order)
	{
		//echo $order;	
		//Group.group_name, Employee.id_name, Employee.name, Host.host_name ASC 
		$key = $order;
		if(strpos($key, " ASC") !== false ){
			$key = str_replace(" ASC","",$order);
			$sort = SORT_ASC;
		}
		
		if(strpos($key, " DESC") !== false ){
			$key = str_replace(" DESC","",$key);
			$sort = SORT_DESC;
		}
		
		
		if(isset($key)){
			
			$keys = explode(",", $key);
			if(count($keys) == 4){
				$key0 = $keys[0];
				$key1 = $keys[1];
				$key2 = $keys[2];
				$key3 = $keys[3];
			
				$keyarr0 = array();$keyarr1 = array();$keyarr2 = array();$keyarr3 = array();
				if(strpos($key0, ".") !== false )
					$keyarr0 = explode(".", $key0);
				elseif(strpos($key0, "__") !== false )
					$keyarr0 = explode("__", $key0);
					
					if(strpos($key1, ".") !== false )
					$keyarr1 = explode(".", $key1);
				elseif(strpos($key1, "__") !== false )
					$keyarr1 = explode("__", $key1);
					
					if(strpos($key2, ".") !== false )
					$keyarr2 = explode(".", $key2);
				elseif(strpos($key2, "__") !== false )
					$keyarr2 = explode("__", $key2);
					
					if(strpos($key3, ".") !== false )
					$keyarr3 = explode(".", $key3);
				elseif(strpos($key3, "__") !== false )
					$keyarr3 = explode("__", $key3);
			//echo $key;	
				if(!empty($keyarr)){
					$names0 = array();$names1 = array();$names2 = array();$names3 = array();
					foreach($data as $a => $d){
						$names0[] = $d[$keyarr0[0]][$keyarr0[1]];
						$names1[] = $d[$keyarr1[0]][$keyarr1[1]];
						$names2[] = $d[$keyarr2[0]][$keyarr2[1]];
						$names3[] = $d[$keyarr3[0]][$keyarr3[1]];
					}
					array_multisort($names0, $sort, $names1, $sort, $names2, $sort, $names3, $sort, $data);
				}
			}else{
				$key = $keys[0];
			
				$keyarr = array();
				if(strpos($key, ".") !== false )
					$keyarr = explode(".", $key);
				elseif(strpos($key, "__") !== false )
					$keyarr = explode("__", $key);
			//echo $key;	
				if(!empty($keyarr)){
					$names = array();
					foreach($data as $a => $d)
						$names[] = $d[$keyarr[0]][$keyarr[1]];
					array_multisort($names, $sort, $data);
				}
			}
		}
		
	}
	
	function form($emp_id, $group_id = null, $host_id = null, $acc = null, $dt = null, $yasumi = 0)
	{
		$this->layout="ajax";
		
		$account = $this->Lv->url_param_decode2($acc);
		
		//基本設定　設定が無ければ上位のグループ
	//	$default = $this->Timecontrol->find(array("group_id" => $group_id));
		$default = $this->getTimecontrol($group_id);
		
		//時間のセレクトボックス
		$start = 0;		
		if(!empty($default)){
			$start_day = $default['Timecontrol']['start_day'];
			$split = explode(":",$start_day);
			$start = intval($split[0]);//echo $start;
		}
		//開始
		$times = array();
		$times[""] = __('def_setting',$retrun=true);
		$times["-"] = "-";//設定off(終日ok
		$times["x"] = __('holiday',$retrun=true);//休日
		for($h = $start; $h < 24; $h++){
			$hh = sprintf("%02d", $h);
			$times[$hh.":00"] = $h.":00";
		}
		for($h = 0; $h < $start; $h++){
			$hh = sprintf("%02d", $h);//
			$times[$hh.":00"] = ($h).":00";
		}
		$this->set('times', $times);
		//終了
		$times2 = array();
		$times2[""] = __('def_setting',$retrun=true);
		$times2["-"] = "-";//設定off(終日ok
		$times2["x"] = __('holiday',$retrun=true);//休日
		for($h = $start+1; $h < 24; $h++){
			$hh = sprintf("%02d", $h);
			$times2[$hh.":00"] = $h.":00";
		}
		if($start != 0)
		for($h = 0; $h < $start+1; $h++){
			$hh = sprintf("%02d", $h);//
			$times2[$hh.":00"] = ($h).":00";
		}
		else
			$times2["24:00"] = "24:00";
		$this->set('times2', $times2);
		//シャットダウン
		$times30 = array();
		$times30[""] = __('def_setting',$retrun=true);
		$times30["-"] = __('off_setting',$retrun=true);
		//$times30["-"] = "-";
		for($h = $start; $h < 24; $h++){
			$hh = sprintf("%02d", $h);
			$times30[$hh.":00"] = $h.":00";
			$times30[$hh.":30"] = $h.":30";
		}
		for($h = 0; $h < $start; $h++){
			$hh = sprintf("%02d", $h);
			$times30[$hh.":00"] = $h.":00";
			$times30[$hh.":30"] = $h.":30";
		}
		$this->set('times30', $times30);
		$this->set('curHost', $host_id);
		$this->set('curDate', $dt);
		$this->set('curAccount', $account);
		
		$criteria[] = "1=1";  
		$criteria[] = "Employee.id = ".$emp_id;
		$criteria[] = "Employeeaccount.host_id = ".$host_id;
		$criteria[] = "Employeeaccount.account = '".$this->Lv->spec_char_dbm($account)."'" ;
		
		$asso = array(
			'Employeeaccount : employeeaccounts : left' => array('Employee.id = Employeeaccount.employee_id'),
			'Host : hosts : left' => array('Host.id = Employeeaccount.host_id'),
			//'Employeeaccount : employeeaccounts' => array(
			//	'Host.id = Employeeaccount.host_id',
			//	//"Employeeaccount.account = '".$this->Lv->spec_char_dbm($account)."'" 
			//	),
			'Hsttime : hsttimes : left' => array(
				'Hsttime.host_id = Employeeaccount.host_id',
				'Hsttime.account = Employeeaccount.account',
				"Hsttime.target_day = '".$dt."'"),
			'Hstshutdown : hstshutdowns : left' => array(
				'Hstshutdown.host_id = Employeeaccount.host_id',
				"Hstshutdown.target_day = '".$dt."'"),
		/*	'Employeetime : employeetimes : left' => array(
				'Employeetime.employee_id = Employee.id',
				"Employeetime.target_day = '".$dt."'"),*/
			//'Employee : employees : left' => array('Employee.id = Employeeaccount.employee_id'),
			//'Rlthstgrp : rlthstgrps : left' => array('Rlthstgrp.host_id = Host.id'),
			//'Group : groups : left' => array('Group.id = Rlthstgrp.group_id'),
			'Group : groups : left' => array('Group.id = Employee.group_id'),
		);
		
		$fields = array(
			'Host.id',
			'Host.host_name',
			'Group.id',
			'Group.group_name',
			'Employee.id',
			'Employee.name',
			'Employee.id_name',
			'Employeeaccount.account',
			'Hsttime.start_work',
			'Hsttime.end_work',
			'Hstshutdown.shutdown'
			/*'Employeetime.start_work',
			'Employeetime.end_work',
			'Employeetime.shutdown'*/
		);
		$data = $this->Employee->findByAsso($criteria, $fields, null,null,null, $asso);
		
		//同じホストを持つ社員がいるか
		$crit = array("Employeeaccount.employee_id != ".$emp_id,
					"Employeeaccount.host_id in (select host_id from employeeaccounts where employee_id ={$emp_id})");
		$crit['GROUP BY'] = "Employee.id";
		$asso = array('Employee : employees' => array('Employee.id = Employeeaccount.employee_id'));
		$fld = array("Employee.id_name", "Employee.name");
		$others = $this->Employeeaccount->findByAsso($crit, $fld, null,null,null, $asso);
		//debug($others);
		$this->set('others', $others);
		
		//社員に他のPCがあるか
		$crit = array("Employeeaccount.employee_id = ".$emp_id,
					"Employeeaccount.host_id !=".$host_id);
		$otherpc = $this->Employeeaccount->find($crit);
		$this->set('otherpc', $otherpc);

		//debug($data[0]);
		$this->set('data', $data[0]);
		$this->set('default', $default);
		$this->set('yasumi', $yasumi);
		

	}
	
	//domain
	function formd($emp_id, $group_id = null, $host_id = null, $acc = null, $dt = null, $yasumi = 0)
	{
		$this->layout="ajax";
		
		$account = $this->Lv->url_param_decode2($acc);
		
		//基本設定　設定が無ければ上位のグループ
	//	$default = $this->Timecontrol->find(array("group_id" => $group_id));
		$default = $this->getTimecontrol($group_id);
		
		//時間のセレクトボックス
		$start = 0;		
		if(!empty($default)){
			$start_day = $default['Timecontrol']['start_day'];
			$split = explode(":",$start_day);
			$start = intval($split[0]);//echo $start;
		}
		//開始
		$times = array();
		$times[""] = __('def_setting',$retrun=true);
		$times["-"] = "-";//設定off(終日ok
		$times["x"] = __('holiday',$retrun=true);//休日
		for($h = $start; $h < 24; $h++){
			$hh = sprintf("%02d", $h);
			$times[$hh.":00"] = $h.":00";
		}
		for($h = 0; $h < $start; $h++){
			$hh = sprintf("%02d", $h);//
			$times[$hh.":00"] = ($h).":00";
		}
		$this->set('times', $times);
		//終了
		$times2 = array();
		$times2[""] = __('def_setting',$retrun=true);
		$times2["-"] = "-";//設定off(終日ok
		$times2["x"] = __('holiday',$retrun=true);//休日
		for($h = $start+1; $h < 24; $h++){
			$hh = sprintf("%02d", $h);
			$times2[$hh.":00"] = $h.":00";
		}
		if($start != 0)
		for($h = 0; $h < $start+1; $h++){
			$hh = sprintf("%02d", $h);//
			$times2[$hh.":00"] = ($h).":00";
		}
		else
			$times2["24:00"] = "24:00";
		$this->set('times2', $times2);
		//シャットダウン
		$times30 = array();
		$times30[""] = __('def_setting',$retrun=true);
		$times30["-"] = __('off_setting',$retrun=true);
		//$times30["-"] = "-";
		for($h = $start; $h < 24; $h++){
			$hh = sprintf("%02d", $h);
			$times30[$hh.":00"] = $h.":00";
			$times30[$hh.":30"] = $h.":30";
		}
		for($h = 0; $h < $start; $h++){
			$hh = sprintf("%02d", $h);
			$times30[$hh.":00"] = $h.":00";
			$times30[$hh.":30"] = $h.":30";
		}
		$this->set('times30', $times30);
		$this->set('curHost', $host_id);
		$this->set('curDate', $dt);
		$this->set('curAccount', $account);
		
		$criteria[] = "1=1";  
		$criteria[] = "Employee.id = ".$emp_id;
		//$criteria[] = "Employeeaccount.host_id = ".$host_id;
		$criteria[] = "Employeeadacc.account = '".$this->Lv->spec_char_dbm($account)."'" ;
		
		$asso = array(
			'Employeeadacc : employeeadaccs : left' => array('Employee.id = Employeeadacc.employee_id'),
			'Employeetime : employeetimes : left' => array(
				'Employeetime.employee_id = Employee.id',
				"Employeetime.target_day = '".$dt."'"),
			'Group : groups : left' => array('Group.id = Employee.group_id'),
		);
		
		$fields = array(
			'-1 as Host__id',
			"'-' as Host__host_name",
			'Group.id',
			'Group.group_name',
			'Employee.id',
			'Employee.name',
			'Employee.id_name',
			'Employeeadacc.account as Employeeaccount__account',
			'Employeetime.start_work as Hsttime__start_work',
			'Employeetime.end_work as Hsttime__end_work',
			'Employeetime.shutdown as Hstshutdown__shutdown',
		);
		$data = $this->Employee->findByAsso($criteria, $fields, null,null,null, $asso);
		
		//同じホストを持つ社員がいるか
		$this->set('others', array());
		
		//社員に他のPCがあるか
		$crit = array("Employeeaccount.employee_id = ".$emp_id);
		$otherpc = $this->Employeeaccount->find($crit);
		$this->set('otherpc', $otherpc);

		//debug($data[0]);
		$this->set('data', $data[0]);
		$this->set('default', $default);
		$this->set('yasumi', $yasumi);
		

	}
	
	function formone($emp_id, $group_id = null, $host_id = null, $acc = null, $dt = null, $yasumi = 0)
	{
		$this->layout="ajax";
		
		$account = $this->Lv->url_param_decode2($acc);
		
		//基本設定　設定が無ければ上位のグループ
	//	$default = $this->Timecontrol->find(array("group_id" => $group_id));
		$default = $this->getTimecontrol($group_id);
		
		//時間のセレクトボックス
		$start = 0;		
		if(!empty($default)){
			$start_day = $default['Timecontrol']['start_day'];
			$split = explode(":",$start_day);
			$start = intval($split[0]);//echo $start;
		}
		//開始
		$times = array();
		$times[""] = __('def_setting',$retrun=true);
		$times["-"] = "-";//設定off(終日ok
		$times["x"] = __('holiday',$retrun=true);//休日
		for($h = $start; $h < 24; $h++){
			$hh = sprintf("%02d", $h);
			$times[$hh.":00"] = $h.":00";
		}
		for($h = 0; $h < $start; $h++){
			$hh = sprintf("%02d", $h);//
			$times[$hh.":00"] = ($h).":00";
		}
		$this->set('times', $times);
		//終了
		$times2 = array();
		$times2[""] = __('def_setting',$retrun=true);
		$times2["-"] = "-";//設定off(終日ok
		$times2["x"] = __('holiday',$retrun=true);//休日
		for($h = $start+1; $h < 24; $h++){
			$hh = sprintf("%02d", $h);
			$times2[$hh.":00"] = $h.":00";
		}
		if($start != 0)
		for($h = 0; $h < $start+1; $h++){
			$hh = sprintf("%02d", $h);//
			$times2[$hh.":00"] = ($h).":00";
		}
		else
			$times2["24:00"] = "24:00";
		$this->set('times2', $times2);
		//シャットダウン
		$times30 = array();
		$times30[""] = __('def_setting',$retrun=true);
		$times30["-"] = __('off_setting',$retrun=true);
		//$times30["-"] = "-";
		for($h = $start; $h < 24; $h++){
			$hh = sprintf("%02d", $h);
			$times30[$hh.":00"] = $h.":00";
			$times30[$hh.":30"] = $h.":30";
		}
		for($h = 0; $h < $start; $h++){
			$hh = sprintf("%02d", $h);
			$times30[$hh.":00"] = $h.":00";
			$times30[$hh.":30"] = $h.":30";
		}
		$this->set('times30', $times30);
		$this->set('curHost', $host_id);
		$this->set('curDate', $dt);
		$this->set('curAccount', $account);
		
		$criteria[] = "1=1";  
		$criteria[] = "Employee.id = ".$emp_id;
	//	$criteria[] = "Employeeaccount.host_id = ".$host_id;
	//	$criteria[] = "Employeeaccount.account = '".$this->Lv->spec_char_dbm($account)."'" ;
		
		$criteria['GROUP BY'] = "Employee.id";//
		
		$asso = array(
			'Employeeaccount : employeeaccounts : left' => array('Employee.id = Employeeaccount.employee_id'),
			'Host : hosts : left' => array('Host.id = Employeeaccount.host_id'),
			'Employeeadacc : employeeadaccs : left' => array('Employee.id = Employeeadacc.employee_id'),
			'Employeetime : employeetimes : left' => array(
				'Employeetime.employee_id = Employee.id',
				"Employeetime.target_day = '".$dt."'"),
			'Group : groups : left' => array('Group.id = Employee.group_id'),
		);
		
		$fields = array(
			'Host.id',
			'Host.host_name',
			'Group.id',
			'Group.group_name',
			'Employee.id',
			'Employee.name',
			'Employee.id_name',
			'(case when Employeeadacc.account is null then Employeeaccount.account else Employeeadacc.account end ) as Employeeaccount__account',
			/*'Hsttime.start_work',
			'Hsttime.end_work',
			'Hstshutdown.shutdown'*/
			'Employeetime.start_work as Hsttime__start_work',
			'Employeetime.end_work as Hsttime__end_work',
			'Employeetime.shutdown as Hstshutdown__shutdown',
		);
		$data = $this->Employee->findByAsso($criteria, $fields, null,null,null, $asso);
		
		//同じホストを持つ社員がいるか
		$crit = array("Employeeaccount.employee_id != ".$emp_id,
					"Employeeaccount.host_id in (select host_id from employeeaccounts where employee_id ={$emp_id})");
		$crit['GROUP BY'] = "Employee.id";
		$asso = array('Employee : employees' => array('Employee.id = Employeeaccount.employee_id'));
		$fld = array("Employee.id_name", "Employee.name");
		$others = $this->Employeeaccount->findByAsso($crit, $fld, null,null,null, $asso);
		//debug($others);
		$this->set('others', $others);

		//debug($data[0]);
		$this->set('data', $data[0]);
		$this->set('default', $default);
		$this->set('yasumi', $yasumi);
		
		$this->set('peremployee', true);
		
		$this->render('form');
	}
}
?>