<?php
class UptimeDefaultConfController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
	var $uses=array('Group', 'Host','Rlthstgrp','Grpauth','Hstalt','Authority','Rltuserauth','User','Configure','Validation',
	'Timecontrol','Grpholiday');
	var $layout='uptime';
	
	
	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('menu_uptime',$retrun=true); 
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index($errorMessage = null)
	{
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		ksort($glist);
		$this->set('glist',$glist);
		
		$groups = "";
		$this->Group->unbindModel(array('hasMany' => array('Grpauth')));
		$gtree = $this->Group->findAllThreaded(null, null, 'Group.group_name', $this->_getUserGroup());
		$temp = $this->Group->findAllById($this->_getUserGroup());
		$temp[0]['Parentgroup'] = array('id' => NULL, 'parent_id' => NULL, 'group_name' => NULL);
		$temp[0]['children'] = $gtree;
		$gtree = $temp;
		//var_dump($gtree);
		
		foreach($glist as $gid => $gname)
		{
			$groups .=  $gid.",";
		}
		$groups = substr($groups,0,-1);	//echo $groups;
		
		$criteria = array("Group.id in (".$groups.")");
		$asso = array(
			'Timecontrol : timecontrols : left' => array('Group.id = Timecontrol.group_id'),
		);
		
		$fields = array(
			'Group.id',
			'Group.group_name',
			'(case when Timecontrol.start_day is null then "-" else Timecontrol.start_day end) as Timecontrol__start_day',
			'(case when Timecontrol.start_work is null then "-" else Timecontrol.start_work end) as Timecontrol__start_work',
			'(case when Timecontrol.end_work is null then "-" else Timecontrol.end_work end) as Timecontrol__end_work',
			'(case when Timecontrol.shutdown is null then "-" else Timecontrol.shutdown end) as Timecontrol__shutdown',
			'Timecontrol.saturday',
			'Timecontrol.sunday',
			'Timecontrol.monday',
			'Timecontrol.tuesday',
			'Timecontrol.wednesday',
			'Timecontrol.thursday',
			'Timecontrol.friday',
			'Timecontrol.holiday',
		);
		$data = $this->Group->findByAsso($criteria, $fields, null,null,null, $asso);
		//var_dump($data);
		//$this->set('data', $data);
		$output = array();
		$this->settree($gtree, $data, $output, 0);
	//	var_dump($output);
		$this->set('data', $output);
		
	}
	
	function settree(&$gtree, &$data, &$output, $layer){
		foreach($gtree as $num => $group1){
			foreach($data as $d){
				if($group1["Group"]["id"] == $d["Group"]["id"]){
					$gtree[$num]["Timecontrol"] = $d["Timecontrol"];
					break;
				}
			}
			unset($gtree[$num]["Parentgroup"]);
			$temp["Group"]["layer"] = $layer;
			$temp["Group"]["id"] = $gtree[$num]["Group"]["id"];
			$temp["Group"]["group_name"] = $gtree[$num]["Group"]["group_name"];
			$temp["Timecontrol"] = $gtree[$num]["Timecontrol"];
			$output[] = $temp;
			
			$this->settree($gtree[$num]["children"], $data, $output, $layer+1);	
		}
	}
	
	function search($group_id = null)
	{
		$this->layout="ajax";
		
		if(!empty($this->data['Employee']['group_id']))
			$group_id = $this->data['Employee']['group_id'];
		
		$gd = $this->Group->findById($group_id);
		$this->set('group_name', $gd['Group']['group_name']);

		$data = array();
		//既存設定の読み込み
		$setting = $this->Timecontrol->find(array('Timecontrol.group_id' => $group_id));
		if(empty($setting))
			$data['Timecontrol']['group_id'] = $group_id;
		else
			$data['Timecontrol'] = $setting['Timecontrol'];
			
		$holidays = $this->Grpholiday->findAll(array('Grpholiday.group_id' => $group_id));
		
		foreach($holidays as $holiday ){
			$name = $holiday['Grpholiday']['name'];
			$data[$name] = $holiday['Grpholiday'];
			
			if($data[$name]['start'] == '0000-00-00')
				unset($data[$name]['start']);
				
			if($data[$name]['end'] == '0000-00-00')
				unset($data[$name]['end']);
		}
		$this->set('data', $data);
		
		$this->set('group_id', $group_id);
		//debug($this->data);
	}
	
	function form($group_id){
		$this->layout='ajax';

		$gd = $this->Group->findById($group_id);
		$this->set('group_name', $gd['Group']['group_name']);
		
		//既存設定の読み込み
		$setting = $this->Timecontrol->find(array('Timecontrol.group_id' => $group_id));
		if(empty($setting)){
			$this->data['Timecontrol']['group_id'] = $group_id;
			$this->set('exists', false);
		}else{
			$this->data['Timecontrol'] = $setting['Timecontrol'];
			$this->set('exists', true);
		}
		
		$this->data['Timecontrol']['announce'] = array();
		$this->data['Timecontrol']['announce'][] =  $this->data['Timecontrol']['shutdown_info'];
		$this->data['Timecontrol']['announce'][] =  $this->data['Timecontrol']['shutdown_notice'];
		$this->data['Timecontrol']['announce'][] =  $this->data['Timecontrol']['shutdown_warning'];
		
		$holidays = $this->Grpholiday->findAll(array('Grpholiday.group_id' => $group_id));
		
		foreach($holidays as $holiday ){
			$name = $holiday['Grpholiday']['name'];
			$this->data[$name] = $holiday['Grpholiday'];
			
			if($this->data[$name]['start'] == '0000-00-00')
				unset($this->data[$name]['start']);
				
			if($this->data[$name]['end'] == '0000-00-00')
				unset($this->data[$name]['end']);
		}
		//debug($this->data);
	}
	
	function update()
	{
		$this->layout="ajax";
		$group_id = $this->data['Timecontrol']['group_id'];
		
		$count = count($this->data['Shutdown']['time']);
		if(isset($this->data['Shutdown']['time']))
		{
			if($count >= 1)
				$this->data['Timecontrol']['shutdown_info'] = $this->data['Shutdown']['time'][0];
			if($count >= 2)
				$this->data['Timecontrol']['shutdown_notice'] = $this->data['Shutdown']['time'][1];
			if($count >= 3)
				$this->data['Timecontrol']['shutdown_warning'] = $this->data['Shutdown']['time'][2];
		}
		
		//debug($this->data['Timecontrol']);
		$count = $this->Timecontrol->findCount('Timecontrol.group_id ='.$group_id);
		if($count > 0){
			$this->Timecontrol->deleteAll(array('group_id ='.$group_id));
		}
		$this->data['Timecontrol']['message'] = $this->Lv->spec_char_dbm($this->data['Timecontrol']['message']);
		$this->Timecontrol->save($this->data['Timecontrol']);
		
		$names = array('summer','newyear','other1','other2','other3','other4','other5');
		foreach($names as $name){
			if(!empty($this->data[$name])){
				$start = $this->genStartDate($this->data[$name]);
				$end = $this->genEndDate($this->data[$name]);
				if(!is_null($start) || is_null($end)){
					$holiday = array(
						'group_id' => $group_id,
						'name' => $name,
						'start' => $start,
						'end' => $end,
					);
					$this->Grpholiday->deleteAll(array('group_id ='.$group_id, 'name = "'.$name.'"'));
					$this->Grpholiday->save($holiday);	
				}
				//debug($holiday);				
			}
		}
		
		$this->GenerateFiles->hook_by_ps(0, array('uptime'), 1);
		
		exit();
	}
	
	function delete()
	{
		$this->layout="ajax";
		$group_id = $this->data['Timecontrol']['group_id'];
		
		$this->Timecontrol->deleteAll(array('group_id ='.$group_id));
		$this->Grpholiday->deleteAll(array('group_id ='.$group_id));
		
		$this->GenerateFiles->hook_by_ps(0, array('uptime'), 1);
		
		exit();
	}
	
	function genStartDate($d)
	{
		if(empty($d['start_year'])
			|| empty($d['start_month'])
			|| empty($d['start_day']))
			return null;
		return $d['start_year']."-".$d['start_month']."-".$d['start_day'];
	}
		
	function genEndDate($d)
	{
		if(empty($d['end_year'])
			|| empty($d['end_month'])
			|| empty($d['end_day']))
			return null;
		return $d['end_year']."-".$d['end_month']."-".$d['end_day'];
	}
}
?>