<?php 
/** 
* 量XML文档生成(非dom) 
* author: q3boy <q3boy@sina.com> 
* version: v0.1 aplha 
* update: 2003/9/8 
* 支持Element/CDATA/Declare/attribute/Comment，可是否包含行和 
*/ 
class xml { 

    /** 元素名 */ 
    var $name; 
    /** 元素 */ 
    var $value; 
    /** 元素型 */ 
    var $type; 
    /** 元素属性 */ 
    var $attrib; 
    /** XML声明 */ 
    var $declare; 
    /** 是否行 */ 
    var $space; 
    
    /** 造函数 */ 
    function xml($name='',$value='') { 
//        echo $name;
        $this->name =$this->set_str_encoding($name); 
        $this->value = $value; 
        $this->declare = array(); 
        $this->setTypes('Element'); 
        $this->setAttrib(array()); 
        $this->setSpace(false); 
    } 
    
    /** 置元素型 */ 
    function setTypes($type) { 
        $this->type = $type; 
    } 
    
    /** 置是否行 */ 
    function setSpace($space) { 
        $this->space = $space; 
    } 
    
    /** 置元素属性 */ 
    function setAttrib($name,$value='') { 
//        echo "";
//        var_dump($this->attrib);
        empty($this->attrib)?$this->attrib=array():$this->attrib=$this->attrib;
        if(is_array($name)) { 
            $this->attrib = array_merge($this->attrib,$name); 
        }else { 
            $this->attrib[$name] = $value; 
        } 
    } 
    
    /** 添加子元素 */ 
    function &addElement($name='',$value='') { 
        $name=$this->set_str_encoding($name); 
        if(!is_array($this->value)) { 
            $this->value = array(); 
        } 
        $xml = new xml($name,$value); 
        $xml->setSpace($this->space); 
        $this->value[] = &$xml; 
        return $this->value[sizeof($this->value)-1]; 
    } 
    
    /** 添加CDATA数据 */ 
    function &addCDATA($name='',$value='') { 
        if(!is_array($this->value)) { 
            $this->value = array(); 
        } 
        $xml = new xml($name,$value); 
        $xml->setSpace($this->space); 
        $xml->setTypes('CDATA'); 
        $this->value[] = &$xml; 
        return $this->value[sizeof($this->value)-1]; 
    } 
    
    /** 添加XML声明 */ 
    function &addDeclare($name='',$value='') { 
        if(!is_array($this->declare)) { 
            $this->value = array(); 
        } 
        $xml = new xml($name,$value); 
        $xml->setSpace($this->space); 
        $xml->setTypes('Declare'); 
        $this->declare[] = &$xml; 
        return $this->declare[sizeof($this->value)-1]; 
    } 
    
    /** 添加注文本 */ 
    function &addComment($content='') { 
        if(!is_array($this->value)) { 
            $this->value = array(); 
        } 
        $xml = new xml($content); 
        $xml->setSpace($this->space); 
        $xml->setTypes('Comment'); 
        $this->value[] = &$xml; 
        return $this->value[sizeof($this->value)-1]; 
    } 
    
    /** 返回xml文本流 */ 
    function toString($itm='',$layer=0) { 
        if(!is_object($itm))$itm = &$this; 
        ///* 行/ */ 
        if($this->space) { 
            $tab = str_repeat(" ",$layer); 
            $tab1 = str_repeat(" ",$layer+1); 
            $br = "\n"; 
        } 
        /* XML声明 */ 
//        echo "<pre>";
//        var_dump($itm->declare);exit;
        for($i=0; $i<count($itm->declare);$i++ ) { 
            $out="<".$itm->declare[$i]->name;

            foreach($itm->declare[$i]->attrib as $key=> $val) { 
//                echo "11111";
                $out .=" $key=\"".$this->encode($val)."\""; 
            } 
            $out.="?>$br"; 
        } 
        /* 文档 */ 
//        echo "@@".$out;exit;
//        echo "<pre>";
//        var_dump($itm->attrib);exit;
        switch($itm->type) { 
            case 'CDATA': 
            case 'Element': 
                empty($out)? $out="":$out;
                
                if(strlen($itm->name)>0)
                {
                    $out .= $tab.'<'.$itm->name; 
                }
                foreach($itm->attrib as $key=> $val) { 
                    $out .=" $key=\"".$this->encode($val)."\""; 
                } 
//                echo "<pre>";
//                var_dump($itm->value);
                if(is_array($itm->value)) { 
                    if(strlen($itm->name)>0)
                    {
                        $out .='>'.$br; 
                    }
                    for($i=0; $i<count($itm->value); $i++ ) { 
                        $out.=$this->toString(&$itm->value[$i],$layer+1); 
                    } 
                    if(strlen($itm->name)>0)
                    {
                        $out .= $tab.'</'.$itm->name.'>'.$br; 
                    }
                }elseif($itm->value!='') { 
                    //$out .='>'.$br.$this->encode($itm->value,$itm->type,$tab1,$br).$br.$tab.'</'.$itm->name.'>'.$br; 
                    $out .='>'.$this->encode($itm->value,$itm->type,$tab1,$br).$br.$tab.'</'.$itm->name.'>'.$br; 
                    
                }else { 
                    $out .=' />'.$br; 
                } 
                break; 
            case 'Comment': 
                $out .= '<!--'.$br.$itm->name.$br.'-->'.$br; 
                break; 
        } 
        return $out; 
    } 
    
    /** 生成xml文件 */ 
    function toFile($file) { 
        $fp = fopen(XML_FOLDER.$file, 'w');
        fwrite($fp,trim($this->toString())); 
        fclose($fp); 
    } 
    
    /** 体引用 */ 
    function encode($content,$type='Element',$tab1='',$br='') { 
//        echo "<pre>";
//        var_dump($content);exit;
        if($type=='Element') { 
            return $tab1.strtr($content,array('>'=>'&lt;','<'=>'&gt;','&'=>'&amp;','"'=>'&quot;',"'"=>'&apos;')); 
        }elseif($type=='CDATA') { 
            return '<![CDATA['.$br.str_replace(']]>',']] >',$content).$br.']]>'; 
        } 
    }
    function set_str_encoding($name)
    {
//        $result= mb_convert_encoding($name,"SJIS","UTF-8"); 
        return $name;
    } 
} 



?>