<?php
/*********************************************************************
*@filename 		grpauth.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2009/02/16   modify for ASP4-030
********************************************************************/
class Grpauth extends AppModel{
	var $name = "Grpauth";
	var $primaryKey = "id";
	var $useTable = "grpauths";

	var $belongsTo = array(
	'Child' =>
	array('className'    => 'Group',
	'conditions'   => '',
	'order'        => '',
	'dependent'    => true,
	'foreignKey'   => 'group_id'
	),
	'Parent' =>
	array('className'    => 'Group',
	'conditions'   => '',
	'order'        => '',
	'dependent'    => true,
	'foreignKey'   => 'org_grp_id'
	)
	);

	/**
	 * Generate List of the parent Groups by One child Group id
	 *
	 * @param int $childId
	 * @return array id => Group.group_name
	 */
	function getParentsByChild($childId)
	{
		$this->unbindModel(array('belongsTo' => array('Child')));
		$groups = $this->findAll("Grpauth.group_id = $childId", 'Parent.id, Parent.group_name', 'Parent.id, Parent.group_name', null, null, 1);
		if(!empty($groups)){
			$keys = Set::extract($groups, '{n}.Parent.id');
			$vals = Set::extract($groups, '{n}.Parent.group_name');
			$groups = array_combine($keys, $vals);
			return $groups;
		}
		else {
			return array();
		}
	}

	/**zhangl start 20080520
	* Generate List of the parent Groups by One child Group id
	*
	* @param int $childId
	* @return array id => Group.group_name
	*/
	function getParentsByChild2($childId)
	{
		$this->unbindModel(array('belongsTo' => array('Child')));
		$groups = $this->findAll(array("Grpauth.group_id = $childId","Parent.id != 1"), 'Parent.group_name',null, null, 1);
		return $groups;
	}
	//zhangl end 20080520

	//zhangs start 20080528
	function getParentsByChild3($childId)
	{
		$this->unbindModel(array('belongsTo' => array('Child')));
		$groups = $this->findAll(array("Grpauth.group_id = $childId","Parent.id != 1"), 'Parent.id',null, null, 1);
		return $groups;
	}
	//zhangs end 20080528
	
	//xinw start 20090216
	//modify for ASP4-030
	function getParentsByChild4($childId)
	{
		$this->unbindModel(array('belongsTo' => array('Child')));
		$groups = $this->findAll(array("Grpauth.group_id = $childId","Parent.id != $childId"), 'Parent.id, Parent.group_name',null, null, 1);
		if(!empty($groups)){
			$keys = Set::extract($groups, '{n}.Parent.id');
			$vals = Set::extract($groups, '{n}.Parent.group_name');
			$groups = array_combine($keys, $vals);
			return $groups;
		}
		else {
			return array();
		}
	}
	//xinw end 20090216
	
	/**
	 *  Generate List of the children Groups by One parent Group id
	 *
	 * @param int $parentId
	 * @return array id => Group.group_name
	 */
	function getChildrenByParent($parentId, $criteria = array())
	{
		$criteria[] = "Grpauth.org_grp_id = $parentId";
		$this->unbindModel(array('belongsTo' => array('Parent')));
		$groups = $this->findAll($criteria, 'Child.id, Child.group_name', 'Child.id, Child.group_name', null, null, 1);
		if(!empty($groups)){
			$keys = Set::extract($groups, '{n}.Child.id');
			$vals = Set::extract($groups, '{n}.Child.group_name');
			$groups = array_combine($keys, $vals);
			return $groups;
		}
		else {
			return array();
		}

	}


	//zhangs start 20080312
	function getChildrenByParent2($parentId, $criteria = array())
	{
		$criteria[] = "Grpauth.org_grp_id = $parentId";
		$criteria[] = "Grpauth.group_id != $parentId";
		$this->unbindModel(array('belongsTo' => array('Parent')));
		$groups = $this->findAll($criteria, 'Child.id, Child.group_name', 'Child.id, Child.group_name', null, null, 1);
		if(!empty($groups)){
			$keys = Set::extract($groups, '{n}.Child.id');
			$vals = Set::extract($groups, '{n}.Child.group_name');
			$groups = array_combine($keys, $vals);
			return $groups;
		}
		else {
			return array();
		}

	}


	function getChildren($parentId, $criteria = array())
	{
		$criteria[] = "Grpauth.org_grp_id = $parentId";
		$this->unbindModel(array('belongsTo' => array('Parent')));
		$groups = $this->findAll($criteria, 'Child.id, Child.group_name', 'Child.id, Child.group_name', null, null, 1);
		if(!empty($groups)){
			return $groups;
		}
		else {
			return array();
		}

	}

	function getChildren2($parentId, $order = null)
	{
		$criteria[] = "Grpauth.org_grp_id = $parentId";
		$this->unbindModel(array('belongsTo' => array('Parent')));
		$groups = $this->findAll($criteria, 'Child.id, Child.group_name', $order, null, null, 1);
		if(!empty($groups)){
			return $groups;
		}
		else {
			return array();
		}

	}
	//zhangs end 20080312


	/**
	 * Delete the Old Relaton for the child group id
	 * Join the Relation of the child group to his parents
	 *
	 * @param int $child
	 * @param array(int) $parents
	 * @return bool
	 */
	function joinChild2Parents($child, $parents)
	{
		$parents = array_keys($parents);
		$parents[] = $child;		//自身を追加

		//古いデータをデリート





		$toDel = $this->findAll("Grpauth.group_id = " . $child);
		if(!empty($toDel)){
			$toDel = Set::extract($toDel, '{n}.Grpauth.id');
			foreach($toDel as $v){
				$this->del($v);
			}
		}

		foreach($parents as $v){
			$data['Grpauth']['group_id'] = $child;
			$data['Grpauth']['org_grp_id'] = $v;
			if(!$this->save($data['Grpauth'])){
				return false;
			}
		}

		//下位グループあり、変更対応





		$belowChildren = Group :: query("SELECT id FROM groups WHERE parent_id = " . $child );
		$toChan = Set::extract($belowChildren, '{n}.0.id');		//下位childrenだけ






		$parents = array_flip($parents);
		foreach($toChan as $v){
			if(!$this->joinChild2Parents($v, $parents)){
				return false;
			}
		}

		return true;
	}

	/**
	 * グループでアラートルールをデリート





	 *
	 * @param unknown_type $groupId
	 * @param unknown_type $controller
	 * @param unknown_type $alertsModel
	 * @return bool
	 */
	function deleteAlertByParentId($groupId, & $controller, $alertsModel)
	{
		if(empty($groupId) || empty($alertsModel)){
			//$groupId and $alertModel can't be empty
			return false;
		}
		if(is_array($alertsModel)){
			foreach($alertsModel as $v){
				$controller->uses[] = $v;
				$controller->constructClasses();
				strpos(strtoupper($v), "GRP") === false ? null : $controller->$v->deleteAllByGroupId($groupId);
				strpos(strtoupper($v), "HST") === false ? null : $controller->$v->deleteHstaltByGroupId($groupId);
			}
		}
		else {
			strpos(strtoupper($alertsModel), "GRP") === false ? null : $controller->$alertsModel->deleteAllByGroupId($groupId);
			strpos(strtoupper($alertsModel), "HST") === false ? null : $controller->$alertsModel->deleteHstaltByGroupId($groupId);
		}
		return true;
	}

	function setInheritByGroupId($groupId, & $controller, $rltalertsModel)
	{
		$children = $this->findAll(array("Grpauth.org_grp_id = " . $groupId));
		$children = Set :: extract($children, "{n}.Grpauth.group_id");
		$parent = $controller->Group->find("Group.id = " . $groupId, "Group.parent_id", null, 0);
		$parentId = $parent['Group']['parent_id'];
		foreach($rltalertsModel as $v){
			$controller->uses[] = $v;
			$controller->constructClasses();
			$controller->$v->inheritAlertByParentId($parentId,$children);
		}
	}
}
?>